	program getdab2
c
c a routine to produce line by line delta abundances.  The lists must be
c sorted by wavelength
c
	common//line8
	character*80 line8(5000)

        character*80 stdfile,pgmfile,outfile,line,line7
	real*8 w7,ab7,ep7,w8(5000),ab8(5000),ep8(5000),dlam
	real*8 abmin,dwmin,depmin,delta_ab

c open files

	write(6,*)'Enter filename with standard line abundances'
	read(5,'(a80)')stdfile
	open(unit=7,file=stdfile,status='old')

	write(6,*)'Enter filename with program line abundances'
	read(5,'(a80)')pgmfile
	open(unit=8,file=pgmfile,status='old')

	write(6,*)'Enter output filename'
	read(5,'(a80)')outfile
        open(10,file=outfile)

c read headers

	do i = 1,6
	   read(7,'(a80)')line
           if (line(:10).eq.'wavelength') goto 90
	enddo
 90	continue

	do i = 1,6
	   read(8,'(a80)')line
           write(10,'(a)')line
           if (line(:10).eq.'wavelength') then
              write(line(51:60),'(a10)')'  Delta_ab'
              write(10,'(a)')line
              goto 91
	   endif
	enddo
 91	continue

c now read lines in the program file

	do i8 = 1,1000000
	   read(8,'(a80)',end=180)line8(i8)
           read(line8(i8),'(2f10.3,30x,f10.2)')w8(i8),ep8(i8),ab8(i8)
	enddo
 180    continue
        n8 = i8-1

c main loop


	dlam = 0.05
        
	do i = 1,100000
           
	   read(7,'(a80)',end=900)line7
	   read(line7,'(2f10.3,30x,f10.2)')w7,ep7,ab7

           dwmin = 100.
           depmin = 100.

           do j = 1,n8

              if (dabs(w7-w8(j)) .le. dlam) then
c *** DEBUG
	if (dabs(w7-6843.655).lt.1.0) then
           write(6,*)'New entry abmin = ',abmin
           write(6,*)line8(j)
	endif
c
                 if (dabs(ep7-ep8(j)) .lt. depmin) then

                     dwmin = dabs(w7-w8(j))
                     depmin = dabs(ep7-ep8(j))
c *** DEBUG
	if (dabs(w7-6843.655).lt.1.0) then
            write(6,*)'J =  ',j
	    write(6,*)'ep7,ep8(j),dwmin,depmin'
	    write(6,*)ep7,ep8(j),dwmin,depmin
	endif
c
	             call getab(j,abmin)
                     delta_ab = ab7-abmin
c *** DEBUG
	if (dabs(w7-6843.655).lt.1.0) then
           write(6,*)'abmin = ',abmin
           write(6,*)line8(j)
	endif
c
                     iline = j
                 endif
	      elseif (w8(j)-w7 .gt. dlam) then
                 if (dwmin.ge.100.) then
	            write(6,*)'No abundance for line at ',w7
                 else
                    write(line8(iline)(51:60),'(f10.2)')abmin
                    write(line8(iline)(63:72),'(f10.2)')delta_ab
                    write(10,'(a80)')line8(iline)
                 endif
                 exit
	      endif
	   enddo
	enddo

 900	continue
	stop
	end



	subroutine getab(n,ab)

	common//line8
	character*80 line8(5000)

	integer n
	real*8 ab,ab1,ew,ew1

	read(line8(n)(31:60),'(f10.1,10x,f10.2)')ew,ab

        if (n.lt.21) then
          nstart = 1
	else
          nstart = n - 20
	endif

	if (ab.gt.999.0) then
	   do i = n+1,5000
              read(line8(i)(31:60),'(f10.1,10x,f10.2)')ew1,ab1
              if (ew1.eq.ew .and. ab1.lt.999.0) then
	         ab = ab1
	         return
              elseif (ew1.ne.ew) then
                 do j = i,1,-1
                    read(line8(j)(31:60),'(f10.1,10x,f10.2)')ew1,ab1
                    if (ew1.eq.ew .and. ab1.lt.999.0) then
	               ab = ab1
	               return
                    endif
	         enddo
                 exit
	      endif
	   enddo


	   ab = 999.99
	endif
	return
	end
	   
