
      subroutine chabund
c*****************************************************************************
c  this routine changes the input abundances according to the users request
c  and the re-runs the synthesis with the new abundances OVERWRITING the 
c  original output files, but using the same model, linelist, etc
c*****************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      integer newpec(100),newnumpecatom,newnumatomsyn,
     .     newnumiso,newnumisosyn
      real*8 newpecabund(100,5), newisoabund(20,5), newisotope(20)
      real*8 xnum
      character choice,choice2


c*****set the local temporary parameters to what they were for the last synth
      newnumiso = numiso
      newnumisosyn = numisosyn
      newnumpecatom = numpecatom
      newnumatomsyn = numatomsyn
      if (newnumatomsyn .eq. 0) newnumatomsyn = 1
      do i=1,100
         newpec(i) = pec(i)
         do j=1,newnumatomsyn
            newpecabund(i,j) = pecabund(i,j)
         enddo
      enddo
      do i=1,newnumiso
         if(newnumiso .ge. 1) then
            newisotope(i)=isotope(i)
            do j=1,newnumisosyn
               newisoabund(i,j)=isoabund(i,j)
            enddo
         endif
      enddo



c*****find out if the "synth" driver is being used
      if (newnumatomsyn .le. 0) newnumatomsyn = 1
      if (control .eq. 'synth') then


c*****for "synth", present the user with the current abundance alterations, 
c     and the options; find out what is desired
1        istat = ivcleof(5,1)
         array = 'Here are the Alterations to the Abundances'
         istat = ivwrite(5,5,array,50)
         array = 'Atom   Abundance (relative to initial model)'
         istat = ivwrite(6,1,array,50)
         line = 6
         do i=1,100
            if(newpec(i) .eq. 1) then
               line = line + 1
               write (array,1001) i,(newpecabund(i,j),j=1,newnumatomsyn)
1001           format (i3,4x,5(f5.2,2x))
               istat = ivwrite(line,1,array,50)
            endif
         enddo
         array = 'Options: c = change abundances  l = list '
         istat = ivwrite(line+1,1,array,50)
         array = '         i = change isotopic ratios'
         istat = ivwrite(line+2,1,array,50)
         array = '         n = change number of synthesis'
         istat = ivwrite(line+3,1,array,50)
         array = '         x = exit no changes    q = rerun synth'
         istat = ivwrite(line+4,1,array,50)
         array = 'What is your choice? '
         nchars = 21
         call getasci (nchars,line+5)
         choice = chinfo(1:1)

         
c*****for "synth", change an abundance
         if (choice .eq. 'c') then
20          istat = ivcleof(line+1,1)
            array = 'Which element to change? '
            nchars = 25
            call getasci (nchars,line+1)
            call number (nchars,line+1,xnum)
            if (xnum.eq.-9999.0 .or. xnum.ge.100.) go to 20
            j = int(xnum)
            if (newpec(j) .eq. 1) then
25             array = 'n = new abundances, or z = zero offsets? '
               nchars = 41
               call getasci (nchars,line+2)
               choice = chinfo(1:1)
               if (choice .eq. 'z') then 
                  newpec(j) = 0
                  do i=1,5
                     newpecabund(j,i) = 0.0
                  enddo
                  newnumpecatom = newnumpecatom - 1
               elseif (choice .eq. 'n') then
                  array = 'Enter the new offsets on the line below:'
                  istat = ivwrite(line+3,1,array,50)
                  read (*,*) (newpecabund(j,i),i=1,newnumatomsyn)
               else
                  go to 25
               endif
            else
               newpec(j) = 1
               array = 'Enter the new offsets on the line below'
               istat = ivwrite(line+2,1,array,50)
               read (*,*) (newpecabund(j,i),i=1,newnumatomsyn) 
               newnumpecatom = newnumpecatom + 1
            endif


c*****for "synth", change an isotopic ratio
         else if (choice .eq. 'i') then
2           istat = ivcleof(5,1)
            array = 'The Current Isotope Ratios'
            istat = ivwrite(5,5,array,50)
            array = 'Number  Isotope  Ratio'
            istat = ivwrite(6,2,array,50)
            line = 6
            do i=1,newnumiso
               line = line + 1
               write(array,1002) i,newisotope(i),newisoabund(i,1)
1002           format(i2,2x,f8.4,2x,f5.2)
               istat = ivwrite(line,1,array,50)
            enddo
            array = 'Options: c = change one of these ratios'
            istat = ivwrite(line+1,1,array,50)
            array = '         n = enter new isotope'
            istat = ivwrite(line+2,1,array,50)
            array = '         q = accept these changes'
            istat = ivwrite(line+3,1,array,50)
30          array = 'What is your choice? '
            nchars = 21
            call getasci (nchars,14)
            choice2 = chinfo(1:1)
            if (choice2 .eq. 'c') then
35             array =  'Which number from the list? '
               nchars = 28
               call getasci (nchars,line+1)
               call number (nchars,line+1,xnum)
               if (xnum.eq.-9999.0 .or. 
     .             xnum.gt.dble(newnumiso)) go to 35
               i = int(xnum)
40             array = 'What is the new ratio? '
               nchars = 23
               call getasci (nchars,line+2)
               call number (nchars,line+2,xnum)
               if (xnum.eq.-9999.) go to 40
               newisoabund(i,1) = xnum
            elseif (choice2 .eq. 'n') then
45             array = 'What isotope? '
               nchars = 14
               call getasci (nchars,line+1)
               call number (nchars,line+1,xnum)
               if (xnum.eq.-9999.0 .or. xnum.lt.100.) go to 45
               newisotope(newnumiso+1) = xnum
50             array = 'What is the ratio? '
               nchars = 29
               call getasci (nchars,line+2)
               call number (nchars,line+2,xnum)
               if (xnum.eq.-9999.) go to 50
               newisoabund(i,1) = xnum
               newnumiso = newnumiso + 1
            elseif  (choice2 .eq. 'q') then
               go to 1
            else
               go to 2
            endif
            

c*****for "synth", change the number of syntheses
         else if (choice .eq. 'n') then
55          array = 'How many synths? '
            nchars = 17
            call getasci (nchars,line+5)
            call number (nchars,line+5,xnum)
            if (xnum.eq.-9999.0 .or. xnum.gt.5.) go to 55
            newnumatomsyn = int(xnum)


c*****for "synth", exit the routine without changing anything
         else if (choice .eq. 'x') then
            return


c*****for "synth", make the proposed alterations permanent; then
c     rerun the syntheses, then exit back to the plotting routine
         else if (choice .eq. 'q') then
            numiso = newnumiso
            numisosyn = newnumisosyn
            numpecatom = newnumpecatom
            numatomsyn = newnumatomsyn
            do i=1,99
               pec(i) = newpec(i)
               do j=1,numatomsyn
                  pecabund(i,j) = newpecabund(i,j)
               enddo
            enddo
            do i=1,numiso
               if(numiso .ge. 1) then
                  isotope(i) = newisotope(i)
                  do j=1,numisosyn
                     isoabund(i,j)=newisoabund(i,j)
                  enddo
               endif
            enddo
            call resynth
            return
         else
            go to 1
         endif


c*****for "synth", the main menu will keep reappearing until "q" or "x" is hit
         go to 1
         
         
c*****for "isotope", simply list the current isotopic ratios and return to the
c     plotting routine
      else if (control .eq. 'isotope') then
         istat = ivcleof(5,1)
         array = 'Here are the Current Isotopic Ratios'
         istat = ivwrite(5,5,array,35)
         array = 'Number    Isotope      Ratio (parent/isotope)'
         istat = ivwrite(6,1,array,39)
         line = 7
         do i=1,newnumiso
               line = line + 1
               write (array,1003) i,newisotope(i),(newisoabund(i,j),
     .                            j=1,newnumisosyn)
1003           format(i2,8x,f8.4,5(3x,f3.2))
               istat = ivwrite(line,1,array,50)
         enddo
         
        
c*****inform the user that no other driver is handled here 
      else 
         array = 'This feature disabled under this driver'      
         nchars = 39
         istat = ivwrite(23,3,array,nchars)
      endif

      
c*****ext from the routine
      return
      end

