      subroutine ewfind
c******************************************************************************
c     This routine predicts equivalent widths for individual atomic lines
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'

c*****read the parameter file
      call params

c*****set up the output file
      nwrite = 20     
c     array = 'Give the filename for standard output: '
c     nchars = 39
c     call infile ('output ',nwrite,'formatted  ',0,nchars,4)

c AMcW 12/Aug/2003
      open(unit=nwrite,file='logfile')

      ndump = 21     
c     array = 'Give the filename for equivalent width summaries: '
c     nchars = 50
c     call infile ('output ',ndump,'formatted  ',0,nchars,6)

c AMcW 12/Aug/2003
      open(unit=ndump,file='OUTPUT')

c*****set up the model atmosphere                                        
      filemodel = 30
c     array = 'Give the filename for the model atmosphere: '
c     nchars = 44
c     call infile ('input  ',filemodel,'formatted  ',0,nchars,8)

c AMcW 12/Aug/2003
      open(unit=filemodel,file='MODEL',status='old')

      call inmodel
      call eqlib

c*****read line data
      filelines = 31
c     array = 'Give the filename for the line list: '
c     nchars = 37
c     call infile ('input  ',filelines,'formatted  ',0,nchars,10)

c AMcW 12/Aug/2003
      open(unit=filelines,file='INPUT',status='old')

      call inlines (1)
      call eqlib
      call nearly
 
c*****set some parameters
      ipr(5) = +1
      mode = 1

c*****run single line computations once to predict the EW for each line
      call linlimit
      do lim1=lim1line,lim2line
         ncurve = lim1
         lim2 = lim1
         gf1(ncurve) = gf(lim1)
         call oneline (1)
         widout(lim1) = w(ncurve)
      enddo

c*****output a summary
      lim1obs = lim1line
      lim2obs = lim2line
      istat = ivcleof (4,1)
      call out (28)
c     array = 'PROGRAM WILL TERMINATE WITH ANY KEYSTROKE'
c     nchars = 41
c     line = nlines + 8
c     call getasci (nchars,line)
         
c*****end the abundance computations
50    call finish
      return
      end

