      subroutine inlines (num)
c******************************************************************************
c     This subroutine reads in the line data
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Dummy.com'
      include 'Quants.com'
      include 'Factor.com'
      real*8 d0(500)
c
c removed by AMcW 8/2003 -- firsttime is now in Atmos.com and set in begin
c     logical firsttime
c     data firsttime /.true./

c*****get the partition functions; only needs to be done on the first call
      if (firsttime .eqv. .true.) then
         do j=1,95
            elem(j) = dble(j)
            dummy=partfn (elem(j),j)
         enddo
         firsttime = .false.
      endif

      if (num .eq. 2) go to 4

c*****decide if certain element abundances need to be modified.
      if (numpecatom .gt. 0) then
         do iatom=3,95
            xabund(iatom) = 10.**pecabund(iatom,isynth)*
     .                      10.**pecabund(99,isynth)*xabu(iatom)
         enddo
      endif
      call out (20)

c*****read in the strong lines with another routine; prepare to read lines here
      call slines
      rewind filelines
      wave = start                                                       
      n1 = 0                                                             
      nlines = 500                                                        
      read (filelines,1001) obsitle
1001  format (a80)
302   n1 = n1 + 1                                                        

c*****read the line list
      i = n1
c
c Changed read to get lineids and changed format to take old moog lists
c AMcW 1/2000
c
333   read (filelines,301,end=311) lineid(i),wave1(i),atom1(i),e(i,1),
     .                             c6(i),gf(i),d0(i),width(i)
301   format (a5,6e10.3,5x,f10.3)
c
      if (width(i) .lt. 0.) go to 333
      i = i + 1
      if (i .le. 500) go to 333
311   nlines = i - 1

c*****here groups of lines for blended features are defined
310   do i=1,nlines
         if (wave1(i) .lt. 0.) then
            group(i) = 1
            wave1(i) = dabs(wave1(i))
            width(i) = width(i-1)
         else
            group(i) = 0
         endif
      enddo     

c*****here log(gf) values are turned into gf values, if needed
c*** changed to always accept log gf values  AMcW July 2004
      do i=1,nlines
         gf(i) = 10.**gf(i)
      enddo         

c*****turn log(RW) values and EW values in mA into EW values in A.  Stuff
c     duplicate EW values of the first line of a blend into all blend members.
379   do i=1,nlines
         if (width(i) .lt. 0.) then
            width(i) = 10.**width(i)*wave1(i)
         else
            width(i) = width(i)/1000.
         endif
       enddo

c*****calculate some parameters of the lines; for atomic lines the
c     van der Waals damping has different options
      do i=1,nlines
         iatom = atom1(i)                                                   
         charge(i) = 1.0 + 10.0*(atom1(i) - iatom)                          
         e(i,2) =  e(i,1) + 1.239d+4/wave1(i)                               
         if (iatom .ge. 100) then
            call sunder(atom1(i),ia,ib)                                        
            if (atom1(i)-int(atom1(i)) .le. 0.0) then
               amass(i) = xam(ia) + xam(ib)    
               mas1=xam(ia)
               mas2=xam(ib)
            else 
               mas1 = int(100*(atom1(i)-int(atom1(i))))
               mas2 = int(10000*(atom1(i)-int(atom1(i)))) - mas1 * 100
               amass(i) = mas1 + mas2
            endif
            chi(i,1) = d0(i)
            chi(i,2) = mas1*mas2/amass(i)                                
            chi(i,3) = 0.
            c6(i) = 1.0d-31                                                    
         else
            amass(i) = xam(iatom)                       
            chi(i,1) = xchi1(iatom)                                            
            chi(i,2) = xchi2(iatom)                                            
            chi(i,3) = xchi3(iatom)                                            
 
c*****do the damping, beginning with the Unsold approximation
            ich = idint(charge(i) + 0.1)      
            unsold = dabs(1.61d-33*(13.5*charge(i)/(chi(i,ich) -
     .               e(i,1)))**2 - 1.61d-33*(13.5*charge(i)/
     .               (chi(i,ich)-e(i,2)))**2)               
            if (ipr(8) .eq. 0) then
               if (c6(i) .eq. 0.0) then
                  c6(i) = unsold
               elseif (c6(i) .gt. 1.0d-10) then
                  c6(i) = unsold*c6(i)
               endif
            elseif (ipr(8) .eq. 1) then
               c6(i) = 6.3*unsold
            elseif (ipr(8) .eq. 2) then
               c6(i) = (1.0 + 0.67*e(i,1))*unsold
            endif
         endif
      enddo

c*****quit the routine normally
      if (nlines .lt. 500) then
         if (stop .gt. wave1(nlines)+10.) stop = wave1(nlines)+10.
      endif
      lim1line = 1
      return  

c****get another chunk of line data                                        
4     n1 = 0                                                             
      do j=lim1line,nlines                                               
         n1 = n1 + 1                                                        
         wave1(n1) = wave1(j)                                               
         atom1(n1) = atom1(j)                                               
         amass(n1) = amass(j)                                               
         charge(n1) = charge(j)                                             
         d0(n1) = d0(j)
         gf(n1) = gf(j)                                                     
         do jj=1,3                                                      
            chi(n1,jj) = chi(j,jj)                                             
            e(n1,jj) = e(j,jj)                                                 
         enddo                                                           
      enddo    
      start = wave                                                       
      go to 302                                                          
      

      end                                                                



