      subroutine linplot (choice)
c******************************************************************************
c     This routine produces MONGO plots of line abundances versus
c     excitation potentials and equivalent widths
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Dummy.com'
c     real*4 ep(1000),abb(1000),logrw(1000)
c     equivalence (ep,dummy3(1)),(abb,dummy3(1001)),(logrw,dummy3(2001))
c     real*4 style(1),ymed
      character ion*4,choice
      real*8 ep(1000),abb(1000),logrw(1000)
      equivalence (ep,dummy3(1)),(abb,dummy3(1001)),(logrw,dummy3(2001))
      real*8 style(1),ymed


c*****dump the data into working arrays
      j = 0
      do l=lim1obs,lim2obs
         if (abunout(l) .ne. 999.99) then
            j = j + 1
            ep(j) = e(l,1)
            abb(j) = abunout(l)
            logrw(j) = dlog10(width(l)/wave1(l))
         endif
      enddo


c*****find the plot boundaries for the excitation potential plot
      xlo = 20.
      do j=1,kount
         xlo = dmin1(xlo,ep(j))
      enddo
      xhi =  0.
      do j=1,kount
         xhi = dmax1(xhi,ep(j))
      enddo
      if (xhi-xlo .lt. 5.) then
         xlo = dmax1((xlo+xhi)/2.-2.5,-0.2d0)
         xhi = xlo + 5.0
      else
         xlo = dmax1((xlo+xhi)/2.-5.0,-0.2d0)
         xhi = xlo + 10.
      endif
      ylo = 20.
      do j=1,kount
         ylo = dmin1(ylo,abb(j))
      enddo
      yhi = -20.
      do j=1,kount
         yhi = dmax1(yhi,abb(j))
      enddo
      if (yhi-ylo .lt. 0.5) then
         ylo = (ylo+yhi)/2. - 0.30
         yhi = ylo + 0.60
      elseif (yhi-ylo .lt. 1.0) then
         ylo = (ylo+yhi)/2. - 0.55
         yhi = ylo + 1.10
      else
         ylo = (ylo+yhi)/2. - 1.10
         yhi = ylo + 2.20
      endif


c*****start the excitation potential plot via plot setup calls
      call sm_window (1,2,1,2,1,2) 
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the excitation potential plot
      call sm_expand (1.2d0)
      call sm_lweight (1.8d0)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_box (1,2,0,0)
      array = 'Excitation Potential'
      call sm_xlabel (array)
      array = 'Abundance'
      call sm_ylabel (array)
      call sm_lweight (1.4d0)
      

c*****make the excitation potential plot
      call sm_ctype ('red')
      call sm_expand (1.6d0)
      style(1) = 43.0d0
      call sm_expand (1.2d0)
      call sm_ptype (style,1) 
      call sm_points (ep,abb,kount)
      call sm_ctype ('yellow')
      call sm_ltype (3)
      ymed = average
      call sm_relocate (xlo,ymed)
      call sm_draw (xhi,ymed)
      if (kount .gt. 2 .and. deltaep .gt. 1.5) then
         call sm_ctype ('blue')
         call sm_relocate (xlo,dble(xxm1*xlo+xxb1)) 
         call sm_draw (xhi,dble(xxm1*xhi+xxb1)) 
      endif
      call sm_ltype (1)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_relocate (xlo+0.05d0*(xhi-xlo),ylo+0.15d0*(yhi-ylo))
      call sm_expand (1.0d0)
      call sm_label (obsitle)
      ich = idint(charge(lim1obs) + 0.1)
      if (ich .eq. 1) then 
         ion = ' I  '
      elseif (ich .eq. 2) then
         ion = ' II '
      elseif (ich .eq. 3) then
         ion = ' III'
      endif
      iatom = idint(atom1(lim1obs))
      write (array,1002) names(iatom),ion
1002  format (a2,a4)
      call sm_relocate ((xhi+xlo)/2.d0,yhi-0.15d0*(yhi-ylo))
      call sm_expand (1.2d0)
      call sm_label (array)
   

c*****define the plot limits for the equivalent width plot
      xlo = 5000.
      do j=1,kount
         xlo = dmin1(xlo,logrw(j))
      enddo
      xhi =  -5000.
      do j=1,kount
         xhi = dmax1(xhi,logrw(j))
      enddo
      xlo = int((xlo-0.01)*2.-1.)/2.
      xhi = int((xhi+0.01)*2.)/2.
      call sm_window (1,2,1,1,1,1) 
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)

c*****draw and label the box for the equivalent width plot
      call sm_expand (1.2d0)
      call sm_lweight (1.8d0)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_box (1,2,0,0)
      array = 'Equivalent Width'
      call sm_xlabel (array)
      array = 'Abundance'
      call sm_ylabel (array)
      call sm_lweight (1.4d0)

c*****make the equivalent width plot
      call sm_ctype ('green')
      call sm_expand (1.6d0)
      style(1) = 43.0d0
      call sm_expand (1.2d0)
      call sm_ptype (style,1)
      call sm_points (logrw,abb,kount)
      call sm_ctype ('yellow')
      call sm_ltype (3)
      call sm_relocate (xlo,ymed)
      call sm_draw (xhi,ymed)
      if (kount .gt. 2 .and. deltarw .gt. 0.5) then
         call sm_ctype ('blue')
         call sm_relocate (xlo,dble(xxm2*xlo+xxb2)) 
         call sm_draw (xhi,dble(xxm2*xhi+xxb2)) 
      endif
      call sm_ltype (1)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_relocate (xlo+0.05d0*(xhi-xlo),yhi-0.15d0*(yhi-ylo))
      call sm_expand (1.0d0)
      call sm_label (moditle)
   
      return
      end








