
      subroutine opacit(modeop,waveop)                                       

c******************************************************************************
c     This routine calculates the continuous opacity *kaplam* or            
c     *kapref* and optical depth *taulam* as needed. the formulas are       
c     ones lifted from the write-up of program *atlas*                      
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'
      real*8 a1(8),b1(8),c1(8),an(8)
      real*8 taucheck(75), tauinteg(75)

c  initialization                                                        
      data a1/ 0.9916, 1.105, 1.101, 1.101, 1.102, 1.0986, 1.0, 1.0/            
      data b1/  2.719d13, -2.375d14, -9.863d13, -5.765d13, -3.909d13,
     .         -2.704d13,       0.0,       0.0/
      data c1/ -2.268d30,  4.077d28,  1.035d28,  4.593d27,  2.371d27,       
     .          1.229d27,       0.0,       0.0/

      if (ipr(1) .gt. 1) write (nwrite,1002) waveop                          
1002  format(/'log continuous opacity factors at wavelength =',f10.2//   
     .       '   ahbf ahmibf ahmiff  ah2op  ahray aheray ahemin    ael',
     .       '  kappa     nh    nhe'/)    

      freq = 2.997925d18/waveop 

c*****here is the big loop to calculate all opacities
      do 100 i=1,ntau                                                    
      tkev = 1.38054d-16*t(i)/1.602d-12                                  
      factor = 1.0 - dexp(-4.799d-11*freq/t(i))
      chplus = 4.82714d15*t(i)**1.5*dexp(-13.595/tkev)/u(1,1,i)
      chmin = 2.0716d-16*t(i)**(-1.5)*dexp(0.754/tkev)/u(1,1,i)
 
c*****hydrogen bound-free opacity                                               
      ahbf = 0.0                                                         
      do n=1,8                                                        
         if (freq .lt. 3.28805d15/n**2) then
            an(n) = 0.0                                                        
         else
            rn = n*1.0
            fix1 = 2.815d29/n**5/freq/freq/freq
            an(n) = fix1*(a1(n)+(b1(n)+c1(n)/freq)/freq)                  
         endif
         ahbf= ahbf + 2.0*n*n*an(n)*factor*
     .         dexp(13.595*(1.0/n**2-1.0)/tkev)     
      enddo
      ex = dexp(-13.427/tkev)                                             
      if (freq .lt. 4.05933d13) ex = ex/dexp(-4.799d-11*freq/t(i))   
      fix4 = 2.815d29*factor/freq/freq/freq
      ahbf = (ahbf + fix4*tkev/13.595*
     .       (ex - dexp(-13.595/tkev)))/u(1,1,i)

c*****h-minus free-free opacity                                             
      ahmiff = ne(i)*(1.3727d-25+(4.3748d-10-2.5993d-7/t(i))/freq)/freq  

c*****h-minus bound-free opacity    
      if (freq .ge. 2.111d14) then
         fora2 = -5.519d27 + (4.808d21/freq)*1.0d20    
         a2 = 6.801d-20 + (5.358d-3 + (1.481d13 + 
     .        fora2/freq)/freq)/freq        
      elseif (freq .ge. 1.8259d14) then
        a2 = 3.695d-16 + (-1.251d-1 + 1.052d13/freq)/freq                  
      else
        a2 = 0.
      endif
      ahmibf = chmin*ne(i)*a2*factor       

c*****hydrogen rayleigh scattering                                             
      wave2 = 2.997925d18/dmin1(freq,2.922d15)                           
      ahray = (5.799d-13 + 1.422d-6/wave2**2 + 2.784/wave2**4)/
     .        wave2**4   

c*****h2-plus molecular bound-free and free-free opacity                        
      fx1 = (-4.230d-26*freq**2)/1.0d20*(freq)
      fx2 = (1.224d-21*freq**2)/1.0d20*(freq**2/1.0d20) 
      fx3 = (-1.351d-27*freq**2)/1.0d20*(freq**2/1.0d20)*
     .      (freq/1.0d10)
      es = -7.342d-3 - 2.409d-15*freq + 1.028d-30*freq**2 + 
     .      fx1 + fx2 + fx3  
      fr1 = dlog(freq)                                                   
      fnut = (-es/tkev - 3.0233d3 + (3.7797d2 + (-1.82496d1 +
     .       (3.9207d-1 - 3.1672d-3*fr1)*fr1)*fr1)*fr1)           
      fx4 = dlog(chplus*nhneutral(i)/ne(i)*factor)
      ah2op = dexp(fx4 + fnut)

c*****helium rayleigh scattering                                                
      wave3 = 2.997925d18/dmin1(freq,5.15d15)                            
      aheray = 5.484d-14*(1.0+2.44d5/wave3**2+5.94d-10/                  
     .         (wave3**2*(wave3**2-2.90d5)))**2/wave3**4                        

c*****he-minus free-free opacity                                            
      ax = 3.397d-26 + (-5.216d-11 + 7.039d+05/freq)/freq                 
      bx = -4.116d-22 + (1.067d-06 + 8.135d+09/freq)/freq                 
      cx = 5.081d-17 + (-8.724d-03 - 5.659d+12/freq)/freq                  
      ahemin = ne(i)*(ax*t(i) + bx + cx/t(i))/10.0**20

c*****electron scattering
      ael = 0.6653d-24*ne(i)

c*****now sum up all the opacity contribution
      kaplam(i) = nhneutral(i)*(ahbf+ahmibf+ahmiff+ah2op+ahray) + 
     .            nheneutral(i)*(aheray+ahemin) + ael

c*****add in an arbitrary amount of "extra" continuous opacity;
c     this fudge added at Verne Smith's request, so blame him!
      if (fudge .gt. 0.0) then 
         kaplam(i) = kaplam(i)*((fudge*10000)/t(i))
         if (i .eq. 1) then
            write(nwrite,*) 'Opacity scaled by scaling',
     .           ' law of: '   
            write(nwrite,*) '      kaplam(i) = kaplam(i) * '
     .           ,'((',fudge,' * 10000)/t(i))'
         endif

      endif

c*****write out the opacity contributions, and end the main loop
      if (ipr(1) .gt. 1) write(nwrite,1001) dlog10(ahbf),
     .                   dlog10(ahmibf),dlog10(ahmiff),dlog10(ah2op),
     .                   dlog10(ahray),dlog10(aheray),dlog10(ahemin),
     .                   dlog10(ael),dlog10(kaplam(i)),
     .                   dlog10(nhneutral(i)),dlog10(nheneutral(i))            
1001  format(11f7.2)
100   continue                                                           

c*****compute an optical depth array at this wavelength, and exit
      if (modeop .ne. 1) then
         do  i=1,ntau                                                    
            dummy1(i) = tauref(i)*kaplam(i)/(0.4343*kapref(i))
         enddo
         first = tauref(1)*kaplam(1)/kapref(1)                          
         dummy1(1) = rinteg(xref,dummy1,taulam,ntau,first)  
         taulam(1) = first
         do i=2,ntau                                                    
            taulam(i) = taulam(i-1) + taulam(i) 
         enddo
         if (ipr(1) .gt. 1) write(nwrite,1003) (taulam(i),i=1,ntau)          
1003     format(/'TAULAM ARRAY'/(1p7e12.5))
         return
      endif

c*****here is the assignment of opacities kaplam to kapref
      do i=1,ntau   
         kapref(i) = kaplam(i)                                              
      enddo
      if(ipr(1) .lt. 2) return                                           

c*****here is an internal tauref check on the externally read in tau scale
      do i=1,ntau                                                    
         tauinteg(i) = tauref(i)*kaplam(i)/(0.4343*kapref(i))
      enddo
      first = tauref(1)                                              
      tauinteg(1) = rinteg(xref,tauinteg,dummy2,ntau,start)  
      taucheck(1) = first
      do i=2,ntau                                                    
         taucheck(i) = taucheck(i-1) + taucheck(i) 
      enddo
      write(nwrite,1003) (taucheck(i),i=1,ntau)                            
      return                                                             

      end                                                                




