      subroutine slines
c******************************************************************************
c     This takes the big lines and makes all the calculations made in
c     inlines so they can be used in taukap 
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Dummy.com'
      include 'Quants.com'
      include 'Strong.com'
      include 'Factor.com'


      if (nstrong .le. 0 ) return

c*****read in up to 20 "strong" lines whose opacities will be considered
c     at all wavelengths of a synthesis
      nstrong = 0
      rewind fileslines
      do j=1,20
c
c changed read to take line id, and changed format to take old moog lists
c AMcW 1/2000
c
         read (fileslines,271,end=377) slineid(j),swave1(j),satom1(j),
     .                          se(j,1),sc6(j),sgf(j),sd0(j),swidth(j)
         nstrong = nstrong + 1
271      format(a5,6e10.3,5x,f10.3)
c
      enddo
      write(*,*) 'Can only use the first 20 strong lines'

c*****here log(gf) values are turned into gf values, if needed
377   do i=1,nstrong
         if (sgf(i) .lt. 0) then
            do j=1,nstrong
               sgf(j) = 10.**sgf(j)
            enddo
            go to 379
         endif
      enddo

c*****turn log(RW) values and EW values in mA into EW values in A.  Stuff
c     duplicate EW values of the first line of a blend into all blend members.
379   do i=1,nstrong
         if (swidth(i) .lt. 0.) then
            swidth(i) = 10.**swidth(i)*swave1(i)
         else
            swidth(i) = swidth(i)/1000.
         endif
      enddo

c*****calculate some parameters of the lines; for atomic lines the
c     van der Waals damping has different options
      do i=1,nstrong
         iatom = satom1(i)                                                   
         scharge(i) = 1.0 + 10.0*(satom1(i) - iatom)                          
         se(i,2) =  se(i,1) + 1.239d+4/swave1(i)                               
         if(iatom .ge. 100) then
            call sunder(satom1(i),ia,ib)                                        
            if ( satom1(i)-int(satom1(i)) .le. 0.0 ) then
               samass(i) = xam(ia) + xam(ib)                                   
               mas1=xam(ia)
               mas2=xam(ib)
            else 
               mas1 = int(100*(satom1(i)-int(satom1(i))))
               mas2 = int(10000*(satom1(i)-int(satom1(i)))) - mas1 * 100
               samass(i) = mas1 + mas2
            endif
            schi(i,1) = sd0(i)                                                  
            schi(i,2) = mas1*mas2/samass(i)                                
            schi(i,3) = 0.
            sc6(i) = 1.0d-31                                                    
         else
            samass(i) = xam(iatom)                       
            schi(i,1) = xchi1(iatom)                                            
            schi(i,2) = xchi2(iatom)                                            
            schi(i,3) = xchi3(iatom)

c*****do the damping, beginning with the Unsold approximation
            ich = idint(scharge(i) + 0.1)      
            unsold = dabs(1.61d-33*(13.5*scharge(i)/(schi(i,ich) -
     .               se(i,1)))**2 - 1.61d-33*(13.5*scharge(i)/
     .               (schi(i,ich)-se(i,2)))**2)               
            if (ipr(8) .eq. 0) then
               if (sc6(i) .eq. 0.0) then
                  sc6(i) = unsold
               elseif (sc6(i) .gt. 1.0d-10) then
                  sc6(i) = unsold*sc6(i)
               endif
            elseif (ipr(8) .eq. 1) then
               sc6(i) = 6.3*unsold
            elseif (ipr(8) .eq. 2) then
               sc6(i) = (1.0 + 0.67*se(i,1))*unsold
            endif
         endif
      enddo

c*****exit the routine normally
330   call snearly
      call out (27)
      return  

      end

