      subroutine synth                   
c******************************************************************************
c     This program synthesizes a section of spectrum and compares it
c     to an observation file.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Strong.com'
      include 'Linex.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params


c*****set up the output files
      nwrite = 20     
      lscreen = 4
      array = 'Give the filename for standard output: '
      nchars = 39
      call infile ('output ',nwrite,'formatted  ',0,nchars,lscreen)
      ndump = 21               
      lscreen = lscreen + 2
      array = 'Give the filename for raw syntheses output: '
      nchars = 44
      call infile ('output ',ndump,'formatted  ',0,nchars,lscreen)
      if (ipr(7) .ne. 0) then
         n2dump = 22               
         lscreen = lscreen + 2
         array = 'Give the filename for smoothed syntheses: '
         nchars = 42
         call infile ('output ',n2dump,'formatted  ',0,nchars,lscreen)
      endif
      if (iraf .ne. 0) then
         n2write = 23               
         lscreen = lscreen + 2
         array = 'Give the filename for IRAF ("rtext") output: '
         nchars = 45
         call infile ('output ',n2write,'formatted  ',0,nchars,lscreen)
      endif


c*****set up the model atmosphere                                        
      filemodel = 30
      lscreen = lscreen + 2
      array = 'Give the filename for the model atmosphere: '
      nchars = 44
      call infile ('input  ',filemodel,'formatted  ',0,nchars,lscreen)
      call inmodel


c*****open the line list file and the strong line list file
      filelines = 31
      lscreen = lscreen + 2
      array = 'Give the filename for the line list: '
      nchars = 37
      call infile ('input  ',filelines,'formatted  ',0,nchars,lscreen)
      if (nstrong .gt. 0) then
         fileslines = 32
         lscreen = lscreen + 2
         array = 'Give the filename for the strong line list: '
         nchars = 44
         call infile ('input  ',fileslines,'formatted  ',0,nchars,
     .                lscreen)
      endif
      

c*****do the syntheses
      if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
         isorun = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly
         call synspec
      else
         do n=1,numatomsyn
            isynth = n
            isorun = 1
            mode = 3
	    if (numiso .ne. 0) call out (26)
            call inlines (1)
            call eqlib
            call nearly
            start = oldstart
            stop = oldstop
            call synspec
            ipr(3) = 0
         enddo
      endif
         

c*****now plot the spectrum
      if (ipr(7).eq.2 .and. ipr(9).gt.0) then
         fileobs = 23               
         lscreen = lscreen + 2
         array = 'Give the filename of the observed spectrum: '
         nchars = 44
         if (ipr(9) .eq. 1) then
            call infile ('input  ',fileobs,'unformatted',2880,nchars,
     .                   lscreen)
         else
            call infile ('input  ',fileobs,'formatted  ',0,nchars,
     .                   lscreen)
         endif
      endif
      if (ipr(7) .ne. 0) then
         call pltspec (lscreen)
      endif

c*****finish
      call finish
      end                                                                






