      subroutine trudamp (j,ifind)
c*************************************************************************
c     This routine calculates damping parameters for lines that have
c     accurately known laboratory damping parameters
c*************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      real*8 nhe

      iwave = int(wave1(j))

      if (atom1(j) .eq. 20.1) then
         if (iwave.ne.8498 .and. iwave.ne.8542 .and.
     .       iwave.ne.8662) go to 200
         write (nwrite,1000)
1000     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'CaII INFRARED TRIPLET'/
     .          4x,'natural',6x,'stark',5x,'helium',3x,'hydrogen',
     .          6x,'gamma',5x,'a(j,i)',5x,'a(VdW)')
         do 10 i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 1.5e+08
            gstark  = 1.5e-06*ne(i)*(t(i)/5000.)**0.1666
            ghelium = 3.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 1.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gamma = gnature/2. + gstark + ghelium + ghydro 
            a(j,i) = gamma*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))                      
            gvander = 17.0*c6(j)**0.4*v1**0.6*nhtot(i)       
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nwrite,1001) gnature,gstark,ghelium,ghydro,
     .                          gamma,a(j,i),avander
1001        format (1p7e11.3)
10          continue
         return
      elseif (atom1(j) .eq. 20.0) then
         if (iwave .ne. 6717) go to 200
         write (nwrite,1002) iwave
1002     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'CaI LINE AT',i6/
     .          4x,'natural',5x,'helium',3x,'hydrogen',
     .          6x,'gamma',5x,'a(j,i)',5x,'a(VdW)')
         do 20 i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 0.4e-08
            ghelium = 1.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 2.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gamma = gnature/2. + ghelium + ghydro 
            gamma = gamma*2.
            a(j,i) = gamma*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))                      
            gvander = 17.0*c6(j)**0.4*v1**0.6*nhtot(i)       
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nwrite,1001) gnature,ghelium,ghydro,
     .                          gamma,a(j,i),avander
20          continue
         return
      elseif (atom1(j) .eq. 11.0) then
         write (nwrite,1003) iwave
1003     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'NaI LINE AT',i6/
     .          4x,'natural',4x,'VdW*1.2',6x,'gamma',
     .          5x,'a(j,i)',5x,'a(VdW)')
         do 30 i=1,ntau
            gnature = 2.21e+15/wave1(j)**2
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))                      
            gvander = 17.0*c6(j)**0.4*v1**0.6*nhtot(i)       
            gcoll   = gvander*2.1
            gamma = gnature/2. + gcoll
            a(j,i) = gamma*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nwrite,1001) gnature,gcoll,gamma,a(j,i),avander
30          continue
         return
      endif

200   ifind = 0
      return
      

      end




