	program mklfn
c
c a routine to make a luminosity function from theoretical isochrones,
c where the input flux distribution file has been made.
c
	real*8 mv(100),dmv,fsum(100),mvtot,f
	data fsum/100*0.0d0/

        dmv = 0.30d0
        mv(1) = -2.50d0

c define the bin boundaries in Mv
	
	do i = 2,100
	   mv(i) = mv(i-1)+dmv
           if (mv(i).ge.8.0) then
              nbin = i-1
              exit
	   endif
	enddo

c read the title and total v flux

        read(5,'(a)')title
	read(5,'(10x,f16.10)')mvtot

c sum the flux fractions in each bin

	do j = 1,3000
	   read(5,*,end=900)v,f
           do i = 1,nbin
              if (v.ge.mv(i) .and. v.lt.mv(i+1)) then
                 fsum(i) = fsum(i) + f/mvtot
                 exit
	      endif
	   enddo
	enddo
 900	continue

c now write-out the summed flux fractions for each bin

	write(6,100)(mv(i)+dm/2.0,fsum(i),i=1,nbin)
 100	format(f10.3,f10.5)

	stop
	end
