	program imfpgm
c
c A routine to compute the IMF from Kroupa 2002, Science, 295, 82
c
	real*8 mass,dm,n

        mass = 0.20d0
        dm = 0.05d0

	do i = 1,100
	   call imf(mass,dm,n)
           write(6,*)mass,n
	   mass = mass + dm
	enddo
	stop
	end


	subroutine imf(mass,dm,n)
c
c A routine to compute the IMF from Kroupa 2002, Science, 295, 82
c (equations 4 & 5)
c
	real*8 m0,m1,m2,m3,mass,n,k

c normalization for solar neighborhood stellar density per cubic pc
	k = 0.877

c IMF slopes. Note that m3 is higher to account for missing companions
        a0 = +0.30
        a1 = +1.30
        a2 = +2.30
        a3 = +2.70

c mass ranges
	m0 = 0.01d0
        m1 = 0.08d0
        m2 = 0.50d0
        m3 = 1.00d0

	if (mass.gt.m0 .and. mass.le.m1) then
	   xi = k*(mass/m1)**(-a0)
	elseif (mass.ge.m1 .and. mass.lt.m2) then
	   xi = k*(mass/m1)**(-a1)
	elseif (mass.ge.m2 .and. mass.lt.m3) then
           xi = k*(m2/m1)**(-a1) * (mass/m2)**(-a2)
	elseif (mass.ge.m3) then
           xi = k * (m2/m1)**(-a1) * (m3/m2)**(-a2) * (mass/m3)**(-a3)
	endif
	n = xi*dm
	return
	end
