	program mkcmd_th
c
c a routine to grab the theoretical isochrones, bin them
c appropriate for the IL abundance routine, and produce
c parameters needed by the IL analysis routine.
c
	logical alpha
        real*8 massi(1000),llg(1000),telg(1000),logg(1000),mbol(1000)
        real*8 mv(1000),teff(1000),rlg(1000),r(1000),bv(1000),n(1000)
	real*8 mic(1000),agelg,z,dm
	real*8 flux_sum,nsum,mvsum,bvsum,teffsum,loggsum,micsum,rsum
	real*8 flux,t_av,logg_av,mic_av,r_av,bv_av,mv_av,fbin,fsum

c *** DEBUG
	real*8 f,ffrac,fmvsum
c

	integer i,i2,j,nlevel,nrgb

	call get_isochrone_params(agelg,z,alpha)
	call open_isochrone_file(agelg,z,alpha)
	call open_output_file

c grab database data and write out variables for IL routine

c  *** DEBUG
	write(9,*)' I    Mv     (B-V)   Teff    Logg     Micro.    Radius'
c

	do i = 1,1000

           read(7,100,end=900)massi(i),llg(i),telg(i),logg(i),mbol(i),
     %                        mv(i),bv(i)
	   call compute_radius(teff(i),llg(i),telg(i),r(i))
 	   call compute_micro(teff(i),logg(i),mic(i))
c  *** DEBUG
        write(9,'(i3,2f8.3,f10.3,3f10.4)')i,mv(i),bv(i),teff(i),logg(i),
     %      mic(i),r(i)
	enddo

 900	continue
	nlevel = i-1

c compute total flux 

	vtotal = 0.0
	do i = 1,nlevel
           call compute_dm(massi,i,nlevel,dm)
           call imf(massi(i),dm,n(i))
	   vtotal = vtotal + n(i)*10.0**(-0.4*mv(i))
	enddo

c find the rgb tip level

	do i = 1,nlevel-1
           if ( (llg(i)-llg(i+1)) .ge. 0.5) then
              nrgb = i
	      exit
	   endif
	enddo

c *** DEBUG
 	write(9,*)' I    Massi     dMass     N(I)     Flux_i     Fsum  
     %  Ffrac_i    Fmv   Fmvsum'
        fsum = 0.0d0
        do i = 1,nlevel
           f = n(i)*10.0**(-0.4*mv(i))
           fsum = f + fsum
           ffrac = fsum/vtotal
	   write(8,'(f10.5,e13.6)')mv(i),f
           fmvsum = fmvsum + f*mv(i)
           write(9,'(i3,2x,2f10.5,e12.5,e12.5,4g12.5)')i,massi(i),
     %          dm,n(i),f,fsum,ffrac,f*mv(i),fmvsum
 	enddo
 	write(9,*)'Vtotal = ',vtotal
 	write(8,*)'Vtotal = ',vtotal
c

c now flux weight the parameters into bins of approximately 3.8%

        i2 = 1
	fsum = 0.0d0
	do i = 1,nlevel

	   if (i2.gt.nlevel) exit
	   flux_sum = 0.0d0
           nsum     = 0.0d0
	   mvsum    = 0.0d0
	   bvsum    = 0.0d0
           teffsum  = 0.0d0
           loggsum  = 0.0d0
           micsum   = 0.0d0
           rsum     = 0.0d0

           do j = i2,nlevel
              flux = n(j) * 10.0**(-0.4*mv(j))
	      flux_sum = flux_sum + flux
              mvsum   = mvsum + mv(j)*flux
              bvsum   = bvsum + bv(j)*flux
              teffsum = teffsum + teff(j)*flux
              loggsum = loggsum + logg(j)*flux
              micsum  = micsum + mic(j)*flux
              rsum    = rsum    + r(j)*flux
              nsum    = nsum + n(j)

              if (flux_sum/vtotal.ge.0.038d0 .or. j.eq.nrgb .or. 
     %            j.ge.nlevel .and. flux_sum.ne.0.0d0) then
                 t_av = teffsum/flux_sum
                 logg_av = loggsum/flux_sum
                 mic_av  = micsum/flux_sum
                 r_av    = rsum/flux_sum
                 bv_av   = bvsum/flux_sum
                 mv_av   = mvsum/flux_sum

                 fbin = flux_sum/vtotal
                 fsum = fsum + fbin
            
c                write(8,120)mv_av,bv_av,t_av,logg_av,mic_av,r_av,nsum,
c    %                       fbin,fsum,j
	         goto 800
	      endif
	   enddo
 800	   continue
	   i2 = j + 1
	enddo
	   
 100    format(17x,f8.3,8x,6f8.4)
 120    format(2f8.3,f7.0,f7.3,f7.2,f8.3,g13.6,2f9.4,i4)
	stop
	end




	subroutine get_isochrone_params(agelg,z,alpha)

c grab GC parameters from user

	logical alpha
	real*8 agelg,z
	character*1 ans

c get age
	write(6,*)'Enter log_10 age (9.0 to 10.25 in steps of 0.05)'
	read(5,*)agelg

c get metallicity
        write(6,120)
	read(5,*)z

c alpha rich?
	write(6,*)'Alpha rich models?'
	read(5,*)ans
	   if (ans.eq.'y' .or. ans.eq.'Y') then
               alpha = .true.
           else 
               alpha = .false.
           endif

 120    format(54hEnter metallicity(0.0001, 0.0004, 0.001, 0.004, 0.008,
     %        ,20h 0.019, 0.03, 0.04):)
	return
	end




	subroutine open_output_file

	character*50 outfile

	write(6,*)'Enter output file name'
	read(5,'(a)')outfile
	open(unit=8,file=outfile)


        write(8,*)'   Mv     (B-V)  Teff    Logg   Mic      R       N    
     %        Vbin     Vsum' 

	return
	end



	subroutine open_isochrone_file(agelg,z,alpha)

	real*8 agelg,z
        character*4 met,age,file*21,file1*33,file2*34,fname*21,end*10
	character*113 title
	logical alpha

c first the metallicity

	if (z.eq.0.0001d0) then
           met = '0001'
        elseif (z.eq.0.0004d0) then
           met = '0004'
        elseif (z.eq.0.001d0) then
           met = '0010'
        elseif (z.eq.0.004d0) then
           met = '0040'
        elseif (z.eq.0.008d0) then
           met = '0080'
        elseif (z.eq.0.019d0) then
           met = '0190'
        elseif (z.eq.0.030d0) then
           met = '0300'
        elseif (z.eq.0.040d0) then
           met = '0400'
	else
           write(6,*)'Error: metallicity not included'
	   stop
	endif

c now find the temperature

	if (agelg.eq.9.0d0) then
           age = '0.00'
	elseif (agelg.eq.9.05d0) then
           age = '0.05'
	elseif (agelg.eq.9.10d0) then
           age = '0.10'
	elseif (agelg.eq.9.15d0) then
           age = '0.15'
	elseif (agelg.eq.9.20d0) then
           age = '0.20'
	elseif (agelg.eq.9.25d0) then
           age = '0.25'
	elseif (agelg.eq.9.30d0) then
           age = '0.30'
	elseif (agelg.eq.9.35d0) then
           age = '0.35'
	elseif (agelg.eq.9.40d0) then
           age = '0.40'
	elseif (agelg.eq.9.45d0) then
           age = '0.45'
	elseif (agelg.eq.9.50d0) then
           age = '0.50'
	elseif (agelg.eq.9.55d0) then
           age = '0.55'
	elseif (agelg.eq.9.60d0) then
           age = '0.60'
	elseif (agelg.eq.9.65d0) then
           age = '0.65'
	elseif (agelg.eq.9.70d0) then
           age = '0.70'
	elseif (agelg.eq.9.75d0) then
           age = '0.75'
	elseif (agelg.eq.9.80d0) then
           age = '0.80'
	elseif (agelg.eq.9.85d0) then
           age = '0.85'
	elseif (agelg.eq.9.90d0) then
           age = '0.90'
	elseif (agelg.eq.9.95d0) then
           age = '0.95'
	elseif (agelg.eq.10.00d0) then
           age = '1.00'
	elseif (agelg.eq.10.05d0) then
           age = '1.05'
	elseif (agelg.eq.10.10d0) then
           age = '1.10'
	elseif (agelg.eq.10.15d0) then
           age = '1.15'
	elseif (agelg.eq.10.20d0) then
           age = '1.20'
	elseif (agelg.eq.10.25d0) then
           age = '1.25'
	else
           age = '0.00'
           write(6,*)'Error: Age not included'
	   stop
	endif

	end(1:6) = '_lgage'
	end(7:10) = age

	fname = '     '
	fname(1:1) = 'z'
        if (z.lt.0.00099) then
           fname(2:5) = met(1:4)
           file1 = 'isochrones1/'//fname(:5)//end(:10)//'.dat'
           file2 = 'isochrones2/'//fname(:5)//end(:10)//'_v2.dat'
        else
           fname(2:4) = met(1:3)
           file1 = 'isochrones1/'//fname(:4)//end(:10)//'.dat'
           file2 = 'isochrones2/'//fname(:4)//end(:10)//'_v2.dat'
	endif
        if (alpha) then
 	   open(unit=7,file=file2,status='old')
	else
 	   open(unit=7,file=file1,status='old')
	endif
	read(7,'(a113)')title
	return
	end



	subroutine compute_micro(teff,logg,mic)
c
c a very rough estimation of the trend of microturbulence with logg
c
c FEEL FREE TO IMPROVE THIS ROUTINE
c
c made-up, with some input from MPSS95 and MR94 Alpha Boo
c
	real*8 teff,logg,mic

c
c original trend used for N6397 back in 2001
c	mic = 2.5 - 1.5*(logg-0.5)/4.0     

c
c New trend, based on Arcturus, 47Tuc star 6, and sun.  AMcW. 15/Aug./2003
c
c       mic = 1.0 + (4.5-logg)*(1.0/6.0)   !this was for run#3
        mic = 2.2d0 + -logg*(4.0d0/15.0d0)       ! run #4 (add 0.3 km/s at logg=1.5)
     
        mic = 1.0d0 + (4.44d0-logg) * 0.6d0/(4.44d0-1.62d0)         ! linear between sun and Arcturus AMcW 30/7/2004


	return
	end



	subroutine compute_radius(teff,llg,telg,r)
c
c compute radius from L = R^2 Teff^4
c
	real*8 teff,llg,telg,r,rlg,telg_sun

	telg_sun = 3.76170

	teff = 10.0**telg
        rlg = 0.5 * (llg - 4.0*(telg - telg_sun) )
        r  = 10.0**rlg

	return
	end



	subroutine compute_dm(massi,i,nlevel,dm)
c
c compute the width of the mass bin to be used for the IMF 
c
	real*8 dm,massi(1000)
	integer i,nlevel

	if (i.ne.1 .and. i.ne.nlevel) then
           dm = 0.5d0*(massi(i+1)-massi(i-1))
        elseif (i.eq.1) then
           dm =  massi(2) - massi(1)
        else
           dm =  massi(nlevel) - massi(nlevel-1)
	endif
	return
	end



	subroutine imf(mass,dm,n)
c
c A routine to compute the IMF from Kroupa 2002, Science, 295, 82
c (equations 4 & 5)
c
	real*8 m0,m1,m2,m3,mass,n,k,dm

c normalization for solar neighborhood stellar density per cubic pc
	k = 0.877

c IMF slopes. Note that m3 is higher to account for missing companions
        a0 = +0.30
        a1 = +1.30
        a2 = +2.30
        a3 = +2.70

c mass ranges
	m0 = 0.01d0
        m1 = 0.08d0
        m2 = 0.50d0
        m3 = 1.00d0

	if (mass.gt.m0 .and. mass.le.m1) then
	   xi = k*(mass/m1)**(-a0)
	elseif (mass.ge.m1 .and. mass.lt.m2) then
	   xi = k*(mass/m1)**(-a1)
	elseif (mass.ge.m2 .and. mass.lt.m3) then
           xi = k*(m2/m1)**(-a1) * (mass/m2)**(-a2)
	elseif (mass.ge.m3) then
           xi = k * (m2/m1)**(-a1) * (m3/m2)**(-a2) * (mass/m3)**(-a3)
	endif
	n = xi*dm
	return
	end
