      subroutine abfind
c******************************************************************************
c     This routine derives abundances for individual atomic lines       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'
      character choice
      integer sm_device

c*****read the parameter file
      call params

c*****set up the output file
      nwrite = 20     
c     array = 'Give the filename for standard output: '
c     nchars = 39
c     call infile ('output ',nwrite,'formatted  ',0,nchars,4)
   
c  AMcW 12/Aug/2003
      open(unit=nwrite,file='logfile')

      ndump = 21     
c     array = 'Give the filename for abundance summaries: '
c     nchars = 43
c     call infile ('output ',ndump,'formatted  ',0,nchars,6)

c  AMcW 12/Aug/2003
      open(unit=ndump,file='OUTPUT')


c*****set up the model atmosphere                                        
      filemodel = 30
c     array = 'Give the filename for the model atmosphere: '
c     nchars = 44
c     call infile ('input  ',filemodel,'formatted  ',0,nchars,8)

c  AMcW 12/Aug/2003
      open(unit=filemodel,file='MODEL')

      call inmodel

c*****read line data; get ready for the line calculations
      filelines = 31
c     array = 'Give the filename for the line list: '
c     nchars = 37
c     call infile ('input  ',filelines,'formatted  ',0,nchars,10)

c  AMcW 12/Aug/2003
      open(unit=filelines,file='INPUT')

      call inlines (1)
      call eqlib
      call nearly
 
c*****set some parameters
      call out (24)
      ipr(5) = -1
      mode = 2

c*****find the range of lines of a species
5     call linlimit
      if (lim1line .lt. 0) then
         call finish
         return
      endif
      lim1obs = lim1line
      lim2obs = lim2line

c*****force each abundance of a species member to predict the 
c     line equivalent width
10    do lim1=lim1line,lim2line
         lim2 = lim1
         ncurve = 1
         gf1(ncurve) = gf(lim1)
         rwlgobs = dlog10(width(lim1)/wave1(lim1))
15       call oneline (2)
         error = (w(ncurve)-width(lim1))/width(lim1)
         ratio = width(lim1)/w(ncurve)
         ncurve = ncurve + 1

c*****here we go for another iteration on a line
         if (dabs(error) .ge. 0.0025) then
            rwlcomp = dlog10(w(ncurve-1)/wave1(lim1))
            if     (rwlcomp.lt.-5.2 .and. rwlgobs.lt.-5.2) then 
               ratio = ratio
            elseif (rwlcomp.ge.-5.2 .and. rwlgobs.ge.-5.2) then 
               ratio = ratio**2.0
            else   
               ratio = ratio**1.5
            endif
            gf1(ncurve) = gf1(ncurve-1)*ratio
            do i=1,ntau                                
               kapnu0(lim1,i) = kapnu0(lim1,i)*ratio            
            enddo
            go to 15

c*****here we do the final calculation on a line when the predicted 
c     and observed are close enough to finish
         else
            gf1(ncurve) = gf1(ncurve-1)*ratio
            do i=1,ntau                                                     
               kapnu0(lim1,i) = kapnu0(lim1,i)*ratio            
            enddo
            call oneline (1)
            widout(lim1) = w(ncurve)
            diff = dlog10(gf1(ncurve)/gf(lim1))
            if (atom1(lim1) .ge. 100.) then
               abunout(lim1) = diff
            else
               abunout(lim1) = dlog10(xabund(int(atom1(lim1)))) + 
     .                         12.0 + diff
            endif
            call out (24)
         endif
      enddo

c*****get the average and standard deviation, and trend parameters for
c     this species; print out results
c
c curt mode AMcW 1/2000
      if (curt) then
         call out(29)
      else
         call stats
         call out (25)
      endif

c*****here a plot may be made on the terminal (and paper) if there 
c     are enough lines
      if (kount .ge. ipr(7) .and. ipr(7) .ne. 0) then
55       choice = 'y'
         if (sm_device(smterm) .lt. 0) then
            write (nwrite,1006) smterm
1006        format ('DEVICE OPENING ERROR FOR:',a54)
            stop
         endif
         call sm_graphics
         call sm_erase
         call linplot (choice)
         call sm_gflush
         call sm_alpha
         array = '   MAKE A HARDCOPY OF THIS PLOT ([n]/h/f/r)? '
         ikount = kount + 11
         nchars = 45
         call getasci (nchars,ikount)
         choice = chinfo(1:1)
         if (choice.eq.'n' .or. nchars.le.0) then
            go to 60
         elseif (choice .eq. 'h') then
            if (sm_device('postport') .lt. 0) then
               write (nwrite,1008) 
1008           format ('DEVICE OPENING ERROR FOR: postport')
               stop
            endif
            call sm_graphics
            call sm_erase
            call linplot (choice)
            call sm_gflush
            call sm_alpha
            call sm_hardcopy
         elseif (choice .eq. 'r') then
            go to 55
         elseif (choice .eq. 'f') then
            array = 
     .        'Give the file name for the POSTSRIPT plot image: '
            nchars = 49
            ikount = kount + 12
            call getasci (nchars,ikount)
            write (array,1005) chinfo(1:nchars)
1005        format ('postfile ',a71)
            if (sm_device(array(1:nchars+9)) .lt. 0) then
               write (nwrite,1007) array(1:nchars+9)
1007           format ('FILE OPENING ERROR FOR:',a56)
               stop
            endif
            call sm_graphics
            call sm_erase
            call linplot (choice)
            call sm_gflush
            call sm_alpha
            call sm_hardcopy
         endif
      endif

c curt mode AMcW 1/2000
        if (curt) go to 5

c*****now the option will be to redo the molecular equilibrium and redo
c     the last species, at the user's option.
60    if (neq .ne. 0) then
         iatom = idint(atom1(lim1obs))
         do n=1,neq                                                      
            if (iatom .eq. iorder(n)) then
               write (array,1004)
1004           format ('SPECIES USES MOLEC. EQUILIBRIUM!',
     .               '  REDO WITH NEW AVERAGE ABUNDANCE ([y]/n)? ')
               ikount=kount+11
               nchars = 75
35             call getasci (nchars,ikount)
               choice = chinfo(1:1)
               if (choice.eq.'y' .or. nchars.le.0) then
                  xabund(iatom) = 10.**(average-12.)
                  call eqlib
                  call nearly
                  go to 10
               elseif (choice .eq. 'n') then
                  go to 36
               else
                  go to 35
               endif
            endif
         enddo
      endif
            
c*****quit, or go on to another species?
36    array = 'DO ANOTHER SPECIES ([y]/n)? '
      ikount=kount+11
      nchars = 32
      call getasci (nchars,ikount)
      choice = chinfo(1:1)
      if (choice.eq.'y' .or. nchars.le.0) then
         go to 5
      else
         call finish
         return
      endif


      end










      block data atomic                                                  
c******************************************************************************
c  this routine contains atomic data ordered by atomic number            
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Quants.com'
c  
c  This routine contains the basic atomic data 
c
c  names = atomic symbols for the elements
      data names/'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     .           'Na','Mg','Al','Si','P ','S ','Cl','Ar','K ','Ca',
     .           'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     .           'Ga','Ge','As','Se','Br','Kr','Rb','Sr','Y ','Zr',
     .           'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     .           'Sb','Te','I ','Xe','Cs','Ba','La','Ce','Pr','Nd',
     .           'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     .           'Lu','Hf','Ta','Wl','Re','Os','Ir','Pt','Au','Hg',
     .           'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     .           'Pa','U ','Np','Pu','Am'/                         
c
c  xabu = the set of current solar (when available) or meteorite       
c  abundances, scaled to log(h) = 12.00 .  The data are from Anders
c  and Grevesse (1989, Geochim.Cosmichim.Acta, v53, p197) and the solar
c  values are adopted except for a) uncertain solar data, or b) Li, Be,
c  and B, for which the meteoritic values are adopted.
c  I use the new Fe value of 7.50.
      data xabu0/
     * 12.00,10.99, 3.31, 1.42, 2.88, 8.56, 8.05, 8.93, 4.56, 8.09,      
     1  6.33, 7.58, 6.47, 7.55, 5.45, 7.21, 5.5 , 6.56, 5.12, 6.36,      
     2  3.10, 4.99, 4.00, 5.67, 5.39, 7.52, 4.92, 6.25, 4.21, 4.60,      
     3  2.88, 3.41, 2.37, 3.35, 2.63, 3.23, 2.60, 2.90, 2.24, 2.60,      
     4  1.42, 1.92, 0.00, 1.84, 1.12, 1.69, 1.24, 1.86, 0.82, 2.0 ,      
     5  1.04, 2.24, 1.51, 2.23, 1.12, 2.13, 1.22, 1.55, 0.71, 1.50,      
     6  0.00, 1.00, 0.51, 1.12, 0.33, 1.1 , 0.50, 0.93, 0.13, 1.08,      
     7  0.12, 0.88,-0.13, 0.68, 0.27, 1.45, 1.35, 1.8 , 0.83, 1.09,      
     8  0.82, 1.85, 0.71, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.12,      
     9  5*0.0/                                                           
c
c  xam = atomic mass (amu)
      data xam/                                                          
     * 1.008,4.003,6.941,9.012,10.81,12.01,14.01,16.00,19.00,20.18,      
     1 22.99,24.31,26.98,28.08,30.97,32.06,35.45,39.95,39.10,40.08,      
     2 44.96,47.90,50.94,52.00,54.94,55.85,58.93,58.71,63.55,65.37,      
     3 69.72,72.59,74.92,78.96,79.90,83.80,85.47,87.62,88.91,91.22,      
     4 92.91,95.94,98.91,101.1,102.9,106.4,107.9,112.4,114.8,118.7,      
     5 121.8,127.6,126.9,131.3,132.9,137.3,138.9,140.1,140.9,144.2,      
     6 145.0,150.4,152.0,157.3,158.9,162.5,164.9,167.3,168.9,173.0,      
     7 175.0,178.5,181.0,183.9,186.2,190.2,192.2,195.1,197.0,200.6,      
     8 204.4,207.2,209.0,210.0,210.0,222.0,223.0,226.0,227.0,232.0,      
     9 231.0,238.0,237.0,244.0,243.0/                                    
c    
c  xchi1 = first ionization potential (ev)   
c  data are from I. S. Grigoriev & E. Z. Meilikhov 1997, Handbook of
c  Physical Quantities, CRC Press, Boca Raton, 516; supplemented
c  by the CRC, 1994 edition
      data xchi1/                                                        
     * 13.60,24.59,5.392,9.323,8.298,11.26,14.53,13.62,17.42,21.56,      
     1 5.139,7.646,5.986,8.152,10.49,10.36,12.97,15.76,4.340,6.113,      
     2 6.562,6.828,6.746,6.766,7.434,7.902,7.881,7.640,7.726,9.394,      
     3 5.999,7.899,9.789,9.752,11.81,14.00,4.177,5.695,6.217,6.634,      
     4 6.579,7.092, 7.28,7.361,7.459,8.337,7.576,8.994,5.786,7.344,      
     5 8.608,9.010,10.45,12.13,3.893,5.211,5.577,5.539, 5.46,5.525,      
     6  5.55,5.644,5.670,6.150,5.864,5.939,6.022,6.108,6.184,6.254,      
     7 5.426,6.825, 7.89,  8.0,  7.9,  8.7,  9.1,  9.0,9.226,10.44,      
     8 6.108,7.417,7.286,8.417,  9.0,10.75,4.073,5.278,  5.2,  6.1,      
     9   5.9,6.194,6.266, 6.06, 5.99/                                    
c
c  xchi2 = second ionization potential (ev)                              
c  a value of 30 in the chi data denotes an unknown value                
      data xchi2/                                                        
     * 50.00,54.42,75.64,18.21,25.16,24.38,29.60,35.12,34.97,40.96,
     * 47.29,15.04,18.83,16.35,19.77,23.34,23.81,27.63,31.63,11.87,
     * 12.80,13.58,14.66,16.50,15.64,16.19,17.08,18.17,20.29,17.96,
     * 20.52,15.94,18.59,21.16,21.81,24.36,27.29,11.03,12.22,13.13,
     * 14.32,16.16,15.26,16.76,18.08,19.43,21.49,16.91,18.87,14.63,
     * 16.53, 18.6,19.13,20.98,23.16,10.00, 11.1, 10.8, 10.6, 10.7,
     *  10.9, 11.1,11.24, 12.1, 11.5, 11.7, 11.8, 11.9, 12.1,12.18,
     *  13.9, 14.9, 16.2, 17.7, 16.6, 17.0,  30.,18.56, 20.5,18.76,
     * 20.43,15.03,16.70, 19.0,  30.,  30., 22.0,10.15,11.75, 11.9,
     *  12.0, 11.9,  30.,  30.,  30./
c
c  xchi3 = third ionization potential (ev)                              
c  a value of 60 in the chi data denotes an unknown value                
c  a valu of 99.99 denotes a very large value
      data xchi3/                                                        
     * 90.00,90.00,122.5,153.9,37.93,47.89,47.45,54.94,62.71,63.46,
     * 71.62,80.14,28.45,33.49,30.20,34.83,39.61,40.91,45.81,50.91,
     * 24.76,27.49,29.31, 31.0,33.67,30.65, 33.5, 35.3,36.84,39.72,
     * 30.73, 34.2, 28.4,30.82, 35.9,36.95, 39.2,42.88,20.53, 23.1,
     *  25.0, 27.2, 29.5, 28.5, 31.1, 32.9, 34.8,37.47, 28.0,30.50,
     * 25.32,27.96, 33.0, 31.0, 33.4, 35.8,19.18,20.20,21.62, 22.1,
     *  22.3, 23.4, 24.9, 20.6, 21.9, 22.8, 22.8, 22.7, 23.7,25.05,
     * 20.96, 23.3,  60.,  60.,  60.,  60.,  60.,  60.,  34., 34.2,
     * 29.85,31.94,25.56,  60.,  60.,  60.,  60.,  60.,  20., 18.3,
     *   60.,  20.,  60.,  60.,  60./
c
c   these logartihmic partition funtions for the fourth ionization state 
c   (X III) are from ATLAS9, and assumed to just be the ground state
c   statistical weights
      data udata/
     *  0.00, 0.00, 0.00, 0.30, 0.00, 0.31, 0.05, 0.78, 0.00, 0.72,
     * -0.01, 0.76, 0.00, 0.30, 0.00, 0.75,-0.02, 0.76,-0.02, 0.74,
     *  0.00, 0.99, 0.40, 0.58, 0.52,-0.01, 0.42, 0.45, 0.00, 0.00,
     *  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     *  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     *  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     *  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     *  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     *  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     *  0.00, 0.00, 0.00, 0.00, 0.00/
c
c  these partition function constants are from ATLAS9
      data ((nudata(l,m),l=1,6),m=  1, 15)/
     * 200020001, 200020011, 201620881, 231228281, 378953411,   10,
     * 100010001, 100010001, 100010001, 100010001, 100010001,   11,
     * 100010001, 100010001, 100010001, 100010001, 100010001,   12,
     * 100010001, 100010011, 102111241, 145022061, 363059451,   20,
     * 200020001, 200020071, 208524971, 382669341, 128222452,   21,
     * 100010001, 100010001, 100010001, 100010001, 100010001,   22,
     * 200020011, 201220481, 212922881, 258731081, 394251691,   30,
     * 100010001, 100010201, 126225521,  67216512, 351165562,   31,
     * 200020001, 200020211, 227936571,  69610342, 137217102,   32,
     * 100010051, 104311441, 131615641, 190623681, 298037691,   40,
     * 200120231, 211422771, 249627631, 309034911, 398545051,   41,
     * 100010001, 100010201, 126225521,  67216512, 351165562,   42,
     * 600060001, 600560281, 608761991, 637466191, 693973361,   50,
     * 100310831, 132016901, 214226411, 315736741, 419147071,   51,
     * 200721061, 233526401, 297533311, 369040481, 440747651,   52/
      data ((nudata(l,m),l=1,6),m= 16, 30)/
     * 893292271,  96110042, 105311262, 126315202, 196126432,   60,
     * 595060251, 620865751, 713280191,  95712292, 167623542,   61,
     * 105513201, 180324851, 341851341,  88416332, 296550722,   62,
     * 403141851, 457051681, 594071181,  92913362, 203331152,   70,
     * 919899541, 107211512, 124914302, 182526232, 403762662,   71,
     * 596862721, 684177081,  88110342, 128317062, 239334312,   72,
     * 874789691, 924795711,  99410492, 115213492, 169022242,   80,
     * 424151091, 622874781,  91312832, 221842502,  79914013,   81,
     *  95610702, 118113032, 149619922, 329761642, 101914173,   82,
     * 575958511, 589859231, 595860671, 636470031, 815199581,   90,
     * 900296401, 102610802, 113912542, 152921152, 318348952,   91,
     * 469162651, 791295541, 121419552, 402686872, 154822203,   92,
     * 100010001, 100010051, 105313051, 210239461,  74013022,  100,
     * 580158751, 591759741, 642687101, 159332652,  64111533,  101,
     *  93510272, 110411662, 127116062, 257647882,  75110223,  102/
      data ((nudata(l,m),l=1,6),m= 31, 45)/
     * 200020001, 200320211, 207322131, 253031421, 417657451,  110,
     * 100010001, 100010161, 119621261,  50711872, 246445382,  111,
     * 580158751, 591860351,  71813142, 321968812, 106014333,  112,
     * 100010011, 101410621, 118414581, 204831781, 509479731,  120,
     * 200120051, 202921001, 226926901, 368457091,  92814872,  121,
     * 100010001, 100110611, 177455431, 176546012,  99718753,  122,
     * 558857701, 583558761, 593260591, 635969541, 796790971,  130,
     * 100310211, 110313021, 172828201,  55311252, 215637942,  131,
     * 200320201, 208622331, 250530971, 410251081, 611571211,  132,
     * 825189211,  95210052, 106211532, 134317202, 237934082,  140,
     * 563057761, 588160311, 631768671, 791097651, 127817282,  141,
     * 101110771, 126716471, 232438081,  71914052, 262045302,  142,
     * 402643441, 496757481, 658274401, 833492941, 103511532,  150,
     * 874497931, 106011282, 119812802, 138415142, 164717802,  151,
     * 564058061, 604164611, 709579551,  90410172, 112912422,  152/
      data ((nudata(l,m),l=1,6),m= 46, 60)/
     * 822887891, 930697831, 102610932, 121614492, 185124742,  160,
     * 443056011, 694982961,  96911522, 144218572, 227326892,  161,
     *  91610392, 113512242, 136416942, 233429882, 364242962,  162,
     * 538155931, 571657911, 598067191,  89013782, 227737172,  170,
     * 873396771, 104411072, 118513532, 175525872, 406763932,  171,
     * 506569571,  87610522, 134421682, 439092662, 182132573,  172,
     * 100010001, 100010051, 106913911, 240147261,  90716112,  180,
     * 550256831, 578158781, 636585461, 151530162,  58010303,  181,
     *  92110362, 112412002, 133216772, 254443722,  76512833,  182,
     * 200020011, 200720361, 211923291, 280137141, 525575741,  190,
     * 100010001, 100110341, 135929551,  79119282, 405274892,  191,
     * 554657081, 581260301,  73012702, 285363872, 129023363,  192,
     * 100110061, 104311741, 145919971, 294345051,  69010322,  200,
     * 205822781, 279234761, 427553061, 688994901, 136319772,  201,
     * 100010001, 100510821, 168744821, 130232522,  69012813,  202/
      data ((nudata(l,m),l=1,6),m= 61, 75)/
     * 924696691, 105212282, 151219062, 240530032, 368944512,  210,
     * 190424662, 297634542, 391743752, 482952832, 573761912,  211,
     * 976799291, 101110322, 105810882, 111911502, 118112122,  212,
     * 181021172, 260333222, 430155582, 710089242, 110213293,  220,
     * 474659872, 721284672,  98211413, 134515623, 177919963,  221,
     * 228327012, 308134272, 381143862, 534563472, 734983512,  222,
     * 272835172, 425851532, 632278322,  97212013, 146817723,  230,
     * 373954132, 743597002, 121414713, 173920143, 229225713,  231,
     * 323142642, 519660272, 679975352, 824789522,  96610363,  232,
     * 717277611,  92911652, 152620872, 295141952, 550468122,  240,
     *  71611552, 205635512, 558281952, 115315823, 205625293,  241,
     * 280639822, 538369722,  87610823, 129115003, 170919183,  242,
     * 600060321, 629270891,  86911302, 151020222, 267534752,  250,
     * 739594821, 139921212, 309342852, 567372412,  97112553,  251,
     *  98417472, 265535782, 454754842, 641973532, 828792212,  252/
      data ((nudata(l,m),l=1,6),m= 76, 90)/
     * 197023222, 274433302, 416753952, 723799822, 139419053,  260,
     * 409453722, 686687452, 110213823, 174322233, 286437043,  261,
     * 262136422, 501167232,  87911303, 138916483, 190721673,  262,
     * 199427202, 335740022, 474957182, 708090462, 118315403,  270,
     * 279739202, 490858232, 684582472, 104713233, 159818733,  271,
     * 279836622, 461857562, 720693022, 124915873, 192522633,  272,
     * 227027622, 306233052, 356839222, 446052912, 652382292,  280,
     * 108416342, 222428472, 353944332, 577378932, 110314303,  281,
     * 198724282, 293236452, 468362702,  86511123, 136016073,  282,
     * 201620781, 231026761, 314737361, 450555381, 692386911,  290,
     * 109415761, 247938311,  58910042, 190937022,  68311693,  291,
     * 897195961, 107212972, 165021182, 260230862, 356940532,  292,
     * 100010001, 100410231, 108712611, 167124841, 388460411,  300,
     * 200020021, 201620761, 223726341, 351352061,  80812472,  301,
     * 100610471, 122617301, 300566361, 149924112, 332342352,  302/
      data ((nudata(l,m),l=1,6),m= 91,105)/
     * 403245601, 493151431, 529654331, 559358091, 611065171,  310,
     *  99710051, 104511541, 135016501, 208226431, 321837921,  311,
     * 199820071, 204521391, 229124761, 266028451, 302932131,  312,
     * 502665261, 755183501, 901496201, 102410942, 117912812,  320,
     * 422848161, 512153401, 557458941, 636270361, 794489061,  321,
     * 100010261, 114613921, 175221251, 249828711, 324436181,  322,
     * 403143241, 491856701, 649173781, 840396751, 113013392,  330,
     * 593676641, 884697521, 105911572, 129515012, 180322212,  331,
     * 484470541,  91510972, 125614082, 157017612, 199722912,  332,
     * 630172361, 799686381, 919797221, 102810942, 117712832,  340,
     * 438055511, 691582151,  94510732, 121413672, 152016732,  341,
     * 651982921,  94610382, 113212492, 139515462, 169718482,  342,
     * 437347431, 498951671, 538559501,  74710812, 169126672,  350,
     * 705183611,  93510092, 111614162, 222932532, 427652992,  351,
     * 510869921,  87410312, 123116552, 236530712, 377744832,  352/
      data ((nudata(l,m),l=1,6),m=106,120)/
     * 100010001, 100010051, 105012781, 198535971,  65911422,  360,
     * 461049811, 522254261, 609088131, 168935052,  68612253,  361,
     * 759990901, 101911142, 129017782, 302856642,  99414333,  362,
     * 200020011, 200720361, 211523021, 269434141, 459163351,  370,
     * 100010001, 100110321, 129524961,  61014202, 291753192,  371,
     * 473650891, 533156051,  66810932, 232950852,  99915303,  372,
     * 100110041, 104111741, 146019721, 281941411, 607785251,  380,
     * 202621931, 255331271, 384347931, 624085761, 122417632,  381,
     * 100010001, 100110321, 129524961,  61014202, 291753192,  382,
     * 791587851, 100012192, 155119942, 254031782, 389946932,  390,
     * 118217102, 220827002, 319036792, 416646512, 513256072,  391,
     *  92510012, 104710862, 112311612, 120212472, 132814282,  392,
     * 141320802, 291439702, 531170262,  92712273, 162521053,  400,
     * 354454352, 724689652, 107212643, 148517093, 193321573,  401,
     * 209727032, 324537052, 415446282, 510255752, 604965222,  402/
      data ((nudata(l,m),l=1,6),m=121,135)/
     * 256636022, 465759302, 749693962, 116514243, 171520333,  410,
     * 335157222,  84511463, 147718363, 221826083, 299933893,  411,
     * 223725352, 280830972, 340937362, 406844002, 473150632,  412,
     * 703972941,  82610822, 154822682, 327244912, 571469372,  420,
     *  75714552, 274347322, 718897632, 123414913, 174920063,  421,
     * 267645462, 669890262, 115514323, 173620673, 242528083,  422,
     *  90613732, 184823562, 291735332, 419949102, 565764332,  430,
     * 131318312, 227126932, 311735452, 397644072, 483852692,  431,
     * 204721673, 234725733, 284031463, 348738613, 426546943,  432,
     * 176824122, 318941082, 515263202, 761790472, 106112303,  440,
     * 221934642, 501968372,  88911173, 136316243, 189221613,  441,
     * 210622722, 241025422, 267928262, 297731272, 327834282,  442,
     * 148520202, 255230902, 364942462, 489656082, 638872352,  450,
     * 153421292, 288137912, 484660322, 720187062, 101011483,  451,
     * 254537212, 492362292, 770592182, 107312243, 137615273,  452/
      data ((nudata(l,m),l=1,6),m=136,150)/
     * 115919651, 320746011, 607576761,  95011642, 141817172,  460,
     * 755087211, 105913442, 173122222, 282034722, 412247732,  461,
     * 180223462, 289735212, 414247632, 538460052, 662672472,  462,
     * 200020001, 200220141, 206422141, 257633021, 455164681,  470,
     * 100810581, 125817401, 260641031,  66210072, 135316982,  471,
     * 795887491,  97711762, 156620252, 248329422, 340038582,  472,
     * 100010001, 100410241, 109212891, 176827421, 444268771,  480,
     * 200020021, 201720921, 233329881, 451475371, 127520782,  481,
     * 100310281, 114815371, 246138311, 519265531, 791492761,  482,
     * 252431921, 368440461, 433746521, 512259221, 723389021,  490,
     * 100110071, 104611651, 146118581, 225426511, 304734431,  491,
     * 200120111, 205021611, 243628031, 317035371, 390442701,  492,
     * 232637101, 488058571, 669074381, 816189091,  97210632,  500,
     * 286335941, 408144471, 479351961, 571862901, 686274341,  501,
     * 100010251, 114013811, 175321601, 256829751, 338337901,  502/
      data ((nudata(l,m),l=1,6),m=151,165)/
     * 404043481, 494656811, 646772781, 813490751, 101411372,  510,
     * 303147981, 618472951, 827392621, 103711702, 131214532,  511,
     * 313037601, 429347901, 536260591, 689477591, 862494881,  512,
     * 526258801, 657372351, 784284071, 897095741, 102711082,  520,
     * 440855541, 686481251,  93810792, 125414792, 176321132,  521,
     * 349054751, 699883081,  96611302, 134216202, 197724212,  522,
     * 405342041, 438645621, 475751071, 587974491, 102214572,  530,
     * 568567471, 773485861,  94510362, 112712182, 130914002,  531,
     * 514269581,  86910562, 130716652, 215327742, 351843662,  532,
     * 100010001, 100010091, 109515351, 291060661, 119621482,  540,
     * 414844131, 465649111, 538464651,  87112232, 158019362,  541,
     * 615475101, 867797531, 112213462, 157618062, 203622662,  542,
     * 200020001, 201020501, 215623871, 283536181, 462756261,  550,
     * 100010001, 100310371, 119016501, 269146361,  77912412,  551,
     * 424445601, 481750061, 516953311, 549356551, 581759791,  552/
      data ((nudata(l,m),l=1,6),m=166,180)/
     * 101210791, 135119351, 282340571, 574580391, 111015062,  560,
     * 262638611, 504160621, 698579371,  91010692, 129115952,  561,
     * 100010001, 100310351, 118416321, 264945521,  76512182,  562,
     *  71111992, 172323592, 312540402, 510763182, 765791012,  570,
     * 204529582, 383647882, 582469262, 807992692, 104911723,  571,
     *  94712552, 148416582, 179819212, 203621522, 227424042,  572,
     * 295959132, 103515693, 215527593, 335939413, 449650223,  580,
     *  79718153, 289639443, 495159253, 686877533, 863794813,  581,
     * 298640242, 475053692, 596965912, 725379692, 872094692,  582,
     * 460693672, 158523823, 327242303, 519661563, 709379783,  590,
     * 455480232, 114014653, 178521013, 240927073, 299232633,  591,
     *  46410533, 183826893, 354443773, 518459633, 674375243,  592,
     * 139623042, 364860002,  96114603, 209828633, 373446973,  600,
     * 460493692, 158523823, 327142303, 519661563, 709279783,  601,
     * 455480232, 114014653, 178521013, 240927073, 299232633,  602/
      data ((nudata(l,m),l=1,6),m=181,195)/
     * 131720482, 280535692, 441254492, 676583972, 103412583,  610,
     * 139623042, 364860002,  96114603, 209828633, 373446973,  611,
     * 460493682, 158523823, 327142303, 519661563, 709279783,  612,
     *  92915672, 222431062, 444763802,  89612173, 159520253,  620,
     * 315059662,  97114563, 204627093, 342541693, 490556383,  621,
     * 269037812, 520270372,  91111273, 133915483, 172719093,  622,
     * 800080571, 851699301, 127617362, 240433032, 444958442,  630,
     * 125416052, 211828182, 375549622, 644381732, 101112213,  631,
     * 800080571, 851699301, 127617362, 240433032, 444958442,  632,
     * 240432982, 427555202, 708489962, 112613853, 167319843,  640,
     * 534793262, 139219123, 247730843, 371043333, 495055893,  641,
     * 364145232, 514756362, 604864112, 673870372, 732276072,  642,
     * 480767202,  89011393, 144118243, 230028753, 354142883,  650,
     * 480767192,  89011393, 144118243, 230028753, 354142883,  651,
     * 480767202,  89011393, 144118243, 230028753, 354142883,  652/
      data ((nudata(l,m),l=1,6),m=196,210)/
     * 343147532, 645887152, 115314793, 183322063, 257729373,  660,
     * 343147532, 645887142, 115314793, 183322063, 257729373,  661,
     * 343147532, 645887142, 115314793, 183322063, 257729373,  662,
     * 222635002, 542276772, 100312353, 145716713, 187020703,  670,
     * 222635002, 542276772, 100312353, 145716713, 187020703,  671,
     * 222635002, 542276772, 100312353, 145716713, 187020703,  672,
     * 133715382, 209130152, 429859382,  79410293, 129815983,  680,
     * 265934782, 497877532, 120517733, 245032063, 400448073,  681,
     * 265934782, 497877532, 120517733, 245032063, 400448073,  682,
     * 800381111,  87510702, 147621462, 310343462, 585475982,  690,
     * 156718872, 279244452, 678196342, 128316243, 197823443,  691,
     *  93517192, 364666132, 103414613, 192624193, 293334613,  692,
     * 100010011, 101310651, 118613951, 169120661, 250629971,  700,
     * 200120901, 270345231,  81714042, 223533112, 461959862,  701,
     * 100312561, 250851931,  91914182, 198626022, 323638692,  702/
      data ((nudata(l,m),l=1,6),m=211,225)/
     * 514664441, 759086851,  99211442, 133315612, 182721252,  710,
     * 125924831, 438667801,  98714112, 199727872, 380850742,  711,
     * 323948621, 661297271, 158626482, 426865032,  93712843,  712,
     * 659294081, 128016962, 222528952, 372047062, 585171462,  720,
     *  99117882, 274638812, 520867322,  84410313, 123314453,  721,
     * 187427702, 343739872, 448049452, 539358282, 625266642,  722,
     *  65210892, 171325762, 373552252, 705192012, 116414343,  730,
     * 192837842, 600784802, 111113823, 165419233, 218524383,  731,
     *  99117872, 274638812, 520867312,  84410313, 123314453,  732,
     * 398981651, 130019172, 273438022, 516168382,  88411163,  740,
     * 131429482, 523279952, 111414623, 183422233, 262130233,  741,
     * 192837842, 600784792, 111113823, 165419233, 218524383,  742,
     * 600963001,  75910412, 150121572, 301940972, 539168952,  750,
     *  73710852, 190731262, 464964142,  83810503, 127315053,  751,
     * 131429482, 523279952, 111414623, 183422233, 262130233,  752/
      data ((nudata(l,m),l=1,6),m=226,240)/
     * 110815502, 216829732, 398752322, 672484682, 104612673,  760,
     * 168225972, 362046562, 566766422, 757484612,  93010103,  761,
     *  73710852, 190731262, 464964142,  83810503, 127315053,  762,
     * 129117892, 239430882, 388748292, 596173252,  89510843,  770,
     * 110815502, 216829732, 398752322, 672484682, 104612673,  771,
     * 168225972, 362046562, 566766422, 757484612,  93010103,  772,
     * 158918512, 207523002, 254328242, 316335762, 407246582,  780,
     *  98115462, 224930742, 401150612, 623475412,  89910583,  781,
     * 110815502, 216829732, 398752322, 672484682, 104612673,  782,
     * 203222611, 265731251, 364042301, 494958601, 702084731,  790,
     * 120521331, 357753801,  75310062, 130516572, 206925452,  791,
     * 651780821, 108814772, 195925252, 316338622, 460853882,  792,
     * 100010001, 100110111, 105211851, 152122101, 341552811,  800,
     * 200320211, 210023021, 268834231, 480472341, 111416912,  801,
     * 104012871, 186129471, 458664151,  82410072, 119013732,  802/
      data ((nudata(l,m),l=1,6),m=241,255)/
     * 200420711, 222424271, 265429161, 325637371, 442853911,  810,
     * 100010021, 101910801, 121414641, 189525811, 358949721,  811,
     * 200020311, 216624611, 296337451, 489064791,  85711212,  812,
     * 103411711, 147819101, 244331781, 434862751,  93113762,  820,
     * 204122231, 248227841, 311535621, 429153941, 651976431,  821,
     * 100210131, 106812201, 154522671, 381665951,  95512512,  822,
     * 400140351, 416944121, 474851591, 564362181, 690477231,  830,
     * 106814451, 204427341, 350744811, 586879131, 108314772,  831,
     * 205523051, 264830231, 345439921, 469156001, 675281671,  832,
     * 500950661, 518153561, 559058941, 628968071, 748483501,  840,
     * 443756241, 696282451,  95411012, 128615262, 182922012,  841,
     * 336953201, 682481011,  93810882, 127915272, 184622442,  842,
     * 402841621, 431544771, 463148311, 520059491, 734896851,  850,
     * 576168741, 788387631,  96910642, 116012552, 135014462,  851,
     * 490265341, 812797201, 116614322, 179622692, 285035302,  852/
      data ((nudata(l,m),l=1,6),m=256,270)/
     * 100010001, 100010031, 102311051, 133018071, 264539391,  860,
     * 402841621, 431544771, 463148311, 520059491, 734996851,  861,
     * 576168741, 788387631,  96910642, 116012552, 135014462,  862,
     * 200020011, 201220591, 218124481, 296538611, 488859141,  870,
     * 100010001, 100010031, 102311051, 133018071, 264539401,  871,
     * 421645151, 477449611, 511852711, 542455761, 572958821,  872,
     * 100010041, 105212131, 153220271, 270435641, 460258111,  880,
     * 201221791, 258131471, 381645781, 546365131, 777592781,  881,
     * 100010001, 100010031, 102311051, 133018071, 264539391,  882,
     * 510064491,  82710872, 142718412, 232328712, 348341572,  890,
     * 228951571,  88513232, 183324132, 305537492, 448152402,  891,
     * 723989131, 103511752, 130814352, 155416652, 177018682,  892,
     * 620099241, 162725772, 391457072,  80110833, 141818023,  900,
     * 620099241, 162725772, 391457072,  80110833, 141818023,  901,
     * 620099251, 162725772, 391457072,  80110833, 141818023,  902/
      data ((nudata(l,m),l=1,6),m=271,285)/
     * 347877992, 129318323, 240730533, 380546863, 570368573,  910,
     * 347877992, 129318323, 240730533, 380546863, 570368573,  911,
     * 347777992, 129318323, 240730533, 380546863, 570368573,  912,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  920,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  921,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  922,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  930,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  931,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  932,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  940,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  941,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  942,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  950,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  951,
     * 209530092, 450866762,  96613623, 186524763, 318839893,  952/


      end
      subroutine begin
c***************************************************************************
c     This routine simply starts up MOOG
c***************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Pstuff.com'

c  clear the text screen, and define the number of lines available 
c  on the screen
c     call screenlength (maxline)
      maxline = 30
      if (maxline .lt. 10) then
         maxline = 24
      else
         maxline = maxline - 2
      endif
      call system('clear')

c  initialize some variables
      filemodel = 0
      filelines = 0
      fileslines = 0
      fileobs = 0
      nwrite = 0
      n2write = 0
      ndump = 0
      n2dump = 0
      nparam = 0

c  write a header and find the appropriate parameter file
      write (array,1001)
1001  format (79('*'))
c     istat = ivwrite (1,1,array,79)
      write (array,1004)
1004  format (29(' '),'MOOG (March 12, 1997)',29(' '))
c     istat = ivwrite (2,1,array,79)
c     array = 'WHAT IS YOUR PARAMETER FILE? ' 
c     nchars = 29
      nparam = 50     
c     call infile ('input  ',nparam,'formatted  ',0,nchars,3)

c AMcW. 12/Aug/2003
      open(unit=nparam,file='/export/home/andy/globulars/BMW2000/analysis/ILsrc/moog97/moogsub.par',status='old')

      read (nparam,1002) control
1002  format (a7)
      write (array,1003) control
1003  format (22x,'MOOG IS CONTROLLED BY DRIVER ',a7)
c     istat = ivwrite (2,1,array,58)
      write (array,1001)
c     istat = ivwrite (3,1,array,79)

      return
      end
      


      subroutine blends
c******************************************************************************
c     This program does abundance derivations from blended spectral features;
c     only one element will have its abundance derived per run.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Pstuff.com'
      integer sm_device
      character choice
 

c*****examine the parameter file
      call params


c*****set up the output files
      nwrite = 20     
      array = 'Give the filename for standard output: '
      nchars = 39
      call infile ('output ',nwrite,'formatted  ',0,nchars,4)
      ndump = 21               
      array = 'Give the filename for abundance summaries: '
      nchars = 43
      call infile ('output ',ndump,'formatted  ',0,nchars,6)


c*****set up the model atmosphere                                        
      filemodel = 30
      array = 'Give the filename for the model atmosphere: '
      nchars = 44
      call infile ('input  ',filemodel,'formatted  ',0,nchars,10)
      call inmodel


c*****initialize some variables
      isynth = 1
      isorun = 1
      iatom = int(cogatom)
      pec(iatom) = 1
      numpecatom = 1
      pecabund(iatom,1) = 0.
      if (numiso .gt. 0) call out (26)


c*****set up the line list
      filelines = 31
      array = 'Give the filename for the line list: '
      nchars = 37
      call infile ('input  ',filelines,'formatted  ',0,nchars,12)
      call inlines (1)
      call eqlib
      call nearly


c*****define the set of lines responsible for a blended feature
      ipr(5) = -1
      mode = 4
30    call linlimit
      lim1 = lim1line
      lim2 = lim2line


c*****make sure that the element whose abundance is to be fit has
c     a representative line of the blend
      do j=lim1,lim2
         if (atom1(j) .lt. 100.) then
            if (iatom .eq. int(atom1(j))) go to 10
         else
            call sunder (atom1(j),ia,ib)
            if (iatom.eq.ia .or. iatom.eq.ib) go to 10
         endif
      enddo
      do j=lim1,lim2
         abunout(j) = 999.99
      enddo
      write (nwrite,*) 'WARNING: NO ELEMENT LINE TO VARY IN BLEND'
      go to 29
 

c*****do the syntheses, forcing each abundance to predict the
c     feature equivalent width
10    ncurve = 1
      start = wave1(lim1) - delwave
      stop = wave1(lim2) + delwave
      delta = wave1(lim2) - wave1(lim1) + delwave
      oldstart = start
      oldstop = stop
      oldstep = step
      olddelta = delta
      rwlgobs = dlog10(width(lim1)/wave1(lim1))
      gf1(ncurve) = 1.
15    call synspec
      call total
      error = (w(ncurve)-width(lim1))/width(lim1)
      ratio = width(lim1)/w(ncurve)
      ncurve = ncurve + 1


c*****here we go for another iteration
      if (dabs(error) .ge. 0.0075) then
         rwlcomp = dlog10(w(ncurve-1)/wave1(lim1))
         if     (rwlcomp.lt.-5.2 .and. rwlgobs.lt.-5.2) then 
            ratio = ratio
         elseif (rwlcomp.ge.-5.2 .and. rwlgobs.ge.-5.2) then 
            ratio = ratio**2.0
         else   
            ratio = ratio**1.5
         endif
         gf1(ncurve) = gf1(ncurve-1)*ratio
         do j=lim1,lim2
            if (atom1(j) .gt. 100.) then
               call sunder (atom1(j),ia,ib)
               if (ia.eq.iatom .or. ib.eq.iatom) then
                  do i=1,ntau                                
                     kapnu0(j,i) = kapnu0(j,i)*ratio            
                  enddo
               endif
            elseif (int(atom1(j)) .eq. iatom) then
               do i=1,ntau                                
                  kapnu0(j,i) = kapnu0(j,i)*ratio            
               enddo
            endif
         enddo
         go to 15
      else


c*****here we do the final calculation when the predicted and observed are close
         gf1(ncurve) = gf1(ncurve-1)*ratio
         do j=lim1,lim2
            if (atom1(j) .gt. 100.) then
               call sunder (atom1(j),ia,ib)
               if (ia.eq.iatom .or. ib.eq.iatom) then
                  do i=1,ntau                                
                     kapnu0(j,i) = kapnu0(j,i)*ratio            
                  enddo
               endif
            elseif (int(atom1(j)) .eq. iatom) then
               do i=1,ntau                                
                  kapnu0(j,i) = kapnu0(j,i)*ratio            
               enddo
            endif
         enddo
         call synspec
         call total
         widout(lim1) = w(ncurve)
         diff = dlog10(gf1(ncurve))
         abunout(lim1) = dlog10(xabund(iatom)) + 12.0 + diff
      endif
      call out (24)


c*****assign the abundance to the strongest line of the blend that
c     contains cogatom; put 999.99's as the abudnances of all but 
c     this line; go back for another blended feature
      if (lim2 .gt. lim1) then
         abunblend = abunout(lim1)
         widblend = widout(lim1)
         strongest = 0.
         linstrongest = 0
         do j=lim1,lim2
            abunout(j) = 999.99
         enddo
         do j=lim1,lim2
            if (atom1(j) .lt. 100.) then
               if (dint(atom1(j)) .eq. cogatom) then
                  if (kapnu0(j,jtau5) .gt. strongest) then
                     strongest = kapnu0(j,jtau5)
                     linstrongest = j
                  endif
               endif
            else
               call sunder (atom1(j),ia,ib)
               if (dble(ia).eq.cogatom .or. dble(ib).eq.cogatom) then
                  if (kapnu0(j,jtau5) .gt. strongest) then
                     strongest = kapnu0(j,jtau5)
                     linstrongest = j
                  endif
               endif
            endif
         enddo
         abunout(linstrongest) = abunblend
         widout(linstrongest) = widblend
      endif
29    lim1line = lim2line + 1
      if (lim1line .le. nlines) go to 30


c*****do abundance statistics; print out a summary of the abundances 
      lim1obs = 1
      lim2obs = nlines
      call stats
      rewind ndump

c
c curt mode AMcW 2/2000
c
      if (curt) then
         call out (29)
      else
         call out (25)
      endif


c*****here a plot may be made on the terminal (and paper) if there
c     are enough lines
      if (kount .ge. ipr(7)) then
55       choice = 'y'
         if (sm_device(smterm) .lt. 0) then
            write (nwrite,1006) smterm
1006        format ('DEVICE OPENING ERROR FOR:',a54)
            stop
         endif
         call sm_graphics
         call sm_erase
         call linplot (choice)
         call sm_gflush
         call sm_alpha
         array = '   MAKE A HARDCOPY OF THIS PLOT ([n]/h/f/r)? '
         ikount = min0(nlines+11,maxline)
         nchars = 45
         call getasci (nchars,ikount)
         choice = chinfo(1:1)
         if (choice.eq.'n' .or. nchars.le.0) then
            go to 60
         elseif (choice .eq. 'h') then
            if (sm_device('postport') .lt. 0) then
               write (nwrite,1008)
1008           format ('DEVICE OPENING ERROR FOR: postport')
               stop
            endif
            call sm_graphics
            call sm_erase
            call linplot (choice)
            call sm_gflush
            call sm_alpha
            call sm_hardcopy
         elseif (choice .eq. 'r') then
            go to 55
         elseif (choice .eq. 'f') then
            array =
     .        'Give the file name for the POSTSRIPT plot image: '
            nchars = 49
            ikount = min0(nlines+12,maxline)
            call getasci (nchars,ikount)
            write (array,1005) chinfo(1:nchars)
1005        format ('postfile ',a71)
            if (sm_device(array(1:nchars+9)) .lt. 0) then
               write (nwrite,1007) array(1:nchars+9)
1007           format ('FILE OPENING ERROR FOR:',a56)
               stop
            endif
            call sm_graphics
            call sm_erase
            call linplot (choice)
            call sm_gflush
            call sm_alpha
            call sm_hardcopy
         endif
      endif


c*****now the option will be to redo the molecular equilibrium and redo
c     the last species, at the user's option.
60    if (neq .ne. 0) then
         do n=1,neq
            if (iatom .eq. iorder(n)) then
               write (array,1004)
1004           format ('SPECIES USES MOLECULAR EQUILIBRIUM!',
     .               '  REDO WITH NEW ABUNDANCE ([y]/n)? ')
               ikount = min0(nlines+11,maxline)
               nchars = 70
35             call getasci (nchars,ikount)
               choice = chinfo(1:1)
               if (choice.eq.'y' .or. nchars.le.0) then
                  xabund(iatom) = 10.**(average-12.)
                  call eqlib
                  call nearly
                  lim1line = 0
                  lim2line = 0
                  rewind ndump
                  go to 30
               elseif (choice .eq. 'n') then
                  go to 36
               else
                  go to 35
               endif
            endif
         enddo
      else
      endif
 

c*****exit the program
36    call finish

      end                                                                








      block data molec                                                   
c******************************************************************************
c     This routine contains molecular equilibrium constant data for         
c     most common diatomic and triatomic molecules. the source for this     
c     data is kurucz(1970,sao special report =309(atlas)). the ionized      
c     atom equilibrium data was done via a least squares fit to the         
c     relevant saha equation data                                           
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Eqdata.com'

      data ((datmol(i,j),i=1,7),j=1,10)/                                 
     1   101.0, 4.477,46.628,.0018031,5.0239d-7,8.1424d-11,5.0501d-15,   
     2   106.0, 3.470,45.506,.0017112,3.6319d-7,5.0164d-11,2.8716d-15,   
     3   107.0, 3.699,45.244,.0018435,4.9000d-7,7.7353d-11,4.7639d-15,   
     4   108.0, 4.395,45.746,.0017004,4.4905d-7,7.0861d-11,4.3648d-15,   
     5   109.0, 5.844,46.618,.0015382,4.0410d-7,6.4407d-11,3.9816d-15,   
     6   111.0, 2.050,44.709,.0024163,6.1037d-7,9.0492d-11,5.3705d-15,   
     7   112.0, 1.999,43.437,.0022153,5.4885d-7,8.1160d-11,4.8026d-15,   
     8   113.0, 2.901,45.688,.0018402,4.1240d-7,5.7606d-11,3.2768d-15,   
     9   114.0, 3.190,44.770,.0016858,3.7373d-7,5.0857d-11,2.8282d-15,   
     *   115.0, 3.300,44.680,.0018959,4.6737d-7,6.8061d-11,4.0256d-15/   
      data ((datmol(i,j),i=1,7),j=11,20)/                                
     1   116.0, 3.530,45.272,.0018600,4.7327d-7,7.1690d-11,4.3041d-15,   
     2   117.0, 4.431,45.886,.0015637,3.9598d-7,6.2107d-11,3.8283d-15,   
     3   156.0, 1.963,48.973,.0079685,2.7435d-6,4.2067d-10,2.3926d-14,   
     4   606.0, 6.156,49.635,.0034811,1.0492d-6,1.6849d-10,1.0370d-14,   
     5   607.0, 8.109,47.853,.0018656,4.6185d-7,7.1497d-11,4.3750d-15,   
     6   608.0,11.108,49.170,.0015802,3.4347d-7,4.6870d-11,2.6563d-15,   
     7   609.0, 4.966,47.368,.0020173,4.7759d-7,6.7404d-11,3.8474d-15,   
     8   614.0, 4.572,48.754,.0035601,1.0081d-6,1.5304d-10,9.0367d-15,   
     9   615.0, 6.895,47.509,.0021172,4.9533d-7,7.2805d-11,4.4007d-15,   
     *   616.0, 7.892,48.547,.0017379,3.6954d-7,4.7608d-11,2.5585d-15/   
      data ((datmol(i,j),i=1,7),j=21,30)/                                
     1   617.0, 3.340,47.009,.0024592,6.5348d-7,9.8261d-11,5.8172d-15,   
     2   707.0, 9.763,48.696,.0019224,4.9143d-7,7.4692d-11,4.5399d-15,   
     3   708.0, 6.508,47.365,.0019840,4.9280d-7,7.2933d-11,4.3354d-15,   
     4   709.0, 2.819,46.770,.0022411,5.5102d-7,7.9899d-11,4.6459d-15,   
     5   714.0, 4.510,47.147,.0018720,4.1254d-7,5.3950d-11,2.9053d-15,   
     6   715.0, 7.111,47.683,.0022458,5.5753d-7,7.9113d-11,4.5753d-15,   
     7   716.0, 4.987,46.988,.0022584,5.7344d-7,8.3948d-11,4.9197d-15,   
     8   808.0, 5.116,48.625,.0016321,3.3915d-7,4.6025d-11,2.5839d-15,   
     9   811.0, 3.079,46.421,.0026221,6.8505d-7,1.0200d-10,6.0540d-15,   
     *   812.0, 3.903,46.567,.0023003,4.3846d-7,5.3231d-11,2.8469d-15/   
      data ((datmol(i,j),i=1,7),j=31,40)/                                
     1   813.0, 4.987,47.561,.0020103,4.5650d-7,6.2393d-11,3.4674d-15,   
     2   814.0, 8.310,48.477,.0015511,2.9069d-7,3.2807d-11,1.5486d-15,   
     3   815.0, 6.071,47.307,.0024172,6.2096d-7,8.9966d-11,5.2500d-15,   
     4   816.0, 5.358,47.488,.0016987,3.5057d-7,4.4497d-11,2.3647d-15,   
     5   817.0, 2.745,46.832,.0021078,5.1344d-7,7.4414d-11,4.3173d-15,   
     6   820.0, 4.531,50.527,.0074374,2.3974d-6,3.5772d-10,2.0047d-14,   
     7   821.0, 7.306,52.654,.0060415,1.9244d-6,2.8695d-10,1.6091d-14,   
     8   822.0, 6.830,47.631,.0020874,4.7332d-7,5.7902d-11,2.9381d-15,   
     9   823.0, 6.569,50.643,.0041044,1.2921d-6,1.9374d-10,1.0920d-14,   
     *   826.0, 4.332,49.277,.0040230,1.2204d-6,1.8023d-10,1.0079d-14/   
      data ((datmol(i,j),i=1,7),j=41,50)/                                
     1   839.0, 7.580,51.213,.0050437,1.5844d-6,2.3594d-10,1.3235d-14,   
     2   840.0, 8.470,51.595,.0039656,1.0769d-6,1.5053d-10,8.1571d-15,   
     3   856.0, 5.441,51.013,.0083594,2.8713d-6,4.3961d-10,2.4982d-14,   
     4   857.0, 8.302,45.838,.00052777,9.087d-8,1.5004d-11,9.6821d-16,  
     5   909.0, 1.592,48.632,.0020165,4.6054d-7,6.4288d-11,3.6296d-15,   
     6   911.0, 4.953,46.717,.0027566,7.4062d-7,1.1213d-10,6.7066d-15,   
     7   912.0, 3.200,45.468,.0025089,6.5244d-7,9.7170d-11,5.7561d-15,   
     8   913.0, 6.790,47.788,.0021362,5.0666d-7,7.1400d-11,4.0530d-15,   
     9   914.0, 5.420,46.897,.0021060,4.9864d-7,6.8598d-11,3.7971d-15,   
     *   916.0, 3.338,46.706,.0019206,4.3001d-7,5.8063d-11,3.2077d-15/   
      data ((datmol(i,j),i=1,7),j=51,60)/                                
     1   917.0, 2.616,47.680,.0021411,5.3239d-7,7.8152d-11,4.5625d-15,   
     2  1111.0, 0.730,45.152,.0036917,1.0752d-6,1.7017d-10,1.0459d-14,   
     3  1117.0, 4.222,46.147,.0030037,8.5128d-7,1.3301d-10,8.0960d-15,   
     4  1216.0, 2.901,46.082,.0026137,6.8845d-7,1.0253d-10,6.0759d-15,   
     5  1217.0, 2.701,44.998,.0028447,7.9686d-7,1.2369d-10,7.4944d-15,   
     6  1313.0, 1.604,47.559,.0029097,7.7812d-7,1.1753d-10,6.9499d-15,   
     7  1317.0, 5.074,47.276,.0025438,6.7568d-7,1.0182d-10,6.0055d-15,   
     8  1414.0, 3.252,47.179,.0020256,4.5186d-7,5.7418d-11,2.9577d-15,   
     9  1416.0, 6.418,47.989,.0017935,3.7532d-7,4.5974d-11,2.3242d-15,   
     *  1417.0, 4.002,46.541,.0025534,6.8459d-7,1.0209d-10,5.9733d-15/   
      data ((datmol(i,j),i=1,7),j=61,70)/                                
     1  1515.0, 5.033,48.223,.0026898,7.0362d-7,1.0075d-10,5.8493d-15,   
     2  1516.0, 5.637,46.919,.0027644,7.4350d-7,1.0948d-10,6.4205d-15,   
     3  1616.0, 4.380,47.693,.0019029,4.2359d-7,5.5948d-11,3.0438d-15,   
     4  1617.0, 2.749,47.565,.0035631,1.0897d-6,1.7573d-10,1.0805d-14,   
     5  1622.0, 4.872,50.656,.0053777,1.7297d-6,2.5989d-10,1.4647d-14,   
     6  1717.0, 2.476,48.021,.0024184,6.5374d-7,1.0061d-10,6.0420d-15,   
     7 10106.0, 8.850,93.457,.0022374,2.9465d-7,2.7708d-11,1.2186d-15,   
     8 10107.0, 7.598,92.007,.0030986,6.6915d-7,8.8676d-11,4.7423d-15,   
     9 10108.0, 9.511,93.163,.0026530,5.6946d-7,8.3927d-11,5.0416d-15,   
     * 10116.0, 7.514,92.053,.0027514,5.1218d-7,6.6192d-11,3.6540d-15/   
      data ((datmol(i,j),i=1,7),j=71,80)/                                
     1 10607.0,13.135,96.088,.0034106,6.7378d-7,8.7666d-11,4.8365d-15,   
     2 10608.0,12.311,94.191,.0030252,5.9689d-7,7.7220d-11,4.2351d-15,   
     3 10708.0, 8.614,94.281,.0032692,6.8008d-7,9.1500d-11,5.1621d-15,   
     4 10811.0, 8.286,92.701,.0043703,1.0975d-6,1.6241d-10,9.6222d-15,   
     5 10812.0, 6.823,91.448,.0039729,9.4759d-7,1.3688d-10,8.0099d-15,   
     6 10813.0,10.010,96.515,.0034484,6.7061d-7,8.1548d-11,4.1211d-15,   
     7 10819.0, 8.199,96.060,.0070073,2.0004d-6,2.8864d-10,1.5954d-14,   
     8 10820.0, 8.927,93.254,.0050309,1.2144d-6,1.7088d-10,9.8677d-15,   
     9 10856.0, 9.517,97.093,.0094370,3.0094d-6,4.5220d-10,2.5505d-14,   
     * 60606.0,13.957,100.81,.0039913,8.1028d-7,1.0167d-10,5.3621d-15/   
      data ((datmol(i,j),i=1,7),j=81,90)/                                
     1 60614.0,13.017,99.438,.0048832,1.1397d-6,1.5810d-10,8.7772d-15,   
     2 60717.0,12.126,98.836,.0048687,1.1673d-6,1.6627d-10,9.5674d-15,   
     3 60808.0,16.561,100.97,.0033659,5.7770d-7,6.3873d-11,3.0525d-15,   
     4 60816.0,14.210,100.00,.0039763,7.8058d-7,9.5929d-11,4.9686d-15,   
     5 60909.0,10.268,97.787,.0037637,7.7313d-7,9.9261d-11,5.3065d-15,   
     6 61616.0,11.881,100.44,.0045422,9.8359d-7,1.2836d-10,6.9210d-15,   
     7 70708.0,11.440,99.172,.0039917,8.1117d-7,1.0518d-10,5.7309d-15,   
     8 70808.0, 9.621,97.617,.0036891,7.5141d-7,9.6734d-11,5.2293d-15,   
     9 70909.0, 6.056,96.316,.0044386,1.0275d-6,1.4206d-10,7.9873d-15,   
     * 80814.0,13.447,100.04,.0037484,6.5483d-7,6.8677d-11,3.0007d-15/   
      data ((datmol(i,j),i=1,7),j=91,100)/                               
     1 80816.0,11.035,98.439,.0037916,7.3774d-7,8.4919d-11,3.9520d-15,   
     2 80822.0,12.649,101.61,.0044962,9.5103d-7,1.1608d-10,5.9492d-15,   
     3 80839.0,15.280,103.10,.0078719,2.1760d-6,3.0785d-10,1.6822d-14,   
     4 80840.0,14.477,97.447,.0043826,1.0801d-6,1.4349d-10,7.5468d-15,   
     5 80857.0,15.953,98.258,.0038781,8.7169d-7,1.1604d-10,6.2093d-15,   
     6 81313.0,10.747,101.28,.0077819,2.1646d-6,3.0703d-10,1.6794d-14,   
     7 28*0.0/                                                          
      end                                                                
      subroutine calmod                   
c*********************************************************************   
c*****this program re-calculates BEGN models on a tau5000 scale.

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Chars.com'

c*****set up the output files
      nwrite = 20     
      array = 'Give the filename for standard output:'
      nchars = 38
      call infile ('output ',nwrite,'formatted  ',0,nchars,4)
      ndump = 21               
      array = 'Give the filename for raw syntheses output:'
      nchars = 43
      call infile ('output ',ndump,'formatted  ',0,nchars,6)

c*****set up the model atmosphere                                        
      filemodel = 4
      array = 'Give the filename for the model atmosphere:'
      nchars = 43
      call infile ('input  ',filemodel,'formatted  ',0,nchars,8)
      call inmodel
      call opacit(2,wavref)   
      write (ndump,1001) wavref,(taulam(i),t(i),pgas(i),
     .                ne(i),kaplam(i),i=1,ntau)
1001  format ('output model for wavelength = ',f5.0/
     .        (1pe11.4,0pf7.0,1p3e11.4))

      return
      end                                                                

      subroutine cdcalc (number)                                          
c******************************************************************************
c     this routine calculates continuum and line+continuum                  
c     contribution functions
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'

c*****continuum "contribution curve" calculation                           
      if (number .eq. 1) then
         do i=1,ntau                                                     
            scont(i) = ((1.19089d+25/wave**2)*1.0d+10)/(wave**3*
     .                 (dexp(1.43879d+08/(wave*t(i)))-1.0d+00))
            if (ipr(4) .eq. 1) then
               cd(i) = kaplam(i)*tauref(i)*scont(i)*
     .                 dexp(-taulam(i))/(0.4343*kapref(i))
            else
               cd(i) = 2.0*kaplam(i)*tauref(i)*scont(i)*
     .                 expint(taulam(i),2)/(0.4343*kapref(i))
            endif
         enddo
                       
c*****line plus continuum "contribution curve" calculation    
      else
         do i=1,ntau                                                     
            sline(i) = scont(i)   
            if (ipr(4) .eq. 1) then
               if (taulam(i)+taunu(i) .le. 50.) then
                  exptau = dexp(-taulam(i)-taunu(i))                
               else
                  exptau = 0.                        
               endif
               cd(i) = tauref(i)*kaplam(i)/(0.4343*flux*
     .                 kapref(i))*(scont(i)*dexp(-taulam(i)) - 
     .                 (1.0+kapnu(i)/kaplam(i))*sline(i)*exptau)    
            else
               cd(i) = 2.0*tauref(i)*kaplam(i)/(0.4343*flux*
     .                 kapref(i))*(scont(i)*expint(taulam(i),2) - 
     .                 (1.0+kapnu(i)/kaplam(i))*sline(i)*
     .                 expint(taulam(i)+taunu(i),2)) 
            endif
         enddo
      endif

      return
      end                                                                

      subroutine chabund
c*****************************************************************************
c  this routine changes the input abundances according to the users request
c  and the re-runs the synthesis with the new abundances OVERWRITING the 
c  original output files, but using the same model, linelist, etc
c*****************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      integer newpec(100),newnumpecatom,newnumatomsyn,
     .     newnumiso,newnumisosyn
      real*8 newpecabund(100,5), newisoabund(20,5), newisotope(20)
      real*8 xnum
      character choice,choice2


c*****set the local temporary parameters to what they were for the last synth
      newnumiso = numiso
      newnumisosyn = numisosyn
      newnumpecatom = numpecatom
      newnumatomsyn = numatomsyn
      if (newnumatomsyn .eq. 0) newnumatomsyn = 1
      do i=1,100
         newpec(i) = pec(i)
         do j=1,newnumatomsyn
            newpecabund(i,j) = pecabund(i,j)
         enddo
      enddo
      do i=1,newnumiso
         if(newnumiso .ge. 1) then
            newisotope(i)=isotope(i)
            do j=1,newnumisosyn
               newisoabund(i,j)=isoabund(i,j)
            enddo
         endif
      enddo



c*****find out if the "synth" driver is being used
      if (newnumatomsyn .le. 0) newnumatomsyn = 1
      if (control .eq. 'synth') then


c*****for "synth", present the user with the current abundance alterations, 
c     and the options; find out what is desired
1        istat = ivcleof(5,1)
         array = 'Here are the Alterations to the Abundances'
         istat = ivwrite(5,5,array,50)
         array = 'Atom   Abundance (relative to initial model)'
         istat = ivwrite(6,1,array,50)
         line = 6
         do i=1,100
            if(newpec(i) .eq. 1) then
               line = line + 1
               write (array,1001) i,(newpecabund(i,j),j=1,newnumatomsyn)
1001           format (i3,4x,5(f5.2,2x))
               istat = ivwrite(line,1,array,50)
            endif
         enddo
         array = 'Options: c = change abundances  l = list '
         istat = ivwrite(line+1,1,array,50)
         array = '         i = change isotopic ratios'
         istat = ivwrite(line+2,1,array,50)
         array = '         n = change number of synthesis'
         istat = ivwrite(line+3,1,array,50)
         array = '         x = exit no changes    q = rerun synth'
         istat = ivwrite(line+4,1,array,50)
         array = 'What is your choice? '
         nchars = 21
         call getasci (nchars,line+5)
         choice = chinfo(1:1)

         
c*****for "synth", change an abundance
         if (choice .eq. 'c') then
20          istat = ivcleof(line+1,1)
            array = 'Which element to change? '
            nchars = 25
            call getasci (nchars,line+1)
            call number (nchars,line+1,xnum)
            if (xnum.eq.-9999.0 .or. xnum.ge.100.) go to 20
            j = int(xnum)
            if (newpec(j) .eq. 1) then
25             array = 'n = new abundances, or z = zero offsets? '
               nchars = 41
               call getasci (nchars,line+2)
               choice = chinfo(1:1)
               if (choice .eq. 'z') then 
                  newpec(j) = 0
                  do i=1,5
                     newpecabund(j,i) = 0.0
                  enddo
                  newnumpecatom = newnumpecatom - 1
               elseif (choice .eq. 'n') then
                  array = 'Enter the new offsets on the line below:'
                  istat = ivwrite(line+3,1,array,50)
                  read (*,*) (newpecabund(j,i),i=1,newnumatomsyn)
               else
                  go to 25
               endif
            else
               newpec(j) = 1
               array = 'Enter the new offsets on the line below'
               istat = ivwrite(line+2,1,array,50)
               read (*,*) (newpecabund(j,i),i=1,newnumatomsyn) 
               newnumpecatom = newnumpecatom + 1
            endif


c*****for "synth", change an isotopic ratio
         else if (choice .eq. 'i') then
2           istat = ivcleof(5,1)
            array = 'The Current Isotope Ratios'
            istat = ivwrite(5,5,array,50)
            array = 'Number  Isotope  Ratio'
            istat = ivwrite(6,2,array,50)
            line = 6
            do i=1,newnumiso
               line = line + 1
               write(array,1002) i,newisotope(i),newisoabund(i,1)
1002           format(i2,2x,f8.4,2x,f5.2)
               istat = ivwrite(line,1,array,50)
            enddo
            array = 'Options: c = change one of these ratios'
            istat = ivwrite(line+1,1,array,50)
            array = '         n = enter new isotope'
            istat = ivwrite(line+2,1,array,50)
            array = '         q = accept these changes'
            istat = ivwrite(line+3,1,array,50)
30          array = 'What is your choice? '
            nchars = 21
            call getasci (nchars,14)
            choice2 = chinfo(1:1)
            if (choice2 .eq. 'c') then
35             array =  'Which number from the list? '
               nchars = 28
               call getasci (nchars,line+1)
               call number (nchars,line+1,xnum)
               if (xnum.eq.-9999.0 .or. 
     .             xnum.gt.dble(newnumiso)) go to 35
               i = int(xnum)
40             array = 'What is the new ratio? '
               nchars = 23
               call getasci (nchars,line+2)
               call number (nchars,line+2,xnum)
               if (xnum.eq.-9999.) go to 40
               newisoabund(i,1) = xnum
            elseif (choice2 .eq. 'n') then
45             array = 'What isotope? '
               nchars = 14
               call getasci (nchars,line+1)
               call number (nchars,line+1,xnum)
               if (xnum.eq.-9999.0 .or. xnum.lt.100.) go to 45
               newisotope(newnumiso+1) = xnum
50             array = 'What is the ratio? '
               nchars = 29
               call getasci (nchars,line+2)
               call number (nchars,line+2,xnum)
               if (xnum.eq.-9999.) go to 50
               newisoabund(i,1) = xnum
               newnumiso = newnumiso + 1
            elseif  (choice2 .eq. 'q') then
               go to 1
            else
               go to 2
            endif
            

c*****for "synth", change the number of syntheses
         else if (choice .eq. 'n') then
55          array = 'How many synths? '
            nchars = 17
            call getasci (nchars,line+5)
            call number (nchars,line+5,xnum)
            if (xnum.eq.-9999.0 .or. xnum.gt.5.) go to 55
            newnumatomsyn = int(xnum)


c*****for "synth", exit the routine without changing anything
         else if (choice .eq. 'x') then
            return


c*****for "synth", make the proposed alterations permanent; then
c     rerun the syntheses, then exit back to the plotting routine
         else if (choice .eq. 'q') then
            numiso = newnumiso
            numisosyn = newnumisosyn
            numpecatom = newnumpecatom
            numatomsyn = newnumatomsyn
            do i=1,99
               pec(i) = newpec(i)
               do j=1,numatomsyn
                  pecabund(i,j) = newpecabund(i,j)
               enddo
            enddo
            do i=1,numiso
               if(numiso .ge. 1) then
                  isotope(i) = newisotope(i)
                  do j=1,numisosyn
                     isoabund(i,j)=newisoabund(i,j)
                  enddo
               endif
            enddo
            call resynth
            return
         else
            go to 1
         endif


c*****for "synth", the main menu will keep reappearing until "q" or "x" is hit
         go to 1
         
         
c*****for "isotope", simply list the current isotopic ratios and return to the
c     plotting routine
      else if (control .eq. 'isotope') then
         istat = ivcleof(5,1)
         array = 'Here are the Current Isotopic Ratios'
         istat = ivwrite(5,5,array,35)
         array = 'Number    Isotope      Ratio (parent/isotope)'
         istat = ivwrite(6,1,array,39)
         line = 7
         do i=1,newnumiso
               line = line + 1
               write (array,1003) i,newisotope(i),(newisoabund(i,j),
     .                            j=1,newnumisosyn)
1003           format(i2,8x,f8.4,5(3x,f3.2))
               istat = ivwrite(line,1,array,50)
         enddo
         
        
c*****inform the user that no other driver is handled here 
      else 
         array = 'This feature disabled under this driver'      
         nchars = 39
         istat = ivwrite(23,3,array,nchars)
      endif

      
c*****ext from the routine
      return
      end


      subroutine cog
c******************************************************************************
c     This routine produces sets of curves of growth                    
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'


c*****examine the parameter file
      call params


c*****set up the output files
      nwrite = 20     
      array = 'Give the filename for standard output: '
      nchars = 39
      call infile ('output ',nwrite,'formatted  ',0,nchars,4)
      ndump = 21               
      array = 'Give the filename for summary curves-of-growth: '
      nchars = 48
      call infile ('output ',ndump,'formatted  ',0,nchars,6)


c*****set up the model atmosphere                                        
      filemodel = 30
      array = 'Give the filename for the model atmosphere: '
      nchars = 44
      call infile ('input  ',filemodel,'formatted  ',0,nchars,8)
      call inmodel
      call eqlib


c*****read in the line data; get ready to do the curves of growth
      filelines = 31
      array = 'Give the filename for the line list: '
      nchars = 37
      call infile ('input  ',filelines,'formatted  ',0,nchars,10)
      call inlines (1)
      call eqlib
      call nearly
 

c*****define the range of lines (the whole list, in this case)
      mode = 1
      call linlimit
      if (lim1line .lt. 0) then
         call finish
         return
      endif

 
c*****do the curves of growth
      do lim1=lim1line,lim2line
         lim2 = lim1
         call curve                                                        
      enddo


c****end the computations
      call finish
      return
      end                                                               


      subroutine cogsyn
c******************************************************************************
c     This program produces a curve-of-growth of a blended feature,
c     altering only a specified species' abundance.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'

c*****examine the parameter file
      call params

c*****set up the output files
      nwrite = 20     
      array = 'Give the filename for standard output: '
      nchars = 39
      call infile ('output ',nwrite,'formatted  ',0,nchars,4)
      ndump = 21               
      array = 'Give the filename for raw syntheses output: '
      nchars = 44
      call infile ('output ',ndump,'formatted  ',0,nchars,6)

c*****set up the model atmosphere                                        
      filemodel = 30
      array = 'Give the filename for the model atmosphere: '
      nchars = 44
      call infile ('input  ',filemodel,'formatted  ',0,nchars,10)
      call inmodel

c*****do the syntheses
      filelines = 31
      array = 'Give the filename for the line list: '
      nchars = 37
      call infile ('input  ',filelines,'formatted  ',0,nchars,12)
      call eqlib
      isynth = 1
      isorun = 1
      ncurve = 0
      iatom = int(cogatom)
      pec(iatom) = 1
      numpecatom = 1
      pecabund(iatom,1) = 0.
10    ncurve = ncurve + 1
      nlines = 0
      call synspec
      call total
      if (ncurve .eq. 1) then
         wstart = 10.**(rwlow)*wave1(lim1)
         wstop = 10.**(rwhigh)*wave1(lim1)
      endif
      ipr(2) = 1
      ipr(3) = 0
      if (w(ncurve) .gt. wstart) then
         pecabund(iatom,1) = pecabund(iatom,1) - rwstep
         go to 10
      endif

      pecabund(iatom,1) = rwstep
20    ncurve = ncurve + 1
      nlines = 0
      call synspec
      call total
      ipr(2) = 1
      ipr(3) = 0
      if (w(ncurve) .lt. wstop) then
         pecabund(iatom,1) = pecabund(iatom,1) + rwstep
         go to 20
      endif


         
c*****finish
      call finish
      end                                                                







      subroutine curve                                                   
c******************************************************************************
c     This routine produces a curve-of-growth for a single line          
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'


c*****set up the parameters 
      ipr(5) = -1
      ncurve = 1                                                         
      dec = 10.**(rwstep)                                                
      wstart = 10.**(rwlow)*wave1(lim1)
      wstop = 10.**(rwhigh)*wave1(lim1)
      gf1(ncurve) = gf(lim1)                                                  

 
c*****increment the log(gf) value backward by rwstep and redo the calculations 
c     until the end (rwlow) is reached
31    call oneline (2)                                                   
      if (w(ncurve) .gt. wstart) then
         gf1(ncurve) = gf1(ncurve)/dec
         do i=1,ntau                                                     
            kapnu0(lim1,i) = kapnu0(lim1,i)/dec
         enddo
         go to 31
      endif
      go to 61
 

c*****increment the log(gf) value forward by rwstep and redo the calculations 
c     until the end (rwhigh) is reached
60    gf1(ncurve) = gf1(ncurve-1)*dec                                    
      do i=1,ntau                                                     
         kapnu0(lim1,i) = kapnu0(lim1,i)*dec                                
      enddo
61    call oneline (1)                                                   
      if (w(ncurve) .lt. wstop) then
         ncurve = ncurve + 1
         go to 60
      endif
 

c*****end the computations with a summary print
      call out(18)                                     
      return                                                             
      end                                                                



      subroutine discov(amol,i1,i2)
c******************************************************************************
c     This routine returns i2 = the number of times atom i1 appears in      
c     molecule amol                                                         
c******************************************************************************

      implicit real*8 (a-h,o-z)
      dimension itest(5)                                                 
      data itest/100000000,1000000,10000,100,1/                          
      i2 = 0                                                             
      im = amol                                                          
      do 2 i=1,5                                                         
      i3 = im/itest(i)                                                   
      if(i3 .eq. i1) i2 = i2 + 1                                         
      im = im - i3*itest(i)                                              
2     continue                                                           
      return                                                             
      end                                                                
      subroutine eqlib                                                   
c******************************************************************************
c     This routine solves the equations of molecular dissociative           
c     equilibrium. the equations can include neutral and ionized molecules  
c     and atoms 
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Mol.com'
      include 'Quants.com'
      include 'Eqdata.com'
      dimension ident(10,40),xfic(10),xcorr(10),deltax(10),c(10,10),     
     1 ans(10,10)                                                        


c*****start by deciding if molecular equilibrium is desired
      if (ipr(2) .le. 0) return


c*****clear the arrays 
      iorder(1) = 0                                                
      neq = iorder(1) 
      tdel = (t(ntau)-t(1))/4.0 + 1.0                                    
      if (ipr(2) .lt. 1) return                                           
      do k=1,10                                                       
         iorder(k) = 0                                                      
         xcorr(k) = 0.                                                      
         do kk=1,40                                                      
            ident(k,kk) = 0                                                    
         enddo
      enddo


c*****read in the dissociation data                                         
      do jmol=1,nmol                                                   
         if (amol(jmol) .ge. 100.) then
            do k=1,100                                                       
               if (datmol(1,k) .eq. amol(jmol)) go to 11                   
            enddo
            write (nwrite,1001) amol(jmol)                   
            write (*,1001) amol(jmol)                   
1001        format ('I do not know this molecule: ',f10.0)                    
            stop                                                               
11          do kk=1,6                                                       
               const(kk,jmol) = datmol(kk+1,k)                            
            enddo 
         else
            iatom1 = amol(jmol)                                                
            const(1,jmol) = xchi1(iatom1)                                      
            do m=1,5                                                        
               ti = t(1) + (m-1)*tdel                                    
               atom = iatom1                                            
               it = ti                                                      
               u1 = partfn(atom,it)                                 
               u2 = partfn(atom+0.1,it)                                   
               const(m+1,jmol) = u2/u1                             
            enddo 
         endif
      enddo
      if (ipr(2) .ge. 2) call out (5)                                      


c*****set up the molecular equilibrium array. each element of array         
c*****'ident' contains the identifier (subscript of an element of           
c*****array 'amol') of an ion or a molecule. the neutral atom is always     
c*****understood, but is not explicitly contained in 'ident'.               
      nmax = 1                                                           
      do jmol=1,nmol                                                  
         atom = amol(jmol)                                                  
2        call sunder(atom,iatom1,iatom2)                                    
         do k=1,10                                                        
            if (iatom1 .eq. iorder(k)) go to 4                                  
         enddo
         neq = neq + 1                                                      
         iorder(neq) = iatom1                                               
         ident(neq,1) = jmol                                                
         go to 6                                                            
4        do kk=1,nmax                                                     
            if (ident(k,kk).eq.0 .or. ident(k,kk).eq. jmol) go to 7             
         enddo 
         nmax = nmax + 1                                                 
         kk = nmax                                                
7        ident(k,kk) = jmol                                                 
6        if (iatom2 .ne. 0) then
            atom = iatom2                                                      
            go to 2                                                            
         endif
      enddo                                                           
      if (ipr(2) .ge. 2) call out (6)                                      


c*****now begin the loop that goes through all the atmosphere tau layers
      do 21 kev=1,ntau                                                   


c*****calculate *xfic* and make a first guess at *xatom*                    
      i = ntau + 1 - kev                                           
      lev = i
      tk = 1.38054d-16*t(i)                                              
      tkev = 1.38054d-16*t(i)*6.242d11                                   
      do k=1,neq                                                      
         korder = iorder(k)                                                 
         xfic(k) = xabund(korder)*nhtot(i)                                  
      enddo
      if (i .lt. ntau) then
         do k=1,neq                                                      
            xatom(k) = xatom(k)*nhtot(i)/nhtot(i+1)                            
         enddo
      else
         do k=1,neq                                                      
            xatom(k) = xfic(k)                                                 
         enddo
      endif


c*****compute the number densities of ions and molecules                    
27    do jmol=1,nmol                                                  
         atom = amol(jmol)                                                  
         if (atom.ge.100. .and. t(i).gt.12000.) then
            xmol(jmol) = 1.0d-20
         elseif (atom.ge.100. .and. t(i).le.15000.) then
            xmol(jmol) = 1.                                                    
            count = 0.                                                         
37          call sunder(atom,iatom1,iatom2)                                    
            count = count + 1.                                                 
            do k=1,neq                                                      
               if (iorder(k) .eq. iatom1) 
     .            xmol(jmol) = xmol(jmol)*xatom(k)                       
            enddo                                                           
            if (iatom2 .ne. 0) then
               atom = iatom2                                          
               go to 37                                         
            endif
            hion = 10.0*(amol(jmol) - dint(amol(jmol)))                        
            xmol(jmol) = xmol(jmol)*dexp(const(1,jmol)/tkev - 
     .                   const(2,jmol) + (const(3,jmol) + 
     .                   (-const(4,jmol) + (const(5,jmol) -               
     .                   const(6,jmol)*t(i))*t(i))*t(i))*t(i) - 
     .                   1.5*(count-1.0-hion)*
     .                   dlog(t(i)))/ne(i)**hion    
         else
            delt = (t(i)-t(1))/tdel                               
            m = min0(idint(delt)+2,5)                          
            delt = delt - idint(delt)                           
             u1 = const(m,jmol) + 
     .           (const(m+1,jmol)-const(m,jmol))*delt          
            iatom1 = atom                                           
            do k=1,neq                                                      
               if (iorder(k) .eq. iatom1) xmol(jmol) = 
     .            4.825d15*u1*t(i)**1.5/ne(i)*dexp(-1.1605d4*            
     .            const(1,jmol)/t(i))*xatom(k)                              
            enddo
         endif
      enddo

c*****compute matrix *c*, which is the derivative of each equation with     
c*****respect to each atom.                                                 
26    do k=1,neq                                                      
         deltax(k) = -xfic(k) + xatom(k)                                    
         do kk=1,neq                                                     
            c(k,kk) = 0.                                                       
         enddo
         c(k,k) = 1.                                                        
         korder = iorder(k)                                                 
         do kk=1,neq                                                     
            kderiv = iorder(kk)                                                
            do 28 j=1,nmax                                                     
               jmol = ident(k,j)                                              
               if (jmol .eq. 0) go to 28                                     
               call discov(amol(jmol),kderiv,num2)                            
               if (num2 .eq. 0) go to 28                                        
               call discov(amol(jmol),korder,num1)                              
               c(k,kk) = c(k,kk) + xmol(jmol)*num1*num2/xatom(kk)            
               if (k .eq. kk) deltax(k) = deltax(k) + num1*xmol(jmol)          
28          continue                                                           
         enddo
      enddo

c*****calculate array 'xcorr', the change in 'xatom'. array 'xcorr' is      
c*****'deltax' multiplied by the inverse of 'c'                            
      call invert (neq,c,ans,10)                                          
      do k=1,neq                                                      
         x1 = xcorr(k)                                                      
         xcorr(k) = 0.                                                      
         do kk=1,neq                                                     
            xcorr(k) = xcorr(k) + ans(k,kk)*deltax(kk)                         
         enddo
      enddo

c*****decide if another iteration is needed                                 
      iflag = 0                                                          
      do k=1,neq                                                      
c*****here oscillations are damped out                                      
         if (x1*xcorr(k) .lt. -0.5*x1**2) xcorr(k) = 0.5*xcorr(k)            
         x1 = xatom(k)                                                      
         if (dabs(xcorr(k)/xatom(k)) .gt. 0.005) iflag = 1                    
         xatom(k) = xatom(k) - xcorr(k)                                     
c*****fix element number densities which are ridiculous                     
         if (xatom(k).le.0.0 .or. xatom(k).ge.1.001*xfic(k)) then
            iflag = 1                                                          
            xatom(k) = 1.0d-2*dabs(xatom(k)+xcorr(k))                           
         endif
      enddo                                                           
      if (iflag .ne. 0) go to 27                                          

c*****print out atomic and molecular partial pressures. *xamol* is the      
c*****number density for each neutral atom                                  
      do k=1,neq                                                     
         xamol(k,i) = xatom(k)                                              
         xatom(k) = dlog10(xatom(k)*tk)                                     
      enddo
      do jmol=1,nmol                                                 
         xmol(jmol) = dlog10(xmol(jmol)*tk)                                 
      enddo
      if (ipr(2) .ge. 2) call out (7)                                      
      do k=1,neq                                                     
         xatom(k) = 10.0**xatom(k)/tk                                       
      enddo

c*****here the big loop in tau ends
21    continue                                                           


      return                                                             
      end                                                                



      subroutine ewfind
c******************************************************************************
c     This routine predicts equivalent widths for individual atomic lines
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Pstuff.com'

c*****read the parameter file
      call params

c*****set up the output file
      nwrite = 20     
c     array = 'Give the filename for standard output: '
c     nchars = 39
c     call infile ('output ',nwrite,'formatted  ',0,nchars,4)

c AMcW 12/Aug/2003
      open(unit=nwrite,file='logfile')

      ndump = 21     
c     array = 'Give the filename for equivalent width summaries: '
c     nchars = 50
c     call infile ('output ',ndump,'formatted  ',0,nchars,6)

c AMcW 12/Aug/2003
      open(unit=ndump,file='OUTPUT')

c*****set up the model atmosphere                                        
      filemodel = 30
c     array = 'Give the filename for the model atmosphere: '
c     nchars = 44
c     call infile ('input  ',filemodel,'formatted  ',0,nchars,8)

c AMcW 12/Aug/2003
      open(unit=filemodel,file='MODEL',status='old')

      call inmodel
      call eqlib

c*****read line data
      filelines = 31
c     array = 'Give the filename for the line list: '
c     nchars = 37
c     call infile ('input  ',filelines,'formatted  ',0,nchars,10)

c AMcW 12/Aug/2003
      open(unit=filelines,file='INPUT',status='old')

      call inlines (1)
      call eqlib
      call nearly
 
c*****set some parameters
      ipr(5) = +1
      mode = 1

c*****run single line computations once to predict the EW for each line
      call linlimit
      do lim1=lim1line,lim2line
         ncurve = lim1
         lim2 = lim1
         gf1(ncurve) = gf(lim1)
         call oneline (1)
         widout(lim1) = w(ncurve)
      enddo

c*****output a summary
      lim1obs = lim1line
      lim2obs = lim2line
      istat = ivcleof (4,1)
      call out (28)
c     array = 'PROGRAM WILL TERMINATE WITH ANY KEYSTROKE'
c     nchars = 41
c     line = nlines + 8
c     call getasci (nchars,line)
         
c*****end the abundance computations
50    call finish
      return
      end

      subroutine findtic (end1,end2,bigtic,smltic)
c*****this routine makes tic marks at nice round intervals.

      implicit real*8(a-h,o-z)
c     real*4 end1,end2,bigtic,smltic,span  now double precision AMcW 1/200
      real*8 end1,end2,bigtic,smltic,span

      span = end2 - end1
      if (span .lt. 0.d0) span = - span
      spanlog = dlog10(span)
      size = real(int(spanlog))
      if (spanlog .lt. 0.) size = size - 1
      chop = spanlog - size
      if (chop .lt. 0.31) then
         bigtic = 10.d0**(size)/2
         smltic = bigtic/5
      elseif (chop .lt. 0.71) then
         bigtic = 10.d0**(size)
         smltic = bigtic/5
      else
         bigtic = 10.d0**(size)*2
         smltic = bigtic/4
      endif
      return
      end







      subroutine finish
c******************************************************************************
c     This routine simply wraps up MOOG
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'

c  close the files
      if (filemodel .ne. 0) close (unit=filemodel)
      if (filelines .ne. 0) close (unit=filelines)
      if (fileslines .ne. 0) close (unit=fileslines)
      if (fileobs .ne. 0) close (unit=fileobs)
      if (nparam .ne. 0) close (unit=nparam)
      if (nwrite .ne. 0) close (unit=nwrite)
      if (n2write .ne. 0) close (unit=n2write)
      if (ndump .ne. 0) close (unit=ndump)
      if (n2dump .ne. 0) close (unit=n2dump)

c  write the closing message
c     istat = ivcleof (4,1)
c     write (array,1001) 
1001  format (22('<'),10x,'MOOG HAS ENDED!',10x,22('>'))
c     istat = ivwrite (5,1,array,79)

      return
      end
      


      subroutine getasci (num,line)
c*****this routine asks for information, by printing out the
c     characters contained in 'array', and returns what the
c     user types out in array 'chinfo'.  Variable 'num' on input
c     is the number of characters in 'message', and on output is
c     the number of characters in 'chinfo'

      include 'Chars.com'

      istat = ivmove(line-1,1)
      istat = ivcleol()
      istat = ivmove(line-1,1)
      if (num .lt. 10) then
         write (errmess,1001) num
1001     format ('(,a',i1,'$)')
      else
         write (errmess,1002) num
1002     format ('(a',i2,'$)')
      endif
      write (*,errmess) array
      num = 80 - num
      if (num .lt. 10) then
         write (errmess,1003) num
1003     format ('(,a',i1,')')
      else
         write (errmess,1004) num
1004     format ('(a',i2,')')
      endif
      read (*,errmess) chinfo
      do 10 i=num,1,-1
         if (chinfo(i:i) .ne. ' ') go to 11
10       continue
      write (*,*) chinfo
      num = -1
      return
11    num = 81 - i
      return

      end




      subroutine infile (type,iunit,mode,irec,kount,line)

      include 'Chars.com'
      character type*7,kstat*7,yesno*1,mode*11

c  decide on the file status desired
      jstat = 0
      if     (type .eq. 'input  ') then
         kstat = 'old    '
      elseif (type .eq. 'output ') then
         kstat = 'new    '
      elseif (type .eq. 'overout') then
         kstat = 'unknown'
      endif

c  open the file specified by the user
      kold = kount
5     kount = kold
      call getasci (kount,line)
6     if (mode .eq. 'formatted  ') then
         open (unit=iunit,file=chinfo(1:kount),access='sequential',
     .         form=mode,blank='null',status=kstat,
     .         iostat=jstat,err=10)
      else
         open (unit=iunit,file=chinfo(1:kount),access='direct',
     .         form=mode,status=kstat,recl=irec,
     .         iostat=jstat,err=10)
      endif
      istat = ivmove (line+1,1)
      istat = ivcleol ()
      return

c  here are the file reading error messages; the error numbers are
c  three-digit ones for SunOS machines, and four-digit ones for Solaris
10    if (jstat .eq. 118 .or. jstat .eq. 1018) then
         write (errmess,1001) jstat
1001     format ('ERROR ',i4,': FILE DOES NOT EXIST! TRY AGAIN.') 
         istat = ivwrite (line+2,3,errmess,44)
         go to 5
      elseif (jstat .eq. 117 .or. jstat .eq. 1017) then
         write (errmess,1002) jstat
1002     format ('ERROR ',i4,': FILE EXISTS! OVERWRITE (y/n)?')
         istat = ivwrite (line+2,3,errmess,41)
         read (*,*) yesno
         if (yesno .eq. 'y') then
            kstat = 'unknown'
            go to 6
         else
            write (errmess,1003) 
1003        format ('PLEASE GIVE A DIFFERENT FILENAME')
            istat = ivwrite (line+2,3,errmess,32)
            go to 5
         endif
      else
         write (errmess,1004) jstat
1004     format ('ERROR ',i4,': UNKNOWN FILE READING ERROR; ABORT!')
         istat = ivwrite (line+2,3,errmess,46)
      endif

      end




      subroutine inlines (num)
c******************************************************************************
c     This subroutine reads in the line data
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Dummy.com'
      include 'Quants.com'
      include 'Factor.com'
      real*8 d0(500)
      logical firsttime
      data firsttime /.true./

c*****get the partition functions; only needs to be done on the first call
      if (firsttime .eqv. .true.) then
         do j=1,95
            elem(j) = dble(j)
            dummy=partfn (elem(j),j)
         enddo
         firsttime = .false.
      endif

      if (num .eq. 2) go to 4

c*****decide if certain element abundances need to be modified.
      if (numpecatom .gt. 0) then
         do iatom=3,95
            xabund(iatom) = 10.**pecabund(iatom,isynth)*
     .                      10.**pecabund(99,isynth)*xabu(iatom)
         enddo
      endif
      call out (20)

c*****read in the strong lines with another routine; prepare to read lines here
      call slines
      rewind filelines
      wave = start                                                       
      n1 = 0                                                             
      nlines = 500                                                        
      read (filelines,1001) obsitle
1001  format (a80)
302   n1 = n1 + 1                                                        

c*****read the line list
      i = n1
c
c Changed read to get lineids and changed format to take old moog lists
c AMcW 1/2000
c
333   read (filelines,301,end=311) lineid(i),wave1(i),atom1(i),e(i,1),
     .                             c6(i),gf(i),d0(i),width(i)
301   format (a5,6e10.3,5x,f10.3)
c
      if (width(i) .lt. 0.) go to 333
      i = i + 1
      if (i .le. 500) go to 333
311   nlines = i - 1

c*****here groups of lines for blended features are defined
310   do i=1,nlines
         if (wave1(i) .lt. 0.) then
            group(i) = 1
            wave1(i) = dabs(wave1(i))
            width(i) = width(i-1)
         else
            group(i) = 0
         endif
      enddo     

c*****here log(gf) values are turned into gf values, if needed
      do i=1,nlines
         if (gf(i) .lt. 0) then
            do j=1,nlines
               gf(j) = 10.**gf(j)
            enddo
            go to 379
         endif
      enddo         

c*****turn log(RW) values and EW values in mA into EW values in A.  Stuff
c     duplicate EW values of the first line of a blend into all blend members.
379   do i=1,nlines
         if (width(i) .lt. 0.) then
            width(i) = 10.**width(i)*wave1(i)
         else
            width(i) = width(i)/1000.
         endif
       enddo

c*****calculate some parameters of the lines; for atomic lines the
c     van der Waals damping has different options
      do i=1,nlines
         iatom = atom1(i)                                                   
         charge(i) = 1.0 + 10.0*(atom1(i) - iatom)                          
         e(i,2) =  e(i,1) + 1.239d+4/wave1(i)                               
         if (iatom .ge. 100) then
            call sunder(atom1(i),ia,ib)                                        
            if (atom1(i)-int(atom1(i)) .le. 0.0) then
               amass(i) = xam(ia) + xam(ib)    
               mas1=xam(ia)
               mas2=xam(ib)
            else 
               mas1 = int(100*(atom1(i)-int(atom1(i))))
               mas2 = int(10000*(atom1(i)-int(atom1(i)))) - mas1 * 100
               amass(i) = mas1 + mas2
            endif
            chi(i,1) = d0(i)
            chi(i,2) = mas1*mas2/amass(i)                                
            chi(i,3) = 0.
            c6(i) = 1.0d-31                                                    
         else
            amass(i) = xam(iatom)                       
            chi(i,1) = xchi1(iatom)                                            
            chi(i,2) = xchi2(iatom)                                            
            chi(i,3) = xchi3(iatom)                                            
 
c*****do the damping, beginning with the Unsold approximation
            ich = idint(charge(i) + 0.1)      
            unsold = dabs(1.61d-33*(13.5*charge(i)/(chi(i,ich) -
     .               e(i,1)))**2 - 1.61d-33*(13.5*charge(i)/
     .               (chi(i,ich)-e(i,2)))**2)               
            if (ipr(8) .eq. 0) then
               if (c6(i) .eq. 0.0) then
                  c6(i) = unsold
               elseif (c6(i) .gt. 1.0d-10) then
                  c6(i) = unsold*c6(i)
               endif
            elseif (ipr(8) .eq. 1) then
               c6(i) = 6.3*unsold
            elseif (ipr(8) .eq. 2) then
               c6(i) = (1.0 + 0.67*e(i,1))*unsold
            endif
         endif
      enddo

c*****quit the routine normally
      if (nlines .lt. 500) then
         if (stop .gt. wave1(nlines)+10.) stop = wave1(nlines)+10.
      endif
      lim1line = 1
      return  

c****get another chunk of line data                                        
4     n1 = 0                                                             
      do j=lim1line,nlines                                               
         n1 = n1 + 1                                                        
         wave1(n1) = wave1(j)                                               
         atom1(n1) = atom1(j)                                               
         amass(n1) = amass(j)                                               
         charge(n1) = charge(j)                                             
         d0(n1) = d0(j)
         gf(n1) = gf(j)                                                     
         do jj=1,3                                                      
            chi(n1,jj) = chi(j,jj)                                             
            e(n1,jj) = e(j,jj)                                                 
         enddo                                                           
      enddo    
      start = wave                                                       
      go to 302                                                          
      

      end                                                                



      subroutine inmodel
c******************************************************************************
c     This subroutine reads in the model
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Quants.com'
      include 'Factor.com'
      include 'Dummy.com'
      real*8 rhox(75), molweight(75) 
      real*8 element(95), logepsilon(95)
      real*8 kaprefmass(75)
      character list*80, list2*70


c*****Read in the key word to define the model type
      rewind filemodel
      read (filemodel,108) modtype
108   format (a10)
      call out (21)

c*****Read a comment line (usually describing the model)
      read (filemodel,106) moditle
106   format (a80)                                                       

c*****Read the number of depth points
      read (filemodel,208) list
      list2 = list(11:)
      read (list2,*) ntau

c*****EITHER: Read in a model from the output of the ATLAS code.  This
c     modtype is called "KURUCZ".  On each line the numbers are:
c     rhox, t, pgas, ne, and Rosseland mean opacity (cm^2/gm), and
c     two numbers not used by MOOG.  
      if (modtype .eq. 'KURUCZ    ') then
         do i=1,ntau
            read (filemodel,*) rhox(i),t(i),pgas(i),ne(i),kaprefmass(i)
         enddo
c     OR: Read in a model from the output of the MARCS code.  This modtype
c     type is called "BEGN".  On each line the numbers are:
c     tauross, t, log(pg), log(pe), mol weight, and kappaross.
      elseif (modtype .eq. 'BEGN      ') then
         do i=1,ntau
            read (filemodel,*) tauref(i),t(i),pgas(i),ne(i),
     .                          molweight(i),  kaprefmass(i)
         enddo
c     OR: Read in a model generated from ATLAS, but without accompanying
c     opacities.  MOOG will need to generate the opacities internally,
c     using a reference wavelength that it reads in before the model.
      elseif (modtype .eq. 'KURTYPE   ') then
         read (filemodel,*) wavref    
         do i=1,ntau
            read (filemodel,*) rhox(i),t(i),pgas(i),ne(i)
         enddo
c     OR: Read in a generic model that has a tau scale at a specific 
c     wavelength that is read in before the model.  
c     MOOG will need to generate the opacities internally.
      elseif (modtype .eq. 'GENERIC   ') then
         read (filemodel,*) wavref    
         do i=1,ntau
            read (filemodel,*) tauref(i),t(i),pgas(i),ne(i)
         enddo
c     OR: quit in utter confusion if those model types are not specified
      else
         write (*,*) 'permitted model types are:'
         write (*,*) '   KURUCZ, BEGN, KURTYPE, or GENERIC'
         write (*,*) 'MOOG quits!'
         stop
      endif

c*****Convert from logarithmic Pgas scales, if needed
      if (pgas(ntau)/pgas(1) .lt. 10.) then
         do i=1,ntau                                                    
            pgas(i) = 10.0**pgas(i)                                            
         enddo
      endif

c*****Convert from logarithmic Ne scales, if needed
      if(ne(ntau)/ne(1) .lt. 20.) then
         do i=1,ntau                                                    
            ne(i) = 10.0**ne(i)                                                
         enddo
      endif

c*****Convert from Pe to Ne, if needed
      if(ne(ntau) .lt. 1.0e7) then
         do i=1,ntau                                                    
            ne(i) = ne(i)/1.38054d-16/t(i)                                 
         enddo
      endif

c*****Read the microturbulence (either a single value to apply to 
c     all layers, or a value for each of the ntau layers). 
c     Conversion to cm/sec from km/sec is done if needed
      read (filemodel,101) (vturb(i),i=1,6)                                   
101   format (6e13.0)                                                     
      if (vturb(2) .ne. 0.) then
         read (filemodel,101) (vturb(i),i=7,ntau) 
      else
         do i=2,ntau                                                    
            vturb(i) = vturb(1)                                                
         enddo
      endif
      if (vturb(1) .lt. 100.) then
         write (moditle(57:64),157) vturb(1)
157      format ('vt=',f5.2)
         do i=1,ntau
            vturb(i) = 1.0e5*vturb(i)
         enddo
      else
         write (moditle(57:64),157) vturb(1)/1.0e5
      endif

c*****Copy abundance data from xabu0 to xabu
	do i = 1,95
           xabu(i) = xabu0(i)
	enddo
c*****Read in the abundance data, storing the original abundances in xabu
      read (filemodel,208) list
208   format(a80)
      list2 = list(11:)
      read (list2,*) natoms,abscale
      if(natoms .ne. 0) 
     .         read (filemodel,*) (element(i),logepsilon(i),i=1,natoms) 
      xhyd = 10.0**xabu(1)                                             
      xabund(1) = 1.0                                                    
      xabund(2) = 10.0**xabu(2)/xhyd                                   
      do i=3,95                                                      
         xabund(i) = 10.0**(xabu(i)+abscale)/xhyd                           
         xabu(i) = xabund(i)
      enddo
      if (natoms .ne. 0) then
         do i=1,natoms                                                  
            xabund(idint(element(i))) = 10.0**logepsilon(i)/xhyd
            xabu(idint(element(i))) = 10.0**logepsilon(i)/xhyd
         enddo
      endif

c*****Compute the mean molecular weight, ignoring molecule formation
c     in this approximation (maybe make more general some day?)
      wtnum = 0.
      wtden = 0.
      do i=1,95
         wtnum = wtnum + xabund(i)*xam(i)
         wtden = wtden + xabund(i)
      enddo
      wtmol = wtnum/(xam(1)*wtden)
      if (modtype .ne. 'BEGN      ') then
         do i=1,ntau
            molweight(i) = wtmol
         enddo
      endif

c*****Compute the density 
      do i=1,ntau                                                    
         rho(i) = pgas(i)*molweight(i)*1.6606d-24/(1.38054d-16*t(i))
      enddo

c*****Calculate the fictitious number density of hydrogen, and then
c     get the number densities of neutral hydrogen and helium by 
c     running through the molecular equilibrium routine with
c     constituents H I, H II, H2, He I, and He II.
c     Note:  ph = (-b1 + dsqrt(b1*b1 - 4.0*a1*c1))/(2.0*a1)
      iatom = 1
      dummy=partfn (dble(iatom),iatom)
      do i=1,ntau    
         th = 5040.0/t(i)         
         ah2 = 10.0**(-(12.7422+(-5.1137+(0.1145-0.0091*th)*th)*th))        
         a1 = (1.0+2.0*xabund(2))*ah2                                       
         b1 = 1.0 + xabund(2)                                               
         c1 = -pgas(i)         
         ph = (-b1/2.0/a1)+dsqrt((b1**2/(4.0*a1*a1))-(c1/a1))
         nhtot(i) = (ph+2.0*ph*ph*ah2)/(1.38054d-16*t(i))                   
      enddo
      amol(1) = 1.1
      amol(2) = 101.0
      amol(3) = 2.1
      nmolhold = nmol
      nmol = 3
      iprhold = ipr(2)
      if (ipr(1) .eq. 2) then
         ipr(2) = 2
         write (nwrite,1001)
1001     format (/'THE FOLLOWING EQUILIBRIUM COMPUTATIONS GET ',
     .           'H I AND HE I DENSITIES')
      else
         ipr(2) = 1
      endif
      call eqlib
      nmol = nmolhold
      ipr(2) = iprhold
      do i=1,ntau
         nhneutral(i) = xamol(1,i)
         nheneutral(i) = xamol(2,i)
      enddo

c*****Read in the names of molecules to be used in molecular equilibrium
      if (ipr(2) .ne. 0) then
         read (filemodel,208) list
         list2 = list(11:)
         read (list2,*) nmol
         read (filemodel,*) (amol(i),i=1,nmol)                                 
      endif

c*****SPECIAL NEEDS: for KURUCZ models, to create the optical depth array,
c     and to convert kaprefs to our units
      if (modtype .eq. 'KURUCZ    ') then
         first = rhox(1)*kaprefmass(1)
         tottau = rinteg(rhox,kaprefmass,tauref,ntau,first) 
         tauref(1) = first
         do i=2,ntau
            tauref(i) = tauref(i-1) + tauref(i)
         enddo
         do i=1,ntau
            kapref(i) = kaprefmass(i)*rho(i)
         enddo
c     SPECIAL NEEDS: for BEGN models, to convert kaprefs to our units
      elseif (modtype .eq. 'BEGN      ') then
         do i=1,ntau                                                    
            kapref(i) = kaprefmass(i)*rho(i)
         enddo
c     SPECIAL NEEDS: for KURTYPE models, to create internal kaprefs,
c     and to compute taurefs from the kaprefs converted to mass units
      elseif (modtype .eq. 'KURTYPE   ') then
         call opacit (1,wavref)
         do i=1,ntau                                                    
            kaprefmass(i) = kapref(i)/rho(i)
         enddo
         first = rhox(1)*kaprefmass(1)
         tottau = rinteg(rhox,kaprefmass,tauref,ntau,first) 
         tauref(1) = first
         do i=2,ntau
            tauref(i) = tauref(i-1) + tauref(i)
         enddo
c     SPECIAL NEEDS: for generic models, to create internal kaprefs,
      elseif (modtype .eq. 'GENERIC   ') then
         call opacit (1,wavref)
      endif

c*****Convert from logarithmic optical depth scales, or vice versa.
c     xref will contain the log of the tauref
      if(tauref(1) .lt. 0.) then
         do i=1,ntau                                                    
            xref(i) = tauref(i)
            tauref(i) = 10.0**xref(i)                                        
         enddo
      else
         do i=1,ntau                                                    
            xref(i) = dlog10(tauref(i))                                        
         enddo
      endif

c*****Locate the atmosphere level where tauref is near 0.5
      do i=1,ntau
         if (tauref(i) .ge. 0.5) go to 180
      enddo
180   jtau5 = i

c*****Write information to output
      call out (1)
      call out (8)

      return

      end                                                                

      subroutine invert(order,a,i,nsiz)                                  
c******************************************************************************
c     This routine inverts an *order,order* matrix *a*. answer is *i*       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      integer order                                                      
      integer orde                                                       
      real*8 i                                                             
      dimension a(nsiz,nsiz),i(nsiz,nsiz)                                
      do 10 n=1,order                                                    
      do 10 m=1,order                                                    
10    i(m,n) = 0.0                                                       
  141 do 14 j=1,order                                                    
   14 i(j,j)=1.0                                                         
      orde=order-1                                                       
      do 15 k=1,orde                                                     
      kk=k+1                                                             
      do 15 j=kk,order                                                   
      i(j,k)=0.0                                                         
   15 i(k,j)=0.0                                                         
c  here begins the inversion                                             
      do 20 n=1,order                                                    
      if(n.eq.order) go to 244                                           
  245 g=a(n,n)                                                           
      n1=n+1                                                             
      ng=n                                                               
      do 22 m=n1,order                                                   
      f=a(m,n)                                                           
      if(f .le. g) go to 22                                              
   21 g=f                                                                
      ng=m                                                               
   22 continue                                                           
      if(ng.eq.n) go to 244                                              
   24 do 25 k=1,order                                                    
      d=i(n,k)                                                           
      e=i(ng,k)                                                          
      f=a(n,k)                                                           
      g=a(ng,k)                                                          
      i(ng,k)=d                                                          
      i(n,k)=e                                                           
      a(ng,k)=f                                                          
   25 a(n,k)=g                                                           
  244 g=a(n,n)                                                           
      if(g .ne. 0.0) go to 23                                            
71    write(nwrite,200)     
      go to 161                              
  200 format(14h un invertable)                                          
   23 do 26 k=1,order                                                    
      a(n,k)=a(n,k)/g                                                    
   26 i(n,k)=i(n,k)/g                                                    
      if(n.eq.order) go to 27                                            
   28 do 20 k=n1,order                                                   
      f=-a(k,n)                                                          
      do 20 j=1,order                                                    
      a(k,j)=a(k,j) + f*a(n,j)                                           
   20 i(k,j)= i(k,j)+f*i(n,j)                                            
   27 do 29 jk=1,orde                                                    
      n=order-jk+1                                                       
      do 29 j=jk,orde                                                    
      m=order-j                                                          
      f=-a(m,n)                                                          
      do 29 k=1,order                                                    
      a(m,k)=a(m,k) +f*a(n,k)                                            
   29 i(m,k)=i(m,k)+f*i(n,k)                                             
  161 return                                                             
      end                                                                

      subroutine isotop
c******************************************************************************
c     This program runs syntheses for differing isotope ratios
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Mol.com'
      include 'Chars.com'
      include 'Atmos.com'
      include 'Factor.com'
      include 'Strong.com'
      include 'Linex.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params


c*****set up the output files
      nwrite = 20
      lscreen = 4
      array = 'Give the filename for standard output: '
      nchars = 39
      call infile ('output ',nwrite,'formatted  ',0,nchars,lscreen)
      ndump = 21
      lscreen = lscreen + 2
      array = 'Give the filename for raw syntheses output: '
      nchars = 44
      call infile ('output ',ndump,'formatted  ',0,nchars,lscreen)
      if (ipr(7) .ne. 0) then
         n2dump = 22
         lscreen = lscreen + 2
         array = 'Give the filename for smoothed syntheses: '
         nchars = 42
         call infile ('output ',n2dump,'formatted  ',0,nchars,lscreen)
      endif
      if (iraf .ne. 0) then
         n2write = 23
         lscreen = lscreen + 2
         array = 'Give the filename for IRAF ("rtext") output: '
         nchars = 45
         call infile ('output ',n2write,'formatted  ',0,nchars,lscreen)
      endif


c*****set up the model atmosphere                                        
      filemodel = 30
      lscreen = lscreen + 2
      array = 'Give the filename for the model atmosphere: '
      nchars = 44
      call infile ('input  ',filemodel,'formatted  ',0,nchars,lscreen)
      call inmodel


c*****open the line list file and the strong line list file
      filelines = 31
      lscreen = lscreen + 2
      array = 'Give the filename for the line list: '
      nchars = 37
      call infile ('input  ',filelines,'formatted  ',0,nchars,lscreen)
      if (nstrong .gt. 0) then
         fileslines = 32
         lscreen = lscreen + 2
         array = 'Give the filename for the strong line list: '
         nchars = 44
         call infile ('input  ',fileslines,'formatted  ',0,nchars,
     .                lscreen)
      endif


c*****do the syntheses
      if (numiso .eq. 0 .or. numisosyn .eq. 0) then
         isynth = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly
         call synspec
      else
         do n=1,numisosyn
            isynth= 1
            isorun = n
            mode = 3
            call out(26)
            call inlines (1)
            call eqlib
            call nearly
            call synspec
            ipr(3) = 0
         enddo
      endif

c*****now plot the spectrum
      if (ipr(7).eq.2 .and. ipr(9).gt.0) then
         fileobs = 23               
         lscreen = lscreen + 2
         array = 'Give the filename of the observed spectrum: '
         nchars = 44
         if (ipr(9) .eq. 1) then
            call infile ('input  ',fileobs,'unformatted',2880,nchars,
     .                   lscreen) 
         else
            call infile ('input  ',fileobs,'formatted  ',0,nchars,
     .                   lscreen)
         endif
      endif
      if (ipr(7) .ne. 0) then
         call pltspec (lscreen)
      endif

c*****finish
20    call finish
      end                                                                






      real*8 function expint(x,n)
c******************************************************************************
c     This routine computes the n'th exponential integral of x
c     ******* notice limits on x for this program!!! ******
c     input - x,  independent variable (-100. .le. x .le. +100.)
c            n,  order of desired exponential integral (1 .le. n .le. 8)
c     output - expint,  the desired result
c     jd does not output ex to save moog call re-write
c              rex,  expf(-x)
c     jd
c     note   returns with e1(0)=0, (not infinity).
c     based on the share routine nuexpi, written by j. w. cooley,
c     courant institute of mathematical sciences, new york university
c     obtained from rudolf loeser
c     general compilation of 1 august 1967.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      real*8 tab(20),xint(7)
      data xint/1.,2.,3.,4.,5.,6.,7./
      data tab /.2707662555,.2131473101,.1746297218,.1477309984,
     1.1280843565,.1131470205,.1014028126,.0919145454,.0840790292,
     1.0774922515,.0718735405,.0670215610,.0627878642,.0590604044,
     1.0557529077,.0527977953,.0501413386,.0477402600,.0455592945,
     1.0435694088/
      data xsave /0./
c
      if (x.ge.100.) goto 800 
      if (x.le.-100.) goto 800 
      xu=x
      if(xu)603,602,603
  602 rex=1.d+00
      if(n-1)800,800,801
  800 expint=0.
      goto 777
  801 expint=1./xint(n-1)
      goto 777
  603 if(xu-xsave)604,503,604
  604 xsave=xu
      xm=-xu
      emx = dexp(xm)
c
c  select method for computing ei(xm)
c
      if(xm-24.5)501,400,400
  501 if(xm-5.)502,300,300
  502 if(xm+1.)100,200,200
  503 eisave=-arg
      exsave=emx
c
c  now recurse to higher orders
c
      if(n-1)507,507,505
 505  do 506 i=2,n
        eisave=(xu*eisave-exsave)/(-xint(i-1))
  506 continue
  507 expint=eisave
      rex=exsave
  777 return
c
c  ei(xm) for xm .lt. -1.0
c  hastings polynomial approximation
c
  100 arg=((((((xu+8.573328740 )*xu+18.05901697  )*xu+8.634760893 )*xu
     *+.2677737343)/xm)*emx)/((((xu+9.573322345 )*xu+25.63295615  )*xu
     *+21.09965308  )*xu+3.958496923 )
      goto 503
c     ei(xm) for -1. .le. xm .lt. 5.0
c     power series expansion about zero
  200 arg=dlog(abs(xm))
      arg=((((((((((((((((.41159050d-14*xm+.71745406d-13)*xm+.76404637d-
     *12)*xm+.11395905d-10)*xm+.17540077d-9)*xm+.23002666d-8)*xm+.275360
     *18d-7)*xm+.30588626d-6)*xm+.31003842d-5)*xm+.28346991d-4)*xm+.2314
     *8057d-3)*xm+.0016666574)*xm+.010416668)*xm+.055555572)*xm+.25)*xm+
     *.99999999)*xm+.57721566)+arg
      goto 503
c
c  ei(xm) for 5.0 .le. xm .lt. 24.5
c  table look-up and interpolation
c
  300 i=xm+.5
      xzero=i
      xdelta=xzero-xm
      arg=tab(i-4)
      if(xdelta)303,305,303
  303 y=arg
      deltax=xdelta/xzero
      power=1./deltax
      do 304 i=1,7
        power=power*deltax
        y=((y-power/xzero)*xdelta)/xint(i)
        arg=arg+y
        if(abs(y/arg)-1.d-8)305,304,304
  304 continue
  305 arg=emx*arg
      goto 503
c     ei(xm) for 24.5 .le. xm
c     truncated continued fraction
  400 arg=((((xm-15.)*xm+58.)*xm-50.)*emx)/((((xm-16.)*xm+72.)*xm-96.)
     **xm+24.)
      goto 503
      end

      subroutine linlimit 
c******************************************************************************
c     This routine marks the range of lines to be considered in a 
c     particular line calculations, depending on the type of calculation
c     (e.g. synthetic spectrum, single line curve-of-growth, etc.)
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Linex.com'

c*****for single-line computations, the line rage is the whole line set;
c     this will be called from "ewfind"
      if     (mode .eq. 1) then
         lim1line = 1
         lim2line = nlines
         return

c*****for deriving abundances from single of lines of one species, delimit
c     the lines of that species as the range; called from "abfind"
      elseif (mode .eq. 2) then
         if     (lim1line .eq. 0) then
            lim1line = 1
         elseif (lim2line .eq. nlines) then
            lim1line = -1
         else
            lim1line = lim2line + 1
         endif
         oldatom = atom1(lim1line)
         do j=lim1line+1,nlines
            if (atom1(j) .ne. oldatom) then
               lim2line = j - 1
               return
            endif
         enddo
         lim2line = nlines
         return

c*****for spectrum synthesis, find the range of lines to include at each
c     wavelength step; called from "synspec"
      elseif (mode .eq. 3) then
         if (lim1line .eq. 0) then
            lim1line = 1
         endif
         do j=lim1line,nlines
            if (wave1(j) .ge. wave-delta) then
               lim1line = j
               go to 10
            endif
         enddo
         lim1 = nlines
10       do j=lim1line,nlines
            if (wave1(j) .gt. wave+delta) then
               lim2line = max0(1,j-1)
               return
            endif
         enddo   
         if (nlines .eq. 500) then
            lim2line = -1
         else
            lim2line = nlines
         endif
         return

c*****for blended line force fits to the EWs, the range is a set of
c     lines in a particular blend
      elseif (mode .eq. 4) then
         if (lim1line .eq. 0) then
            lim1line = 1
         endif
         if (group(lim1line) .ne. 0.) then
            write (*,*) 'TROUBLE! THE FIRST LINE IN THE GROUP'
            write (*,*) 'DOES NOT DEFINE A NEW GROUP OF LINES!'
            stop
         endif
         if (lim1line .eq. nlines) then
            lim2line = lim1line
         else
            do j=lim1line+1,nlines
               if (group(j) .ne. 1) then
                  lim2line = j - 1
                  return
               endif
            enddo
            lim2line = nlines
         endif
         return




      endif

      end

      subroutine linplot (choice)
c******************************************************************************
c     This routine produces MONGO plots of line abundances versus
c     excitation potentials and equivalent widths
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Dummy.com'
c     real*4 ep(1000),abb(1000),logrw(1000)
c     equivalence (ep,dummy3(1)),(abb,dummy3(1001)),(logrw,dummy3(2001))
c     real*4 style(1),ymed
      character ion*4,choice
      real*8 ep(1000),abb(1000),logrw(1000)
      equivalence (ep,dummy3(1)),(abb,dummy3(1001)),(logrw,dummy3(2001))
      real*8 style(1),ymed


c*****dump the data into working arrays
      j = 0
      do l=lim1obs,lim2obs
         if (abunout(l) .ne. 999.99) then
            j = j + 1
            ep(j) = e(l,1)
            abb(j) = abunout(l)
            logrw(j) = dlog10(width(l)/wave1(l))
         endif
      enddo


c*****find the plot boundaries for the excitation potential plot
      xlo = 20.
      do j=1,kount
         xlo = dmin1(xlo,ep(j))
      enddo
      xhi =  0.
      do j=1,kount
         xhi = dmax1(xhi,ep(j))
      enddo
      if (xhi-xlo .lt. 5.) then
         xlo = dmax1((xlo+xhi)/2.-2.5,-0.2d0)
         xhi = xlo + 5.0
      else
         xlo = dmax1((xlo+xhi)/2.-5.0,-0.2d0)
         xhi = xlo + 10.
      endif
      ylo = 20.
      do j=1,kount
         ylo = dmin1(ylo,abb(j))
      enddo
      yhi = -20.
      do j=1,kount
         yhi = dmax1(yhi,abb(j))
      enddo
      if (yhi-ylo .lt. 0.5) then
         ylo = (ylo+yhi)/2. - 0.30
         yhi = ylo + 0.60
      elseif (yhi-ylo .lt. 1.0) then
         ylo = (ylo+yhi)/2. - 0.55
         yhi = ylo + 1.10
      else
         ylo = (ylo+yhi)/2. - 1.10
         yhi = ylo + 2.20
      endif


c*****start the excitation potential plot via plot setup calls
      call sm_window (1,2,1,2,1,2) 
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the excitation potential plot
      call sm_expand (1.2d0)
      call sm_lweight (1.8d0)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_box (1,2,0,0)
      array = 'Excitation Potential'
      call sm_xlabel (array)
      array = 'Abundance'
      call sm_ylabel (array)
      call sm_lweight (1.4d0)
      

c*****make the excitation potential plot
      call sm_ctype ('red')
      call sm_expand (1.6d0)
      style(1) = 43.0d0
      call sm_expand (1.2d0)
      call sm_ptype (style,1) 
      call sm_points (ep,abb,kount)
      call sm_ctype ('yellow')
      call sm_ltype (3)
      ymed = average
      call sm_relocate (xlo,ymed)
      call sm_draw (xhi,ymed)
      if (kount .gt. 2 .and. deltaep .gt. 1.5) then
         call sm_ctype ('blue')
         call sm_relocate (xlo,dble(xxm1*xlo+xxb1)) 
         call sm_draw (xhi,dble(xxm1*xhi+xxb1)) 
      endif
      call sm_ltype (1)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_relocate (xlo+0.05d0*(xhi-xlo),ylo+0.15d0*(yhi-ylo))
      call sm_expand (1.0d0)
      call sm_label (obsitle)
      ich = idint(charge(lim1obs) + 0.1)
      if (ich .eq. 1) then 
         ion = ' I  '
      elseif (ich .eq. 2) then
         ion = ' II '
      elseif (ich .eq. 3) then
         ion = ' III'
      endif
      iatom = idint(atom1(lim1obs))
      write (array,1002) names(iatom),ion
1002  format (a2,a4)
      call sm_relocate ((xhi+xlo)/2.d0,yhi-0.15d0*(yhi-ylo))
      call sm_expand (1.2d0)
      call sm_label (array)
   

c*****define the plot limits for the equivalent width plot
      xlo = 5000.
      do j=1,kount
         xlo = dmin1(xlo,logrw(j))
      enddo
      xhi =  -5000.
      do j=1,kount
         xhi = dmax1(xhi,logrw(j))
      enddo
      xlo = int((xlo-0.01)*2.-1.)/2.
      xhi = int((xhi+0.01)*2.)/2.
      call sm_window (1,2,1,1,1,1) 
      call sm_limits (xlo,xhi,ylo,yhi)
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)

c*****draw and label the box for the equivalent width plot
      call sm_expand (1.2d0)
      call sm_lweight (1.8d0)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_box (1,2,0,0)
      array = 'Equivalent Width'
      call sm_xlabel (array)
      array = 'Abundance'
      call sm_ylabel (array)
      call sm_lweight (1.4d0)

c*****make the equivalent width plot
      call sm_ctype ('green')
      call sm_expand (1.6d0)
      style(1) = 43.0d0
      call sm_expand (1.2d0)
      call sm_ptype (style,1)
      call sm_points (logrw,abb,kount)
      call sm_ctype ('yellow')
      call sm_ltype (3)
      call sm_relocate (xlo,ymed)
      call sm_draw (xhi,ymed)
      if (kount .gt. 2 .and. deltarw .gt. 0.5) then
         call sm_ctype ('blue')
         call sm_relocate (xlo,dble(xxm2*xlo+xxb2)) 
         call sm_draw (xhi,dble(xxm2*xhi+xxb2)) 
      endif
      call sm_ltype (1)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype ('black')
      else
         call sm_ctype ('white')
      endif
      call sm_relocate (xlo+0.05d0*(xhi-xlo),yhi-0.15d0*(yhi-ylo))
      call sm_expand (1.0d0)
      call sm_label (moditle)
   
      return
      end








      subroutine moog()
c******************************************************************************
c     This is the main driver for MOOG.  It reads the parameter
c     file and sends MOOG to various controlling subroutines
c******************************************************************************

      include 'Chars.com'
      character yesno*1

c*****invoke the overal starting routine
1     control = '       '
      call begin

c*****use either one of the standard driver routines: 
      if     (control .eq. 'plotit ') then
         call plotit
      elseif (control .eq. 'synth  ') then
         call synth
      elseif (control .eq. 'cogsyn ') then
         call cogsyn  
      elseif (control .eq. 'blends ') then
         call blends  
      elseif (control .eq. 'abfind ') then
         call abfind
      elseif (control .eq. 'ewfind ') then
         call ewfind
      elseif (control .eq. 'cog    ') then
         call cog
      elseif (control .eq. 'calmod ') then
         call calmod
      elseif (control .eq. 'isotop ') then
         call isotop

c*****or, put in your own drivers in the form below....
      elseif (control .eq. 'mine  ') then
         call  mydriver 

c*****or else you are out of luck!
      else
         array = 'THIS IS NOT ONE OF THE DRIVERS.  TRY AGAIN (y/n)?'
         istat = ivwrite (4,3,array,49)
         istat = ivmove (3,1)
         read (*,*) yesno
         if (yesno .eq. 'y') then
            go to 1
         else
            call finish
         endif
      endif

      end
      
      subroutine mydriver
c******************************************************************************
c     This program is a dummy routine now.  The user can substitute a new
c     driver in its place, for experimental or specialized MOOG use.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Mol.com'

      return

      end




       integer function ivcleof(y,x)
c
c    This routine clears to the end of the screen, beginning with the
c    position row=y, column=x. The cursor is then placed at (y,x)
c
       include 'Pstuff.com'
       character blank*79
       integer y,x,ypos,xpos
 
c AMcW 8/2003
	return
c
       write(blank,1001)
1001   format(79(' '))
       istat = ivwrite(y,x,blank,79)
       xpos = 1
       ypos = y


       do 11 ipos=ypos,maxline
          istat = ivmove(ipos,xpos)
11        istat = ivcleol()
       istat = ivmove(y,x)
c
       ivcleof = 0
       return
       end





       integer function ivwrite(y,x,arr,ccount)
c
c    This routine writes out a string of characters from 'arr',
c    with the first character beginning at row=y, column=x. The length
c    of the string may be at most 79 characters, and this routine
c    will not write on the 80th column or the 25th row of the screen.
c
       include 'Pstuff.com'
       integer y,x,count,ccount
       character arr*80,dummy*80,string(80)*1,esc*1
       equivalence (dummy,string(1))
c
c AMcW 8/2003
	return
c
       write(blank,1001)
       count = ccount
       if (y .gt. maxline .or. x .gt. 79) then
          ivwrite = -1
          return
       endif
c
       esc = char(27)
       dummy = arr
       count = min0(80-x,count)
c       
       if (x .lt. 10) then
          if (y .lt. 10) then
             write (*,1007) esc,y,x,(string(i),i=1,count)
1007         format(1x,a1,'[',i1,';',i1,'H',80a1)
          else
             write (*,1006) esc,y,x,(string(i),i=1,count)
1006         format(1x,a1,'[',i2,';',i1,'H',80a1)
          endif
       else 
          if (y .lt. 10) then
             write (*,1005) esc,y,x,(string(i),i=1,count)
1005         format(1x,a1,'[',i1,';',i2,'H',80a1)
          else
             write (*,1004) esc,y,x,(string(i),i=1,count)
1004         format(1x,a1,'[',i2,';',i2,'H',80a1)
          endif
       endif
c
       ivwrite = 0
       return
       end






       integer function ivmove(y,x)
c
c    This routine moves the cursor to position row=y, column=x.
c    It checks to be sure that y does not exceed 'maxline', and x does not
c    exceed 79 (the screen limits).
c
       include 'Pstuff.com'
       integer y,x
       character esc*1
c AMcW 8/2003
	return
c
       write(blank,1001)
c
       if (y .gt. maxline .or. x .gt. 79) then
          ivmove = -1
          return
       endif
c
       esc = char(27)
c       
       if (x .lt. 10) then
          if (y .lt. 10) then
             write (*,1007) esc,y,x
1007         format(1x,a1,'[',i1,';',i1,'H')
          else
             write (*,1006) esc,y,x
1006         format(1x,a1,'[',i2,';',i1,'H')
          endif
       else 
          if (y .lt. 10) then
             write (*,1005) esc,y,x
1005         format(1x,a1,'[',i1,';',i2,'H')
          else
             write (*,1004) esc,y,x
1004         format(1x,a1,'[',i2,';',i2,'H')
          endif
       endif
c
       ivmove = 0
       return
       end



    


       integer function ivcleol()
c    This routine clears to the end of a line, beginning with the current
c    cursor position.
c
       character*1 esc
c
c AMcW 8/2003
	return
c
       write(blank,1001)
       esc = char(27)
       write(*,1001) esc
1001   format(1x,a1,'[K')
c
       ivcleol = 0
       return
       end




       integer function ivbold(on)
c    
c    This routine either turns on the bold-face lettering, if on=1,
c    or turns it off, if on=0
c
       integer on
       character*1 esc
c
c AMcW 8/2003
	return
c
       write(blank,1001)
       esc = char(27)
       if(on.eq.1) then
             write(*,'(1x,a1,a)') esc,'[1m'
       else
             write(*,'(1x,a1,a)') esc,'[0m'
       endif 
c
       ivbold = 0
       return
       end





       integer function ivundl(on)
c
c    This routine either turns on the underlining of text, if on=1,
c    or turns it off.
c
       integer on
       character*1 esc
c
c AMcW 8/2003
	return
c
       write(blank,1001)
       esc = char(27)
       if(on.eq.1) then
             write(*,'(1x,a1,a)') esc,'[4m'
       else
             write(*,'(1x,a1,a)') esc,'[0m'
       endif 
c
       ivundl = 0
       return
       end

 




       integer function ivcpos(x,y)
c
c    Damned if I know what this clever little routine does!
c
       integer x,y
       character*1 esc

c AMcW 8/2003
	return
c
       write(blank,1001)
       esc = char(27)
       write(*,'(1x,a1,a)') esc,'[6n'

       ivcpos = 0
       return
       end



      subroutine nearly                                                  
c******************************************************************************
c     This routine calculates the quantity 'kapnu0' for each line and       
c     each tau; this is the line opacity at line center.  When kapnu0 is 
c     multiplied by the voigt function, one gets the line opacity at an 
c     arbitrary wavelength.  The damping parameter 'a' and the doppler   
c     factor 'dopp' are also computed                                    
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Quants.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Dummy.com'
      dimension xnum(75)
      equivalence (xnum,dummy1)


c*****do the whole routine for each line (1:nlines)
      do j=1,nlines                                                  


c*****set up some parameters
         ich = idint(charge(j) + 0.1)                    
         iatom = atom1(j)                                                   
         factoriso = 1.0d0
    
                  
c*****calculate the doppler factors
         do i=1,ntau                                                     
            dopp(j,i) = dsqrt(1.6631d8*t(i)/amass(j)+vturb(i)**2)               
         enddo


c*****calculate lower state atomic number densities for atoms.  Here,
c     q21 is the ion/neutral ratio, etc., and q is the ratio of the total
c     to the species of interest.  Do the Saha equation first, then
c     the Boltzmann equation
         if (iatom .ge. 100) go to 5                                         
         do i=1,ntau                                                     
            q21 = 4.825d15*u(iatom,2,i)/(u(iatom,1,i)*ne(i))*
     .            t(i)**1.5*dexp(-1.1605d4*chi(j,1)/t(i)) 
            q32 = 4.825d15*u(iatom,3,i)/(u(iatom,2,i)*ne(i))*
     .            t(i)**1.5*dexp(-1.1605d4*chi(j,2)/t(i)) 
            q43 = 4.825d15*u(iatom,4,i)/(u(iatom,3,i)*ne(i))*
     .            t(i)**1.5*dexp(-1.1605d4*chi(j,3)/t(i)) 
            if     (ich .eq. 1) then
               q = 1.0 + q21 + q32*q21 + q43*q32*q21
            elseif (ich .eq. 2) then
               q = 1.0/q21 + 1.0 + q32 + q43*q32
            elseif (ich .eq. 3) then
               q = 1.0/(q21*q32) + 1.0/q32 + 1.0 + q43
            endif
            if (neq .ne. 0) then
               do n=1,neq                                                      
                  if (iatom .eq. iorder(n)) then
                     xnum(i) = xamol(n,i)
                     if     (ich .eq. 1) then
                        q = 1.0
                     elseif (ich .eq. 2) then
                        q = 1.0/q21
                     endif
                     go to 35
                  endif
               enddo
            endif
            xnum(i) = xabund(iatom)*nhtot(i)
35          xnum(i) = xnum(i)/q*dexp(-1.1605d4*e(j,1)/t(i))/
     .             u(iatom,ich,i)   
         enddo
         go to 101                                                          


c*****calculate lower state molecular number densities and line opacities   
c     at line centers                                                       
5        am = chi(j,2)                                                      
         call sunder(atom1(j),iaa,ibb)                                        
         do n=1,neq                                                      
            if(iorder(n) .eq. iaa) ia = n                                       
            if(iorder(n) .eq. ibb) ib = n                                       
         enddo
         do i=1,ntau                                                     
            theta = 5040.0/t(i)                                                
            psipri = 1.38054d-16*t(i)*10.0**(chi(j,1)*theta-13.670)*
     .               theta**2.5/(am**1.5*u(iaa,1,i)*u(ibb,1,i)) 
            xnum(i) = dexp(-1.1605d4*e(j,1)/t(i))*psipri*
     .                xamol(ia,i)*xamol(ib,i)
         enddo


c*****calculate the line opacities at line centers
101      if (atom1(j)-float(iatom) .ge. 0.0) then
            do i=1,numiso
               if (atom1(j) .eq. isotope(i)) then
                  factoriso = isoabund(i,isorun)
               endif
            enddo
         endif
         do i=1,ntau
            kapnu0(j,i) = 2.65386d-2*xnum(i)*gf(j)*wave1(j)*1.0d-8/
     .                 dopp(j,i)*(1.0-dexp(-1.43879d8/
     .                 (wave1(j)*t(i))))/factoriso
c    .                 (wave1(j)*t(i))))/dfloat(factoriso)  replaced original AMcW 1/200
         enddo
         strength(j) = kapnu0(j,jtau5)/factoriso
c        strength(j) = kapnu0(j,jtau5)/dfloat(factoriso)    replaced original AMcW 1/200


c*****calculate the line broadening parameter; call a separate routine 
c     for special cases where the damping parameters are accurately known
         if (itru .eq. 1 .and. (atom1(j).eq.20.1 .or. 
     .       atom1(j).eq.20.0 .or. atom1(j).eq.11.0)) then
            ifind = -1
            call trudamp (j,ifind)
         else
            ifind = 0
         endif
         if (ifind .eq. 0) then
            if (ipr(3) .gt. 1) write (nwrite,1001) j, wave1(j)
1001        format(//' LINE BROADENING PARAMETERS FOR LINE', i4,
     .             ' AT WAVELENGTH',f8.2/
     .             '  i',4x,'natural',6x,'Stark',4x,'VdWaals',
     .             6x,'total',5x,'a(j,i)')
            do i=1,ntau                                                    
               v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))                   
               gammar = 2.223d15/wave1(j)**2
               excdiff = chi(j,idint(charge(j)+0.001)) - e(j,2)
               if (excdiff .gt. 0.0 .and. atom1(j).lt.100.) then
                  effn2 = 13.6*charge(j)**2/excdiff
               else
                  effn2 = 25.
               endif
               gammas = 1.0e-8*ne(i)*effn2**2.5
               gammav = 17.0*c6(j)**0.4*v1**0.6*nhneutral(i) 
               gammatot = gammar + gammas + gammav
               a(j,i) = gammatot*wave1(j)*1.0d-8/(12.56636*dopp(j,i)) 
               if (ipr(3) .gt. 1) write (nwrite,1002) i,gammar,
     .                            gammas,gammav,gammatot,a(j,i)
1002           format (i3,1p5e11.3)
            enddo
         endif
      enddo

c*****exit the routine normally
      call out (3)
      return                                                             

      end                                                                


      subroutine number (nchar,line,xnum)
c*****this routine decodes a character string into a double precision
c     floating point number.
 
      include 'Chars.com'
      real*8 xnum
      character form*10

 
c*****if a carriage return has been hit, return with -9999.
      if (nchar .le. 0) then
         xnum = -9999.
         return
      endif


c*****set the conversion format
20    if (nchar .lt. 10) then
         write(form,1001) nchar
1001     format('(f',i1,'.0)    ')
      else
         write(form,1002) nchar
1002     format('(f',i2,'.0)   ')
      endif

 
c*****now do the conversiton to a number
      read (unit=chinfo,fmt=form,iostat=ierr,err=100) xnum
      return

 
c*****here an error has been detected
100   write (errmess,1004) ierr,chinfo(1:nchar)
1004  format ('ERROR IN NUMBER INPUT: ERROR=',i4,5x,'NUMBER=',a20) 
      nchars = 65
      istat = ivwrite (line,3,errmess,nchars)
      xnum = -9999.
      return      


      end







      subroutine oneline (imode)                                    
c******************************************************************************
c     This routine computes a single line profile                       
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'
      include 'Pstuff.com'
      real*8 dinteg(200)
      data wavl/0.0/                                   

c AMcW 8/2003 for subroutine moog mode
	wavl = 0.0
c


c*****set an arbitrary maximum # of wavelength points to compute 
c     the line profile
      maxsteps = 75


c*****get started; calculate the step size
      if (imode .eq. 0) gf1(ncurve) = gf(lim1)                          
      dellam(1) = 0.                                                    
      if (wavestep .eq. 0.) then
         st1 = wave1(lim1)*dopp(lim1,jtau5)/2.997929e10/5.                 
         st1 = dble(int(10000.*st1))/10000.                              
      else
         st1 = wavestep
      endif


c*****calculate the continuous opacity at line wavelength               
      wave = wave1(lim1)                                                
      if (abs(wave-wavl) .gt. 30.) then
         wavl = wave
         call opacit(2,wave)     
         if (imode .ne. 2 ) call out(15)                        


c*****calculate continuum intensity/flux                                
         call cdcalc(1)                                                    
         first = 0.4343*cd(1)
         flux = rinteg(xref,cd,dummy1,ntau,first)
         if (imode .ne. 2) call out(10)         
      endif
      cflux(lim1) = flux
             

c*****recheck the wavelength step size
      if (wavestep .eq. 0.) then
140      wave = wave1(lim1)
         call taukap
         call cdcalc(2)                                                    
         first = 0.4343*cd(1)
         d(1) = rinteg(xref,cd,dummy1,ntau,first)
         wave = wave + 5.*st1
         call taukap
         call cdcalc(2)                                                    
         first = 0.4343*cd(1)
         d(2) = rinteg(xref,cd,dummy1,ntau,first)       
         if (d(2)/d(1) .lt. 0.7) then
            st1 = st1/1.5
            st1 = dfloat(int(10000.*st1))/10000.                              
            go to 140
         elseif (d(2)/d(1) .gt. 0.85) then
            st1 = st1*2.0
            st1 = dfloat(int(10000.*st1))/10000.                              
            go to 140
         endif
      endif
      wave = wave1(lim1)                                                
      if (imode .ne. 2) call out(2)    


c*****calculate wavelength dependent line quantities, and the line depth
c     until the depth is very small in the line wing
      do n=1,maxsteps
         call taukap                                                       
         call cdcalc(2)                                                    
         first = 0.4343*cd(1)
         d(n) = rinteg(xref,cd,dummy1,ntau,first)       
         if (ipr(3).ge.3 .and. n.eq.1) call out (22)
         if (ipr(6).ne.0 .and. imode.ne.2) call out (19)  
         if (d(n)/d(1) .lt. 0.0075) then
            ndepths = n
            go to 160
         endif
         dellam(n+1) = dellam(n) + st1                                    
         wave = wave1(lim1) + dellam(n+1)                                  
      enddo                                                             
      if (imode .ne. 2) call out (16)
      ndepths = maxsteps 


c*****finish the calculation                                            
160   if (imode .ne. 2) call out (17)                                       
      do n=2,ndepths
         d(ndepths+n-1) = d(n)
      enddo
      d(ndepths) = d(1)
      do n=2,ndepths
         d(n-1) = d(2*ndepths+1-n)
      enddo
      dellam(1) = -st1*(ndepths-1)
      ndep = 2*ndepths - 1
      do n=2,ndep
         dellam(n) = dellam(n-1) + st1
      enddo
      first = 2*dellam(ndep)*d(ndep)
      w(ncurve) = rinteg(dellam,d,dinteg,ndep,first) 
      if (imode .ne. 2) call out(14)                        
 
 
      return                                                            
      end                                                               



      subroutine opacit(modeop,waveop)                                       

c******************************************************************************
c     This routine calculates the continuous opacity *kaplam* or            
c     *kapref* and optical depth *taulam* as needed. the formulas are       
c     ones lifted from the write-up of program *atlas*                      
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'
      real*8 a1(8),b1(8),c1(8),an(8)
      real*8 taucheck(75), tauinteg(75)

c  initialization                                                        
      data a1/ 0.9916, 1.105, 1.101, 1.101, 1.102, 1.0986, 1.0, 1.0/            
      data b1/  2.719d13, -2.375d14, -9.863d13, -5.765d13, -3.909d13,
     .         -2.704d13,       0.0,       0.0/
      data c1/ -2.268d30,  4.077d28,  1.035d28,  4.593d27,  2.371d27,       
     .          1.229d27,       0.0,       0.0/

      if (ipr(1) .gt. 1) write (nwrite,1002) waveop                          
1002  format(/'log continuous opacity factors at wavelength =',f10.2//   
     .       '   ahbf ahmibf ahmiff  ah2op  ahray aheray ahemin    ael',
     .       '  kappa     nh    nhe'/)    

      freq = 2.997925d18/waveop 

c*****here is the big loop to calculate all opacities
      do 100 i=1,ntau                                                    
      tkev = 1.38054d-16*t(i)/1.602d-12                                  
      factor = 1.0 - dexp(-4.799d-11*freq/t(i))
      chplus = 4.82714d15*t(i)**1.5*dexp(-13.595/tkev)/u(1,1,i)
      chmin = 2.0716d-16*t(i)**(-1.5)*dexp(0.754/tkev)/u(1,1,i)
 
c*****hydrogen bound-free opacity                                               
      ahbf = 0.0                                                         
      do n=1,8                                                        
         if (freq .lt. 3.28805d15/n**2) then
            an(n) = 0.0                                                        
         else
            rn = n*1.0
            fix1 = 2.815d29/n**5/freq/freq/freq
            an(n) = fix1*(a1(n)+(b1(n)+c1(n)/freq)/freq)                  
         endif
         ahbf= ahbf + 2.0*n*n*an(n)*factor*
     .         dexp(13.595*(1.0/n**2-1.0)/tkev)     
      enddo
      ex = dexp(-13.427/tkev)                                             
      if (freq .lt. 4.05933d13) ex = ex/dexp(-4.799d-11*freq/t(i))   
      fix4 = 2.815d29*factor/freq/freq/freq
      ahbf = (ahbf + fix4*tkev/13.595*
     .       (ex - dexp(-13.595/tkev)))/u(1,1,i)

c*****h-minus free-free opacity                                             
      ahmiff = ne(i)*(1.3727d-25+(4.3748d-10-2.5993d-7/t(i))/freq)/freq  

c*****h-minus bound-free opacity    
      if (freq .ge. 2.111d14) then
         fora2 = -5.519d27 + (4.808d21/freq)*1.0d20    
         a2 = 6.801d-20 + (5.358d-3 + (1.481d13 + 
     .        fora2/freq)/freq)/freq        
      elseif (freq .ge. 1.8259d14) then
        a2 = 3.695d-16 + (-1.251d-1 + 1.052d13/freq)/freq                  
      else
        a2 = 0.
      endif
      ahmibf = chmin*ne(i)*a2*factor       

c*****hydrogen rayleigh scattering                                             
      wave2 = 2.997925d18/dmin1(freq,2.922d15)                           
      ahray = (5.799d-13 + 1.422d-6/wave2**2 + 2.784/wave2**4)/
     .        wave2**4   

c*****h2-plus molecular bound-free and free-free opacity                        
      fx1 = (-4.230d-26*freq**2)/1.0d20*(freq)
      fx2 = (1.224d-21*freq**2)/1.0d20*(freq**2/1.0d20) 
      fx3 = (-1.351d-27*freq**2)/1.0d20*(freq**2/1.0d20)*
     .      (freq/1.0d10)
      es = -7.342d-3 - 2.409d-15*freq + 1.028d-30*freq**2 + 
     .      fx1 + fx2 + fx3  
      fr1 = dlog(freq)                                                   
      fnut = (-es/tkev - 3.0233d3 + (3.7797d2 + (-1.82496d1 +
     .       (3.9207d-1 - 3.1672d-3*fr1)*fr1)*fr1)*fr1)           
      fx4 = dlog(chplus*nhneutral(i)/ne(i)*factor)
      ah2op = dexp(fx4 + fnut)

c*****helium rayleigh scattering                                                
      wave3 = 2.997925d18/dmin1(freq,5.15d15)                            
      aheray = 5.484d-14*(1.0+2.44d5/wave3**2+5.94d-10/                  
     .         (wave3**2*(wave3**2-2.90d5)))**2/wave3**4                        

c*****he-minus free-free opacity                                            
      ax = 3.397d-26 + (-5.216d-11 + 7.039d+05/freq)/freq                 
      bx = -4.116d-22 + (1.067d-06 + 8.135d+09/freq)/freq                 
      cx = 5.081d-17 + (-8.724d-03 - 5.659d+12/freq)/freq                  
      ahemin = ne(i)*(ax*t(i) + bx + cx/t(i))/10.0**20

c*****electron scattering
      ael = 0.6653d-24*ne(i)

c*****now sum up all the opacity contribution
      kaplam(i) = nhneutral(i)*(ahbf+ahmibf+ahmiff+ah2op+ahray) + 
     .            nheneutral(i)*(aheray+ahemin) + ael

c*****add in an arbitrary amount of "extra" continuous opacity;
c     this fudge added at Verne Smith's request, so blame him!
      if (fudge .gt. 0.0) then 
         kaplam(i) = kaplam(i)*((fudge*10000)/t(i))
         if (i .eq. 1) then
            write(nwrite,*) 'Opacity scaled by scaling',
     .           ' law of: '   
            write(nwrite,*) '      kaplam(i) = kaplam(i) * '
     .           ,'((',fudge,' * 10000)/t(i))'
         endif

      endif

c*****write out the opacity contributions, and end the main loop
      if (ipr(1) .gt. 1) write(nwrite,1001) dlog10(ahbf),
     .                   dlog10(ahmibf),dlog10(ahmiff),dlog10(ah2op),
     .                   dlog10(ahray),dlog10(aheray),dlog10(ahemin),
     .                   dlog10(ael),dlog10(kaplam(i)),
     .                   dlog10(nhneutral(i)),dlog10(nheneutral(i))            
1001  format(11f7.2)
100   continue                                                           

c*****compute an optical depth array at this wavelength, and exit
      if (modeop .ne. 1) then
         do  i=1,ntau                                                    
            dummy1(i) = tauref(i)*kaplam(i)/(0.4343*kapref(i))
         enddo
         first = tauref(1)*kaplam(1)/kapref(1)                          
         dummy1(1) = rinteg(xref,dummy1,taulam,ntau,first)  
         taulam(1) = first
         do i=2,ntau                                                    
            taulam(i) = taulam(i-1) + taulam(i) 
         enddo
         if (ipr(1) .gt. 1) write(nwrite,1003) (taulam(i),i=1,ntau)          
1003     format(/'TAULAM ARRAY'/(1p7e11.3))
         return
      endif

c*****here is the assignment of opacities kaplam to kapref
      do i=1,ntau   
         kapref(i) = kaplam(i)                                              
      enddo
      if(ipr(1) .lt. 2) return                                           

c*****here is an internal tauref check on the externally read in tau scale
      do i=1,ntau                                                    
         tauinteg(i) = tauref(i)*kaplam(i)/(0.4343*kapref(i))
      enddo
      first = tauref(1)                                              
      tauinteg(1) = rinteg(xref,tauinteg,dummy2,ntau,start)  
      taucheck(1) = first
      do i=2,ntau                                                    
         taucheck(i) = taucheck(i-1) + taucheck(i) 
      enddo
      write(nwrite,1003) (taucheck(i),i=1,ntau)                            
      return                                                             

      end                                                                





      subroutine out (number)                                             
c******************************************************************************
c     This routine is a printing subroutine                                 
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Strong.com'
      include 'Dummy.com'
      include 'Factor.com'
      include 'Pstuff.com'
      include 'Quants.com'
      character molname*8,name*1,parent*8,ion*4
      real*8 dd(5000)
      data n,num,ifresh/3*0/                                                    

c*****go to the appropriate output area
      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,
     .       18,19,20,21,22,23,24,25,26,27,28,29),number  

c*****here is the model atmosphere output; all drivers
1     if (ipr(1) .lt. 1) return                                           
      write (nwrite,107) moditle
107   format (/'MODEL ATMOSPHERE HEADER:'/a80/)
      do i=1,ntau                                                    
         dummy1(i) = dlog10(pgas(i))                                        
         dummy2(i) = dlog10(ne(i)*1.38054d-16*t(i))                         
      enddo
      write (nwrite,101) wavref,(i,xref(i),tauref(i),t(i),dummy1(i),      
     .      pgas(i),dummy2(i),ne(i),vturb(i),i=1,ntau)                        
101   format ('INPUT ATMOSPHERE QUANTITIES',10x,                      
     .        '(reference wavelength =',f10.2,')'/3x,'i',2x,'xref',3x,
     .        'tauref',7x,'T',6x,'logPg',4x,'Pgas',6x,'logPe',
     .        5x,'Ne',9x,'Vturb'/ 
     .        (i4,0pf6.2,1pe11.4,0pf9.1,f8.3,1pe11.4,0pf8.3,
     .        1pe11.4,e11.2))       
      write (nwrite,102)                                                  
102   format (/'INPUT ABUNDANCES: (log10 number densities, log H=12)'/
     .       '      Default solar abundances: Anders and Grevesse 1989')
      do i=1,95                                                      
         dummy1(i) = dlog10(xabund(i)) + 12.0                               
      enddo
      write (nwrite,104) (names(i),i,dummy1(i),i=1,95)                     
104   format (5(3x,a2,'(',i2,')=',f5.2))                                      
      write (nwrite,106) (ipr(i),i=1,4)                                  
106   format (/'OPTIONS: atmosphere = ',i1,5x,'molecules  = ',i1/
     .        '         lines      = ',i1,5x,'flux/int   = ',i1)
      return                                                             

c*****here is the calculated wavelength step size; single-line computations
2     write (nwrite,201) lim1,st1
201   format (/'LINE NUMBER',i5,10x,'wavelength step size =',f7.4)
      return   
                                                          
c*****here are the line data; all drivers
3     if(ipr(3) .lt. 1) return                                           
      write (nwrite,311) nlines
311   format (/'INPUT LINES DATA FOR',i4,' LINES'/' j ',4x,'wave1',
     .       7x,'species',8x,'E.P.',5x,'gf',8x,'C6',
     .       5x,'strength',6x,'E.W.')
      do j=1,nlines
         ich = idint(charge(j) + 0.1)
         if (ich .eq. 1) then 
            ion = ' I  '
         elseif (ich .eq. 2) then
            ion = ' II '
         elseif (ich .eq. 3) then
            ion = ' III'
         endif
         iatom = idint(atom1(j))
         if (iatom .lt. 100) then
            if (iunits .eq. 1) then
               write (nwrite,313) j,1.d-4*wave1(j),names(iatom),
     .           ion,atom1(j),e(j,1),gf(j),c6(j),
     .           strength(j),1000.*width(j)
            else if(iunits .eq. 2) then
               write (nwrite,312) j,1.d8/wave1(j),names(iatom),
     .           ion,atom1(j),e(j,1),gf(j),c6(j),
     .           strength(j),1000.*width(j)
            else
               write (nwrite,312) j,wave1(j),names(iatom),
     .           ion,atom1(j),e(j,1),gf(j),c6(j),
     .           strength(j),1000.*width(j)
            endif
312         format (i3,f10.3,3x,a2,a4,2f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
313         format (i3,f10.6,3x,a2,a4,2f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
         else
            call sunder (atom1(j),ia,ib)
            if (ia .eq. 1) then
               l = ia
               ia = ib
               ib = l
            endif
            leftovr = idint(10000.*(atom1(j)-iatom)+0.1)
            if (ia .lt. 10) then
               read (names(ia),345) name
345            format (a1)
               write (molname,343) name,names(ib),leftovr
343            format (1x,a1,a2,i4)
            else
               write (molname,341) names(ia),names(ib),leftovr
341            format (2a2,i4)
            endif
            if (iunits .eq. 1) then
               write (nwrite,344) j,1.d-4*wave1(j),molname,atom1(j),
     .           e(j,1),gf(j),c6(j),strength(j),1000.*width(j)
            else if (iunits .eq. 2) then
               write (nwrite,342) j,1.d8/wave1(j),molname,atom1(j),
     .           e(j,1),gf(j),c6(j),strength(j),1000.*width(j)
            else
               write (nwrite,342) j,wave1(j),molname,atom1(j),
     .           e(j,1),gf(j),c6(j),strength(j),1000.*width(j)
            endif
342         format (i3,f10.3,2x,a8,f7.1,f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
344         format (i3,f10.6,2x,a8,f7.1,f8.2,1pe10.2,e10.2,
     .              e10.2,0pf10.2)
         endif
      enddo    
      if (start .eq. 0.0 .and. stop .eq. 0.0) go to 304
      if (iunits .eq. 2) then
         write (nwrite,303) oldstart,oldstop,oldstep,olddelta
      elseif (iunits .eq. 1) then
         write (nwrite,305) oldstart,oldstop,oldstep,olddelta
      else 
         write (nwrite,306) start,stop,step,delta  
      endif
303   format (/'SYNTHETIC SPECTRUM PARAMETERS (units=1/cm)'/
     .      10x,'start =',f11.3,' ',5x,'stop =',f11.3,' '/  
     .      'step size in the spectrum =',f11.4,' '/                       
     .      'at each point, opacity will include lines' ,
     .      ' within',f11.4,' of the point')          
305   format (/'SYNTHETIC SPECTRUM PARAMETERS (units=microns)'/
     .      10x,'start =',f10.7,' ',5x,'stop =',f10.7,' '/  
     .      'step size in the spectrum =',f10.7,' '/                       
     .      'at each point, opacity will include lines' ,
     .      ' within',f10.7,' of the point')          
306   format (/'SYNTHETIC SPECTRUM PARAMETERS (units=A)'/
     .      10x,'start =',f11.3,' ',5x,'stop =',f11.3,' '/  
     .      'step size in the spectrum =',f11.4,' '/                       
     .      'at each point, opacity will include lines' ,
     .      ' within',f11.4,' of the point')          

304   if (rwlow .ne. 0.) then
         write (nwrite,333) rwlow, rwhigh, rwstep
333      format (/'CURVE-OF-GROWTH PARAMETERS'/
     .           10x,'log(R.W) lower bound =',f7.3,
     .           10x,'upper bound =',f7.3/
     .           10x,'step size in the curve =',f7.3)
      endif  

      if(ipr(3) .lt. 4) go to 4

9     write (nwrite,901)                                                  
901   format (/'PARTITION FUNCTIONS')                                      
      do j=1,95
         if (elem(j) .ne. 0.) then
            iatom = int(elem(j))
            write (nwrite,903) iatom, names(iatom), xam(j),
     .                         xchi1(j), xchi2(j), xchi3(j)
903         format (/'Z =',i2,' (',a2,'),  mass=',f8.3,'  I.P.s=',
     .              3f7.3)
            do k=1,4
               write (nwrite,904) k-1,(u(j,k,i),i=1,ntau)   
904            format ('    ionization state = ',i1/(10f8.3))  
            enddo
         endif
      enddo
      return                                                             

4     if (ipr(3) .lt. 2) return                                           
      write (nwrite,401)                                                  
401   format (/'LINE OPACITIES AT LINE CENTERS')                          
      do j=1,nlines                                                  
         write (nwrite,403) j,(kapnu0(j,i),i=1,ntau)                         
403      format (10h0  kapnu0(,i3,3h,i)/(8(1pe10.2)))                        
      enddo
      return                                                             

5     write (nwrite,501) (amol(i),(const(j,i),j=1,6),i=1,nmol)            
501   format (/'INPUT EQUILIBRIUM DATA:'/1x,'species',3x,'const1',       
     1 3x,'const2',6x,'const3',6x,'const4',6x,'const5',6x,'const6'/      
     2 (0pf8.1,f8.3,1p5e12.4))                                         
      return                                                             

6     do 602 i=1,neq                                                     
602   dummy1(i) = iorder(i)                                              
      write (nwrite,601) (dummy1(i),i=1,neq),(amol(i),i=1,nmol)           
601   format (/'MOLECULAR EQUILIBRIUM SOLUTIONS:  (log partial',
     .       ' pressures listed under names)'/                    
     .       2x,'i',5x,'T',6x,'Pgas',6f10.1/(19x,6f10.1))               
      return                                        
                     
7     pglog = dlog10(pgas(lev))
      write (nwrite,701) lev,t(lev),pglog,(xatom(i),i=1,neq),         
     .                   (xmol(i),i=1,nmol)        
701   format (i3,f8.0,f8.2,6f10.2/(19x,6f10.2))                   
      return                                                             

8     if (ipr(1) .lt. 1) return                                           
      write (nwrite,801) (kapref(i),i=1,ntau)                             
801   format (/'KAPREF ARRAY:'/(6(1pe12.5)))                  
      return                                                             

10    if (iunits .eq. 2) then 
         write (nwrite,1001) 1d8/wave,flux                     
      else if (iunits .eq. 1) then 
         write (nwrite,1002) wave/1d4,flux
      else 
         write (nwrite,1001) wave,flux
      endif
1001  format ('AT WAVELENGTH/FREQUENCY =',f11.3,
     .        '  CONTINUUM FLUX/INTENSITY =',1pe12.5)
1002  format ('AT WAVELENGTH/FREQUENCY =',f11.7,
     .        '  CONTINUUM FLUX/INTENSITY =',1pe12.5)
      return

11    write (nwrite,1101)                                                 
1101  format (/'SPECTRUM DEPTHS')                                      
      if (ndump .eq. 0) return                                           
      write (ndump,1805) moditle
      if (iraf .eq. 1) then
         npoint = (stop-start)/step
         write (n2write,1104) npoint,wave,wave,step,step
1104     format ('SIMPLE  =    t'/'NAXIS   =     1'/'NAXIS1  = ',i10,/
     .   'W0      =',f10.4/'CRVAL1  =',f10.4/'WPC     =',f10.4/
     .   'CDELT1  =',f10.4)
         write (n2write,1105) 
1105     format (16HORIGIN  = 'moog'/21HDATA-TYP= 'synthetic'/
     .           18HCTYPE1  = 'lambda'/21HCUNIT1  = 'angstroms')
         write (n2write,1106) moditle
1106     format (11HTITLE   = ',A65,1H')
         do j=1,93
            if (pec(j) .gt. 0 ) then
               dummy1(j) = dlog10(xabund(j)) + 12.0
               write (n2write,1107) names(j),dummy1(j)
1107           format ('ATOM    = ',1H',7x,a2,1H',/,'ABUND   = ',f10.2)
            endif
         enddo
         write (n2write,1108) vturb(1)
1108     format ('VTURB   = ',e10.4,'     /  cm/sec  ')
         write (n2write,1109)
1109     format ('END')
      endif
      if (iunits .eq. 2) then
         write (ndump,1102) oldstart,oldstop,oldstep,olddelta
      elseif (iunits .eq. 1) then
         write (ndump,1103) oldstart,oldstop,oldstep,olddelta
      else 
         write (ndump,1102) start,stop,step,delta  
      endif
1102  format (4f11.3)                                                     
1103  format (4f10.7)                                                     
      return                                                             

12    n = n + 1                                                          
      if (n .lt. 10) return    
      if (iraf .eq. 1) then
         do j=1,10
            dd(num+j) = 1. - d(num+j)
         enddo
         write (n2write,1202) (dd(num+j),j=1,10)
1202     format (10f7.4)            
      endif
      if (iunits .eq. 2) then
         wave3 = 1.d8/wave + 9.0*oldstep 
         write (nwrite,1203) wave3,(d(num+j),j=1,10)                         
      else if (iunits .eq. 1) then
         wave3 = 1.d-4*(wave - 9.0*step)
         write (nwrite,1201) wave3,(d(num+j),j=1,10)                         
      else 
         wave3 = wave - 9.0*step
         write (nwrite,1203) wave3,(d(num+j),j=1,10)                         
      endif
1201  format (f10.7,': depths=',10f6.3)                       
1203  format (f10.3,': depths=',10f6.3)                       
      if(ndump .gt. 0) write (ndump,1202) (d(num+j),j=1,10)              
      n = 0                                                              
      num = num + 10                                                     
      if (num .ge. 5000) num = 0                                          
      return                                                             

13    if(n .eq. 0) go to 1301                                            
      if (iraf .eq. 1) then
         do j=1,10
            dd(num+j) = 1. - d(num+j)
         enddo
         write (n2write,1202) (dd(num+j),j=1,n)
      endif
      if (iunits .eq. 2) then
         wave3 = 1.d8/wave + 9.0*oldstep 
         write (nwrite,1203) wave3,(d(num+j),j=1,n)                         
      else if (iunits .eq. 1) then
         wave3 = 1.d-4*(wave - 9.0*step)
         write (nwrite,1201) wave3,(d(num+j),j=1,n)                         
      else 
         wave3 = wave - 9.0*step
         write (nwrite,1203) wave3,(d(num+j),j=1,n)                         
      endif
      if (ndump .gt. 0) write(ndump,1202) (d(num+j),j=1,n)               
1301  if (iunits .eq. 2) then
         write (nwrite,1302) 1.d8/wave
      elseif (iunits .eq. 1) then
         write (nwrite,1304) 1.d-4*wave
      else
         write (nwrite,1302) wave
      endif
1302  format ('FINAL WAVELENGTH/FREQUENCY =',f10.3/) 
1304  format ('FINAL WAVELENGTH/FREQUENCY =',f10.7/)
      num = 0                                                        
      n = num 
      return                                                             

14    ew = 1000.0*w(ncurve)
      gflog = dlog10(gf1(ncurve))                                        
      rwlog = dlog10(w(ncurve)/wave1(lim1))                          
      write (nwrite,1401) wave1(lim1),ew,rwlog,gf1(ncurve),gflog      
1401  format('lambda =',f12.3,5x,'E.W. =',f8.1,' mA.',5x,
     .       'log(R.W.) =',f6.2/'gf =',1pe10.3,5x,'log(gf) =',
     .       0pf7.2)                      
      return                                                             

15    if (ipr(1) .lt. 2) return                                           
      write(nwrite,1501) wave,(kaplam(i),i=1,ntau)                       
1501  format('  kaplam from 1 to ntau at wavelength',f10.2/            
     1 (6(1pe12.4)))                                                     
      return                                                             

16    write (nwrite,1601)
1601  format ('WARNING:  not enough points to specify the line?')
      return                                                             

17    write (nwrite,1701) (d(j),j=1,ndepths)                     
1701  format (10f7.3)
      return                                                             

18    if (ndump .ne. 0 .and. lim1 .eq. 1) 
     .   write (ndump,1805) moditle
1805  format (a80)                                                       
      do 1801 i=1,ncurve                                                 
      w(i) = dlog10(w(i)/wave1(lim1))
1801  gf1(i) = dlog10(gf1(i))                                            
      iatom = atom1(lim1)                                                
      if(iatom .ge. 100) iatom = 1                                       
      abund = dlog10(xabund(iatom)) + 12.                                
      write (nwrite,1803) wave1(lim1),atom1(lim1),e(lim1,1),
     .                    abund,ncurve  
1803  format(/'wavelength =',f8.2,5x,'species =',f6.1,5x,'ep =',f6.2/,
     1 'abundance =',f9.2,5x,'n =',i2)                                      
      write (nwrite,1802) (gf1(i),w(i),i=1,ncurve)                        
1802  format('  curve of growth in (loggf,logrw) pairs'/                 
     1 (5('  (',f5.2,',',f5.2,')')))                                     
      if (ndump .eq. 0) return                                           
      write (ndump,1803) wave1(lim1),atom1(lim1),e(lim1,1),
     .       abund,ncurve   
      write (ndump,1804) (gf1(i),w(i),i=1,ncurve)                         
1804  format (12f6.2)                                                     
      return                                                             

19    do 1901 i=1,ntau                                                   
      if(taunu(i)+taulam(i) .ge. 1.) go to 1902                          
1901  continue                                                           
1902  write(nwrite,1903) i,taunu(i),taulam(i)                            
1903  format('  tau(total) is greater than 1 at level',i3,               
     1 '  optical depths are taunu =',e12.3,'  and taulam =',e12.3)       
      return                               

20    write (nwrite,2002)
      xmetals = abscale + pecabund(99,isynth)
2002  format (/'For these computations, some abundances have ',
     .       ' been altered:')
      write (nwrite,2007) xmetals
2007  format (' ALL abundances NOT listed below differ ',
     .        'from solar by ',f6.2,' dex')
      if (.not.curt) write (ndump,2007) xmetals
      do 2001 j=1,93
         if (pec(j) .gt. 0 ) then
            dummy1(j) = dlog10(xabund(j)) + 12.0         
            write (nwrite,2003) names(j),dummy1(j)
2003        format (8x,'element ',a2,':  abundance = ',f5.2)
            write (ndump,2003) names(j),dummy1(j)
         endif
2001     continue
      return            

21    write (nwrite,2102) modtype
2102  format (13('-'),'MOOG OUTPUT FILE',10('-'),
     .        '(MOOG version from 3/09/95)',13('-')//
     .        'THE MODEL TYPE: ',a10)
      if (modtype .eq. 'begn      ' .or.
     .    modtype .eq. 'BEGN      ') write (nwrite,2103)
2103  format ('   The Rosseland opacities and optical depths have ',
     .        'been read in')
      return

22    do i=1,ntau                                                   
         cd(i) = dabs(cd(i)) 
         dummy1(i) = xref(i)*cd(i)
      enddo
      first = 0.
      xmean = rinteg(xref,dummy1,dummy2,ntau,first)/
     .        rinteg(xref,cd,dummy2,ntau,first) 
c
c now write-out the contribution function elements
c
      write (nwrite,'(a)') 'TAUNU(I)'
      write (nwrite,*) (taunu(i),i=1,ntau)
      write (nwrite,'(//)')
c
      write (nwrite,2205) xmean                                           
2205  format (/' mean level of line depth formation, log(tauref) = ',
     .       f6.2)                                                            
      do i=1,ntau
         if (taulam(i)+taunu(i) .ge. 1.) then
            write (nwrite,2206) xref(i)
2206        format (' log(tauref) for [taulam+taunu>=1] is ',
     .              f6.2)
            return
         endif
      enddo

23    return

24    if (ncurve .ne. 1) then
         write (nwrite,2402) ncurve
2402     format (' This fit required ',i2,' iterations')
      endif
      return

25    if(ifresh .eq.0) then
         write (ndump,2511) obsitle,moditle
2511     format (a80)
c AMcW 8/2003
c        ifresh = 1
      endif
      if (cogatom .eq. 0.) then
         iatom = idint(atom1(lim1obs))
      else
         iatom = idint(cogatom)
      endif
      xab = dlog10(xabund(iatom)) + 12.
      ich = idint(charge(lim1obs) + 0.1)
      if (ich .eq. 1) then 
         ion = ' I  '
      elseif (ich .eq. 2) then
         ion = ' II '
      elseif (ich .eq. 3) then
         ion = ' III'
      endif
      if (iatom .lt. 100) then
         write (array,2504) names(iatom),ion,xab
2504     format ( 'Abundance Results for Species ',a2,a4,
     .        '       (input abundance = ',f6.2,')')
         line = 1
         call prinfo (line)
         write (ndump,*)
         write (ndump,2504) names(iatom),ion,xab
         write (array,2514)
2514     format ('wavelength        EP     logGF        EW',
     .        '     logRW     abund     del avg')
         line = 2
         call prinfo (line)
         write (ndump,2514)
      else
         call sunder (atom1(j),ia,ib)
         if (ia .eq. 1) then
            l = ia
            ia = ib
            ib = l
         endif
         leftovr = idint(10000.*(atom1(j)-iatom)+0.1)
         if (ia .lt. 10) then
            read (names(ia),345) name
            write (molname,343) name,names(ib),leftovr
         else
            write (molname,341) names(ia),names(ib),leftovr
         endif
         write (array,2506) molname,xab
2506     format ( 'Abundance Results for Species ',a8,
     .        '       (input abundance = ',f6.2,')')
         line = 1
         call prinfo (line)
         write (ndump,*)
         write (ndump,2506) molname,xab
         write (array,2516)
2516     format('wavelength        EP     logGF      EWin',
     .        '    EWcalc     abund     del avg')
         line = 2
         call prinfo (line)
         write (ndump,2516)
      endif
      do 2510 l=lim1obs,lim2obs
         if (abunout(l) .ne. 999.99) then
            diff = abunout(l) - average
         else
            diff = 999.99
         endif
         ew = 1000.*width(l)
         rw = dlog10(width(l)/wave1(l))
         write (array,2501) wave1(l),e(l,1),dlog10(gf(l)), 
     .         ew,rw,abunout(l),diff
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,2501) wave1(l),e(l,1),dlog10(gf(l)), 
     .         ew,rw,abunout(l),diff
2501     format (f10.2,f10.2,f10.3,f10.1,2f10.2,f12.2)
2510  continue
      write (array,2505) average, deviate, kount
      line = line + 1
      if (errmess(1:9) .ne. 'stopinfo!') call prinfo (line)
      write (ndump,2505) average, deviate, kount
2505  format ('average abundance = ',f5.2,'     std. ',
     .     'deviation = ',f5.2,'     #lines = ',i3)
      if (kount .gt. 2 .and. deltaep .gt. 1.5) then
         write (array,2507) xxm1, xxb1, xxr1 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,2507) xxm1, xxb1, xxr1
2507     format ('E.P. correlation:  slope = ',f7.3,'  intercept = ',
     .           f7.3,'  corr. coeff. = ',f7.3)
      else
         write (array,*) 'No statistics done for E.P. trends' 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,*) 'No statistics done for E.P. trends' 
      endif
      if (kount .gt. 2 .and. deltarw .gt. 0.5) then
         write (array,2508) xxm2, xxb2, xxr2   
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,2508) xxm2, xxb2, xxr2   
2508     format ('R.W. correlation:  slope = ',f7.3,'  intercept = ',
     .           f7.3,'  corr. coeff. = ',f7.3)
      else
         write (array,*) 'No statistics done for R.W. trends' 
         if (errmess(1:9) .ne. 'stopinfo!') then
            line = line + 1
            call prinfo (line)
         endif
         write (ndump,*) 'No statistics done for R.W. trends' 
      endif
      return

26    write (nwrite,*) 'Isotopic Ratios given for this synthesis'
      do 261 i=1,numiso
      iiso=isotope(i)
      call sunder (isotope(i),ia,ib)
      if (ia .eq. 1) then
         l = ia
         ia = ib
         ib = l
      endif
      leftovr = idint(10000.*(isotope(i)-iiso)+0.1)
      if (ia .lt. 10) then
         read (names(ia),2645) name
2645     format (a1)
         write (molname,2643) name,names(ib),leftovr
2643     format (1x,a1,a2,i4)
      else
         write (molname,2641) names(ia),names(ib),leftovr
2641     format (2a2,i4)
      endif
      if (ia .lt. 10) then
         write (parent,2642) names(ia),names(ib) 
2642     format (a1,a2) 
      else 
         write(parent,2644) names(ia),names(ib)
2644     format (2a2)
      endif
      write (nwrite,2601) parent,molname,isoabund(i,isorun)
      write (ndump,2601) parent,molname,isoabund(i,isorun)
2601  format ('Isotope Ratio: ',a4,'/',a10,' = ',f10.3)
261   continue
      return

 27   write (nwrite,2711) nstrong
2711   format (/'INPUT LINES DATA FOR',i4,' STRONG LINES'/' j ',4x,
     .       'wave1',7x,'species',8x,'E.P.',6x,'gf',9x,'C6',
     .       6x,'strength')
      do 2710 j=1,nstrong
      ich = idint(scharge(j) + 0.1)
      if (ich .eq. 1) then 
         ion = ' I  '
      elseif (ich .eq. 2) then
         ion = ' II '
      elseif (ich .eq. 3) then
         ion = ' III'
      endif
      iatom = idint(satom1(j))
      if (iatom .lt. 100) then
         if (iunits .eq. 1) then
            write (nwrite,2713) j,1.d-4*swave1(j),names(iatom),
     .           ion,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else if(iunits .eq. 2) then
            write (nwrite,2712) j,1.d8/swave1(j),names(iatom),
     .           ion,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else
            write (nwrite,2712) j,swave1(j),names(iatom),
     .           ion,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         endif
2712      format (i3,f10.3,3x,a2,a4,2f8.2,1pe11.3,e11.3,e11.2)             
 2713     format (i3,f10.6,3x,a2,a4,2f8.2,1pe11.3,e11.3,e11.2)             
      else
         call sunder (satom1(j),ia,ib)
         if (ia .eq. 1) then
            l = ia
            ia = ib
            ib = l
         endif
         leftovr = idint(10000.*(satom1(j)-iatom)+0.1)
         if (ia .lt. 10) then
            read (names(ia),2745) name
2745         format (a1)
            write (molname,2743) name,names(ib),leftovr
2743         format (1x,a1,a2,i4)
         else
            write (molname,2741) names(ia),names(ib),leftovr
2741         format (2a2,i4)
         endif
         if (iunits .eq. 1) then
            write (nwrite,2744) j,1.d-4*swave1(j),molname,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else if (iunits .eq. 2) then
            write (nwrite,2742) j,1.d8/swave1(j),molname,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         else
            write (nwrite,2742) j,swave1(j),molname,satom1(j),
     .           se(j,1),sgf(j),sc6(j),skapnu0(j,jtau5)
         endif
2742      format (i3,f10.3,2x,a8,f7.1,f8.2,1pe11.3,e11.3,e11.2)             
2744      format (i3,f10.6,2x,a8,f7.1,f8.2,1pe11.3,e11.3,e11.2)             
      endif
2710   continue
2704   if(ipr(3) .ge. 2) go to 4                                           
       return

28    if (ifresh .eq.0) then
         write (ndump,2811) obsitle,moditle
2811     format (a80)
c AMcW 8/2003
c        ifresh = 1
      endif
c     write (*,2804)
2804  format (/'Equivalent Widths Results '
     .     /'wavelength        EP     logGF     ident',
     .     '     Abund    EWcalc   Cont. Flux')
      write (ndump,2804)
      do l=lim1obs,lim2obs
         iatom = atom1(l)
         xab = dlog10(xabund(iatom)) + 12.
         ich = idint(charge(l) + 0.1)
         if (ich .eq. 1) then 
            ion = ' I  '
         elseif (ich .eq. 2) then
            ion = ' II '
         elseif (ich .eq. 3) then
            ion = ' III'
         endif
         if (iatom .lt. 100) then
c           write (*,2801) wave1(l),e(l,1),dlog10(gf(l)),names(iatom),
c    .           ion,xab,1000.*widout(l),cflux(l)
            write (ndump,2801) wave1(l),e(l,1),dlog10(gf(l)),
     .           names(iatom),ion,xab,1000.*widout(l),cflux(l)
 2801       format (f10.2,f10.2,f10.3,'     ',a2,a3,f10.2,f10.1,3x,
     .               1pe12.6)
         else
c           write (*,2802) wave1(l),e(l,1),dlog10(gf(l)),atom1(l),
c    .           xab,1000.*widout(l)
            write (ndump,2802) wave1(l),e(l,1),dlog10(gf(l)),atom1(l),
     .         xab,1000.*widout(l)
 2802       format (f10.2,f10.2,f10.3,a10,f10.2,f10.1)
         end if
      end do
      return

29    do 2910 l=lim1obs,lim2obs
         if (abunout(l).lt.999.) then
            ew = 1000.*width(l)
            rw = dlog10(width(l)/wave1(l))
            write (ndump,2901) lineid(l),wave1(l),e(l,1),dlog10(gf(l)),
     .         ew,abunout(l)
2901        format (a5,f10.3,f8.3,f8.3,f8.2,f8.3)
         endif
2910  continue

      return
      end                                                                


      subroutine params
c******************************************************************************
c     This subroutine reads in the commands from the parameter file
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Factor.com'
      include 'Pstuff.com'
      include 'Strong.com'
      include 'Mol.com'
      character keyword*10
      character arrayz*80

c  initialize some variables:
c  terminal type
      smterm = ' '
c  atmosphere data [1], molecular equilibrium [2], line data [3], 
c  flux/intensity [4], synthesis/single line computations [5], 
c  line formation [6], plotting [7], damping [8], and
c  observed spectrum file type [9] flags 
      ipr(1) = 1
      ipr(2) = 0
      ipr(3) = 1
      ipr(4) = 0
      ipr(5) = 0
      ipr(6) = 0
      ipr(7) = 0
      ipr(8) = 0
      ipr(9) = 0
      iunits = 0
      itru = 1
      iscale = 0
      nlines = 0
      iraf = 0
      do i=1,100
         pec(i) = 0
      enddo
 
c   if fudge is less than or equal to 0 then it does not scale it...make it
c   -1.0 just to be sure we dont have floating poing problems with 0.0
      fudge = -1.0

c  set curt mode to false as default
c
      curt = .false.

c  elements with special abundance data
      neq = 0
      numpecatom = 0
      numatomsyn = 0
      numiso = 0
      numisosyn = 0
c  spectrum run parameters
      start = 0.
      stop = 0.
      step = 0.
      delta = 0.
      cogatom = 0.
c  line limit parameters
      ncurve = 0
      lim1line = 0
      lim2line = 0
      lim1obs = 0
      lim2obs = 0
      lim1 = 0
      lim2 = 0

c  look for the key word, always in the first 10 columns of a line
c  then act on that keyword
5     write (array,1007)
1007  format (79(' '))
      read (nparam,1001,end=100) arrayz
1001  format (a80)

      i=index(arrayz,' ')
      keyword = arrayz(1:i-1)
      array = arrayz(i:)

c  keyword 'atmosphere' controls the output of atmosphere quantities
c           0 = do not print out the atmosphere
c           1 = print out the standard things about an atmsophere
c           2 = print standard things and additional stuff like continuous
c                    opacities, etc.
      if     (keyword .eq. 'atmosphere') then
         read (array,*) ipr(1)
1003     format (10x,i5)

c  keyword 'molecules ' controls the molecular equilibrium calculations
c           0 = do not do molecular equilibrium
c           1 = do molecular equilibrium but do not print results
c           2 = do molecular equilibrium and print results
      elseif (keyword .eq. 'molecules') then
         read (array,*) ipr(2)

c  keyword 'lines     ' controls the output of line data
c           0 = print out nothing about the input lines
c           1 = print out standard information about the input line list
c           2 = gory line data print (usually for diagnostic purposes)
      elseif (keyword .eq. 'lines') then
         read (array,*) ipr(3)
         iopr(3) = ipr(3)

c  keyword 'pscale    ' allows you to set all of the plotting 
c     parameters if you know them in advance
c     0 = user supplied in plotting routine (default)
c     1 = given in following lines as follows 
c
c     xlow xhi ylo yhi
c     vshift lamshift obsadd obsmult
c     smooth-type smooth-FWHM
      elseif (keyword .eq. 'pscale') then
         read (array,*) iscale
         read (nparam,*) xlo,xhi,ylo,yhi
         read (nparam,*) vmult,xadd,yadd,ymult
         read (nparam,*) smtype,half
c
c keyword 'curt       ' gives curt output   AMcW 1/2000
c
      elseif (keyword .eq. 'curt') then
         curt = .true.


c keyword 'trudamp     '  should moog use the detailed line damping for
c                         those transitions that have information stored in
c                         subroutine trudamp? (Default is *yes*)
      elseif (keyword .eq. 'trudamp') then
         read (array,*) itru


c keyword 'units      ' controls the units in which moog 
c          outputs the final spectrum
c            0 = angs
c            1 = microns
c            2 = 1/cm
      elseif (keyword .eq. 'units') then
         read (array,*) iunits


c keyword 'iraf       ' allows the user to output a raw spectrum in 
c          a form suitable for IRAF's rtext input command
c            0 = don't do this, make output the normal way.
c            1 = make an IRAF-compatible output
      elseif (keyword .eq. 'iraf') then
         read (array,*) iraf


c  keyword 'flux/int  ' choses integrated flux or central intensity
c           0 = integrated flux calculations
c           1 = central intensity calculations
      elseif (keyword .eq. 'flux/int') then
         read (array,*) ipr(4)
 1013   format(8x,i30)

c  keyword 'damping   ' controls the output of line data
c           0 = use the Unsold approximation, except multiply possibly
c                 by a factor read in for an individual line
c           1 = use the Unsold approximation multiplied by 6.3
c           2 = use the Unsold approximation multiplied by the
c                 factor recommended by the Blackwell group
      elseif (keyword .eq. 'damping') then
         read (array,*) ipr(8)

c  keyword 'obspectrum' controls the file type of the observed spectrum
c           0 = no observed spectrum is to be input
c           1 = read a true FITS file
c           2 = (not implemented yet)
c           3 = (not implemented yet)
c           4 = (not implemented yet)
c           5 = read a special MONGO style (wavelength, flux pair) file
      elseif (keyword .eq. 'obspectrum') then
         read (array,*) ipr(9)

c  keyword 'terminal  ' gives the SUPERMONGO terminal type
c           name = the terminal type name that SUPERMONGO recognizes
c                  (see the SUPERMONGO manual for a list)
      elseif (keyword .eq. 'terminal') then
         read (array,*) smterm

c  keyword 'plot      ' decides whether or not to make a plot of results
c           0 = do not make a plot
c           For syntheses: 1 = plot only synthetic spectra
c                          2 = plot synthetic and observed spectra
c           For line analyses: # = the minimum number of lines of a 
c                                  species necessary to trigger a plot
      elseif (keyword .eq. 'plot') then
         read (array,*) ipr(7)

c  keyword 'abundances' gives the changes to be applied to the abundances
c           # = the number of different syntheses to run
c               (the next line gives the different abundance factors
c               to use)
      elseif (keyword .eq. 'abundances') then
         read (array,*) numpecatom,numatomsyn
1005     format (10x,i5,i5)
         do l=1,numpecatom
            read (nparam,*) j,(pecabund(j,k),k=1,numatomsyn)
1019        format(i10,8f8.0)
            pec(j) = 1
         end do

c keyword 'isotopes   ' gives the isotopes used in the line list and their
c                       abundance relative to the parent spiecies
      elseif (keyword .eq. 'isotopes') then
         read (array,*) numiso,numisosyn
         do  j=1,numiso
         read (nparam,*) isotope(j),(isoabund(j,k),k=1,numisosyn)
1012     format(f10.4,8f8.0)
         end do


c  keyword 'synlimits ' gives the wavelength parameters for syntheses
c                        start and stop are beginning and ending
c                        wavelengths, step is the step size in the
c                        syntheses, and delta is the wavelength range
c                        to either side of a synthesis point to consider
c                        for line opacity calculations
      elseif (keyword .eq. 'synlimits') then
         read (nparam,*) start, stop, step, delta

c  keyword 'blenlimits' gives the parameters for blended line abundance
c                        matches.  delwave is the wavelength offset 
c                        to the blue of first and to the red of the 
c                        last line in the blend to extend the syntheses; 
c                        step is the wavelength step size in the 
c                        computations; cogatom is the name of the
c                        element whose abundance should be varied
c                        to achieve an EW match with observations.
      elseif (keyword .eq. 'blenlimits') then
         read (nparam,*) delwave, step, cogatom

c  keyword 'coglimits ' gives the log(W/lambda) limits for curves-of-growth
c                       rwlow and rwhigh are the beginning
c                       and ending points of the log(red.width) values,
c                       rwstep is the step in log(red.width),
c                       cogatom is the declaration of which element
c                       will have its abundance varied (necessary only
c                       for spectrum synthesis curves-of-growth,
c                       and wavestep is a forced (if desired) step size
c                       in wavelength along the line (this applies to
c                       single line computations only
      elseif (keyword .eq. 'coglimits') then
         read (nparam,*) rwlow, rwhigh, rwstep, wavestep, cogatom

c  keyword 'limits    ' old limits format...tell the user to change the
c                       keyword and quit.

      elseif (keyword .eq. 'limits') then
         write(*,*) 'Warning: keyword changed to synlimits or coglimits'
         write(*,*) 'for Syntesis and COG calculations.'
         write(*,*) 
         write(*,*) 'Formats:'
         write(*,*) 'synlimits <start> <stop> <step> <delta>'
         write(*,*) 'coglimits <rwlow> <rwhigh> <rwstep> <cogatom> ',
     .     '<wavestep>'
         stop


c   keyword of strong for lines which are to be considered for all of the 
c   synthesis

      elseif (keyword .eq. 'strong') then
         read (array,*) nstrong
     

c  keyword word of opacit which takes the continuus opacity and scales it
c  with the form of kaplam(i)= kaplam(i)*((factor*10000)/t(i))
c  in Opacit.f after it calulates the normal kaplam
c  if value is <= 0 then it does not do it

      elseif (keyword .eq. 'opacit') then
         read (array,*) fudge
     
      

c  any other keyword causes great grudge
      else
         write (*,1006) keyword
1006     format ('LOOK OUT!  This option is unknown to MOOG: ',
     .          a10)

      endif

c  loop back to get another parameter
      go to 5

c  if no terminal type is given, ask for it

100   if (smterm .eq. ' ') then
         array = 'GIVE THE SUPERMONGO TERMINAL TYPE NAME: '
         nchar = 40
         call getasci (nchar,12)
         smterm = chinfo(1:nchar)
         ivstat = ivcleof(12,1)
      endif

c  at the end of the parameter file, return after converting all working
c  wavlength units to Angstroms
      oldstart = start
      oldstop = stop
      oldstep = step
      olddelta = delta
      if (iunits .eq. 2) then
         stop = 1.d8/oldstart
         start = 1.d8/oldstop
      elseif (iunits .eq. 1) then
         stop = 1.d4*oldstop
         start = 1.d4*oldstart
         step = 1.d4*oldstep
         delta = 1.d4*olddelta
      endif
      return

      end







      real*8 function partfn (atom,jmark)                                  
c******************************************************************************
c     This routine computes arrays or single partition functions         
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      real*8 thpart(3,3), ndpart(3,6), uupart(3,6)
      data (ndpart(1,i),i=1,6)/ -3.69340716d+3,  2.07672551d+3,
     .                          -4.61061880d+2,  5.04289636d+1,
     .                          -2.70949776d+0,  5.70499143d-2/
      data (ndpart(2,i),i=1,6)/ -6.14001006d+3,  3.43797948d+3,
     .                          -7.68130434d+2,  8.55970362d+1,
     .                          -4.75533573d+0,  1.05363768d-1/
      data (ndpart(3,i),i=1,6)/ -8.98340934d+2,  4.95993575d+2,
     .                          -1.09861091d+2,  1.21995868d+1,
     .                          -6.77229656d-1,  1.50250139d-2/
      data (uupart(1,i),i=1,6)/ -7.80733849d+2,  4.15269002d+2,
     .                          -8.50971724d+1,  8.30809555d+0,
     .                          -3.77141610d-1,  6.08341139d-3/
      data (uupart(2,i),i=1,6)/  1.20793703d+2, -1.30861494d+2,
     .                           4.48063653d+1, -6.84490372d+0,
     .                           4.88529516d-1, -1.32730303d-2/
      data (uupart(3,i),i=1,6)/  5.18480529d+3, -3.02564444d+3,
     .                           7.03396006d+2, -8.14028851d+1,
     .                           4.68959696d+0, -1.07563314d-1/
      data (thpart(1,i),i=1,3)/ 14.66, 35.40, 77.35/
      data (thpart(2,i),i=1,3)/ 19.57, 45.90, 87.64/
      data (thpart(3,i),i=1,3)/ 35.22, 56.02, 77.97/

      if (int(atom).eq.60 .or. int(atom).eq.92) go to 10
      if (int(atom) .eq. 90) go to 20

c*****do a single partition function just for the molecular equilibrium
      if (jmark .gt. 500) then
         partfn = ucalc(atom,jmark)                                         
         return                                                             

c*****do partition functions for 4 ionization states of an element
      else
         iat = 10*idint(atom) - 1
         at = dfloat(iat)/10.
         do k=1,4
            iat = iat + 1
            at = dfloat(iat)/10.
            do i=1,ntau   
               u(jmark,k,i) = ucalc(at,i)   
            enddo
         enddo
      endif
      return                                                             

c*****for Neodynium and Uranium, override the partition functions of ATLAS.
c     this is a special code for these partition functions;
c     it is taken from Irwin, 1981, ApJS, 45, 621
10    do k=1,3
         do i=1,ntau
            ulog = 0.
            tlog = dlog(t(i))
            do j=1,6
               if (int(atom) .eq. 60) then
                  ulog = ulog + ndpart(k,j)*tlog**(j-1)
               else
                  ulog = ulog + uupart(k,j)*tlog**(j-1)
               endif
            enddo
            u(jmark,k,i) = exp(ulog)
         enddo
      enddo
      do i=1,ntau
         u(jmark,4,i) = 1.0
      enddo
      if (ipr(3) .ge. 4) write (nwrite,1004)
1004  format (/'THERE ARE SPECIAL PARTITION FUNCTIONS ',
     .         'FOR NEODYNIUM OR URANIUM')                   
      return


c*****for Thorium, override the partition functions of ATLAS.
c     this is a special code for the Thorium partition functions;
c     it is taken from Morell et al. 1992, A&A 259, 543
20    do k=1,3
         do i=1,ntau
            if (t(k) .le. 3600.) then
               u(jmark,k,i) = thpart(k,1)
            elseif (t(k) .le. 5700.) then
               frac = (t(i)-3600.)/2100.
               u(jmark,k,i) = thpart(k,1) + 
     .                        frac*(thpart(k,2)-thpart(k,1))
            elseif (t(k) .le. 8000.) then
               frac = (t(i)-5700.)/2300.
               u(jmark,k,i) = thpart(k,2) + 
     .                        frac*(thpart(k,3)-thpart(k,2))
            else
               frac = 1.0 + (t(i)-8000.)/8000.
               u(jmark,k,i) = frac*thpart(k,3)
            endif
         enddo
      enddo
      do i=1,ntau
         u(jmark,4,i) = 1.0
      enddo
      if (ipr(3) .ge. 4) write (nwrite,1001)
1001  format (/'THERE ARE SPECIAL PARTITION FUNCTIONS ',
     .         'FOR THORIUM')                   
      return


      end                                                                





      subroutine plotit                   
c******************************************************************************
c     This routine plots a spectrum that already has been synthesized
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params


c*****set up the output files
      ndump = 21               
      lscreen = 4
      array = 'Give the filename for raw syntheses output: '
      nchars = 44
      call infile ('input  ',ndump,'formatted  ',0,nchars,lscreen)
      n2dump = 22               
      lscreen = lscreen + 2
      array = 'Give the filename for smoothed syntheses: '
      nchars = 42
      call infile ('overout',n2dump,'formatted  ',0,nchars,lscreen)
      if (iraf .ne. 0) then
         n2write = 23
         lscreen = lscreen + 2
         array = 'Give the filename for IRAF ("rtext") output: '
         nchars = 45
         call infile ('output ',n2write,'formatted  ',0,nchars,lscreen)
      endif


c*****now plot the spectrum
      if (ipr(7) .eq. 2) then
         fileobs = 23               
         lscreen = lscreen + 2
         array = 'Give the filename of the observed spectrum: '
         nchars = 44
         if (ipr(9) .eq. 1) then
         call infile ('input  ',fileobs,'unformatted',2880,nchars,
     .                lscreen) 
         else
         call infile ('input  ',fileobs,'formatted  ',0,nchars,
     .                lscreen) 
         endif
      endif
      if (ipr(7) .ne. 0) then
         line = 10
         call pltspec (line)
      endif


c*****finish
      call finish
      end                                                                




      subroutine pltspec (line)
c******************************************************************************
c     This subroutine controls the plotting of the synthesized and 
c     observed data
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*8 xnum
      integer sm_device
      character*1 choice, deviations
c     real*4 xpos,ypos,yyadd,xxadd,vvmult,yymult  AMcW 1/2000
      real*8 xpos,ypos,yyadd,xxadd,vvmult,yymult


c  initialize some variables
      if(iscale .eq. 0) then
         ymult = 1.
         ylo = 0.
         yhi = 1.1
         xlo = 0.
         xhi = 0.
         choice = 's'
         deviations = 'n'
      else
         choice = '1'
         deviations = 'n'
      endif

c  begin by reading in an observed spectrum
      if (ipr(9) .ge. 1 .and. ipr(7) .ge. 2) then
         call readobs (line)
         if (lount .eq. -1) then
            array = 'OBSERVED SPECTRUM FILE PROBLEM!  I QUIT.'
            istat = ivwrite (13,3,array,40)
            return
         endif
      endif
      
      istat = ivcleof(4,1)

c  go through the option list:  the routine may be exited
1     if (choice .eq. 'q') then
         return

      elseif (choice .eq. '1' .or. choice .eq. '2') then
         call smooth (-1)
         wmiddle = (start + stop)/2.
         do i=1,lount
            yobs(i) = ymult*yobs(i)
            yobs(i) = yadd+yobs(i)
            xobs(i) = xadd+xobs(i)
            xobs(i) = vmult*wmiddle/2.99795e+5 + xobs(i)
         enddo
         if (ymult .eq. 0.0) ymult = 1.0
         if (xlo .eq. xhi) then
            xlo = start
            xhi = stop
         endif
         if (ylo .eq. yhi) then
            ylo = 0.
            yhi = 1.1
            
         endif
         
c  or the synthetic spectra may be resmoothed
      elseif (choice .eq. 's') then
2        write (array,1007)
1007     format ('SMOOTHING: n=NONE, g=GAUSS, l=LORENZ, ',
     .           'v=ROTATION, m=MACROTURBULENCE')
         istat = ivwrite (line+4,3,array,67)
         write (array,1008)
1008     format ('           c=v+g, d=m+g, r=m+v+g, p=VARIABLE GAUSS')
         istat = ivwrite (line+5,3,array,50)
         array = 'What is your choice? '
         nchars = 21
         call getasci (nchars,line+6)
         smtype = chinfo(1:1)
            call smooth (line+7)
         if (smtype.eq.'n' .or. smtype.eq.'g' .or.
     .       smtype.eq.'l' .or. smtype.eq.'v' .or.
     .       smtype.eq.'m' .or. smtype.eq.'c' .or.
     .       smtype.eq.'d' .or. smtype.eq.'r') then
         elseif (smtype .eq. 'p') then
            call vargauss (line+7)
         else
            go to 2
         endif
         if (smtype .eq. 'e') then
            array = 'REDO THE SMOOTHING (y/n)? '
            nchars = 26
            call getasci (nchars,line+9)
            smtype = chinfo(1:1)
            if (smtype .eq. 'n') then
               go to 100
            else
               istat = ivcleof (10,1)
               go to 2
            endif
         endif
         if (xlo .eq. 0.0 .and. xhi .eq. 0.0) then
            xlo = start
            xhi = stop
         endif

c  or the observations may be rescaled
      elseif (choice .eq. 'r') then
         array = 'MULTIPLY THE OBSERVED POINTS BY WHAT FACTOR? '
         nchars = 45
         call getasci (nchars,13)
         call number (nchars,10,xnum)
         yymult = sngl(xnum)
         ymult = ymult + yymult
         do i=1,lount
            yobs(i) = yymult*yobs(i)
         enddo

c  or the observations may be shifted by an additive constant
      elseif (choice .eq. 'a') then
         array = 'ADD WHAT NUMBER TO THE OBSERVED POINTS? '
         nchars = 40
         call getasci (nchars,13)
         call number (nchars,13,xnum)
         yyadd = sngl(xnum)
         yadd = yadd + yyadd
         do i=1,lount
            yobs(i) = yyadd + yobs(i)
         enddo

c  or the observations may be shifted by a constant wavelength
      elseif (choice .eq. 'w') then
         array = 'SHIFT THE OBSERVED POINTS BY WHAT WAVELENGTH? '
         nchars = 46
         call getasci (nchars,13)
         call number (nchars,13,xnum)
         xxadd = sngl(xnum)
         xadd = xadd + xxadd
         do i=1,lount
            xobs(i) = xxadd + xobs(i)
         enddo

c  or the observations may be shifted by a constant velocity
      elseif (choice .eq. 'v') then
         array = 'SHIFT THE OBSERVED POINTS BY WHAT VELOCITY (KM/S)? '
         nchars = 51
         call getasci (nchars,13)
         call number (nchars,13,xnum)
         vvmult = sngl(xnum)
         vmult = vmult * vvmult
         wmiddle = (start + stop)/2.
         do i=1,lount
            xobs(i) = vvmult*wmiddle/2.99795e+5 + xobs(i)
         enddo

c  or the plot boundaries may be changed
      elseif (choice .eq. 'c') then
         write (array,1001) xlo
1001     format ('LEFT WAVELENGTH (',f9.2,'): ')
         nchars = 29
         call getasci (nchars,15)
         if (nchars .gt. 0) then
            call number (nchars,15,xnum)
            xlo = sngl(xnum)
         endif
         write (array,1002) xhi
1002     format ('RIGHT WAVELENGTH (',f9.2,'): ')
         nchars = 30
         call getasci (nchars,16)
         if (nchars .gt. 0) then
            call number (nchars,16,xnum)
            xhi = sngl(xnum)
         endif
         write (array,1003) ylo
1003     format ('BOTTOM RELATIVE FLUX (',f9.2,'): ')
         nchars = 34
         call getasci (nchars,17)
         if (nchars .gt. 0) then
            call number (nchars,17,xnum)
            ylo = sngl(xnum)
         endif
         write (array,1004) yhi
1004     format ('TOP RELATIVE FLUX (',f9.2,'): ')
         nchars = 31
         call getasci (nchars,18)
         if (nchars .gt. 0) then
            call number (nchars,18,xnum)
            yhi = sngl(xnum)
         endif
         go to 121

c    use the cross hairs to zoom in on a particular feature
      elseif (choice .eq. 'z') then
         call sm_graphics
         if (deviations .eq. 'y') then
            call sm_window (1,2,1,1,1,1)
         endif
         array = 'MARK THE LOWER LEFT HAND CORNER WITH THE CURSOR'
 220     istat = ivcleof(13,1)
         istat = ivwrite(13,3,array,47)
         call sm_curs (xlo,ylo,ichr)
         array = 'MARK THE UPPER RIGHT HAND CORNER WITH THE CURSOR'
 212     istat = ivcleof(14,1)
         istat = ivwrite (14,1,array,48)
         call sm_curs (xhi,yhi,ichr)
         call sm_gflush
         call sm_alpha

 121     do 16 i=1,lount
            if (xlo .le. xobs(i)) go to 17
16          continue
         lim1obs = 1
         go to 19
17       lim1obs = i
19       do 18 i=lim1obs,lount
            if (xhi .le. xobs(i)) go to 14
18          continue
c        go to 13   AMcW 1/2000
         lim1obs = 1
         lim2obs = lount
         deviations = 'n'

14       lim2obs = i

c    return cursor position
      elseif (choice .eq. 'p') then
         call sm_graphics
         if (deviations .eq. 'y') then
            call sm_window (1,2,1,1,1,1)
         endif
         array = 'MARK THE POSITION WITH THE CURSOR'
 213     istat=ivcleof(21,1)
         istat=ivwrite(13,3,array,34)
         call sm_curs (xpos,ypos,ichr)
         call sm_relocate (xpos,ypos-0.05d0*(yhi-ylo))
         call sm_draw (xpos,ypos+0.05d0*(yhi-ylo))
         call sm_draw (xpos-0.01d0*(xhi-xlo),ypos+0.04d0*(yhi-ylo))
         call sm_relocate (xpos,ypos+0.05d0*(yhi-ylo))
         call sm_draw (xpos+0.01d0*(xhi-xlo),ypos+0.04d0*(yhi-ylo))
         write (array,1041) xpos
1041     format (f8.2)
         call sm_relocate (xpos,ypos-0.07d0*(yhi-ylo))
         call sm_putlabel (5,array)
         call sm_gflush
         call sm_alpha
         go to 100

c    change the title of the model....
      elseif (choice .eq. 't') then
         array = 'ENTER THE NEW TITLE'
         istat = ivcleof(21,1)
         istat = ivwrite (13,3,array,19)
         read (*,33) moditle
 33      format(a80)
   
c    replot the spectra with a separate plot for observed/synthtic deviations
      elseif (choice .eq. 'd') then
         deviations = 'y'

c    the plot boundaries may be reset to the original values;
c    this is a basic starting over plot
c 13  elseif (choice .eq. 'o') then  removed AMcW 1/2000
13    elseif (choice .eq. 'o') then
         xlo = start
         xhi = stop
         ylo = 0.
         yhi = 1.1
         lim1obs = 1
         lim2obs = lount
         deviations = 'n'

c    the plot boundaries may be reset to the original values
      elseif (choice .eq. 'm') then
         go to 90

c    now either here make a hardcopy plot
      elseif (choice .eq. 'h') then
         if (sm_device('postland') .lt. 0) then
            write (nwrite,1009)
1009        format ('DEVICE OPENING ERROR FOR: postland')
            stop
         endif
         call sm_graphics
         call sm_erase
         call synplot (choice,deviations)
         call sm_gflush
         call sm_alpha
         call sm_hardcopy
         go to 100

c    or write the plot to a postscript file
      elseif (choice .eq. 'f') then
         array = 'Give the file name for the POSTSRIPT plot image: '
         nchars = 49
         call getasci (nchars,13)
         write (array,1005) chinfo(1:nchars)
1005     format ('postlandfile ',a67)
         if (sm_device(array(1:nchars+9)) .lt. 0) then
            write (nwrite,1006) array(1:nchars+9)
1006        format ('FILE OPENING ERROR FOR:',a56)
            stop
         endif
         call sm_graphics
         call sm_erase
         call synplot (choice,deviations)
         call sm_gflush
         call sm_alpha
         call sm_hardcopy
         go to 100
      
c   or rerun the model with new abundances
      elseif (choice .eq. 'n') then
         call chabund
         call smooth (-1)
         choice = 'm'
         go to 1

c   or reprint the option table if the choice is not understood
      else 
         go to 100
      endif
      
c    or plot on the terminal
90    if (sm_device(smterm) .lt. 0) then
         write (nwrite,1010) smterm
1010     format ('DEVICE OPENING ERROR FOR:',a54)
         stop
      endif
      call sm_graphics
      call sm_erase
      call synplot (choice,deviations)
      call sm_gflush
      call sm_alpha
      
c     finally, print the option table and loop back  
100   istat = ivcleof (5,1)
      array = 'OPTIONS?    s=new smoothing     r=rescale obs.     '
      istat = ivwrite (5,3,array,48)
      array = '            a=add # to obs.     h=hardcopy         '
      istat = ivwrite (6,3,array,48)
      array = '            c=change bounds     q=quit             '
      istat = ivwrite (7,3,array,48)
      array = '            m=redo same plot    o=orig. plot bounds'
      istat = ivwrite (8,3,array,51)
      array = '            v=velocity shift    w=wavelength shift '
      istat = ivwrite (9,3,array,51)
      array = '            z=zoom in on plot   p=cursor position  '
      istat = ivwrite (10,3,array,51)
      array = '            t=change title      f=postscript file  '
      istat = ivwrite (11,3,array,51)
      array = '            n=new abundances    d=obs/syn deviation'
      istat = ivwrite (12,3,array,51)
      array = 'What is your choice? '
      nchars = 21
      call getasci (nchars,14)
      choice = chinfo(1:1)
      go to 1

      end
      





      subroutine prinfo (line)
c*****this routine prints out information on the information screen
 
      include 'Chars.com'
      include 'Pstuff.com'
      character errm1*80,array1*80
       
      if (line .eq. 1) then
         istat = ivcleof(4,1)
      endif

      if (line .eq. maxline-5) then
         errm1 = errmess
         array1 = array
10       array = 'WANT TO SEE MORE ([y]/n)? '
         nchars = 26
         call getasci (nchars,4+line)
         if (chinfo(1:1).eq.'y' .or. nchars.le.0) then
            istat = ivcleof(4,1)
            line = 1
            array = array1
            errmess = errm1
         elseif (chinfo(1:1) .eq. 'n') then
            errmess = 'stopinfo!'
            return
         else
            go to 10
         endif
      endif

      istat = ivwrite(4+line,1,array,79)
      errmess = 'everything OK'
      return
      
      end













      subroutine readobs (line)
c*****this routine reads in observed spectra.  the format is indicated by
c     the value of ipr(9)

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Chars.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*8 disp(9)
      integer*2 int2(1440)
      integer*4 int4(720)
      real*4 real4(720)
      equivalence (int2,int4)
      equivalence (int2,real4)
      character head*2880

c*****branch to the appropriate data file type
      rewind fileobs
      go to (100,200,300,400,500),ipr(9)

c*****here is a pure FITS file type. First set some default parameters
100   write (obsitle,1021)
1021  format (80(' '))
      naxis = 1
      naxis1 = 0
      bscale = 0.
      bzero = 0.
      do j=1,9
         disp(j) = 0.
      enddo

c     get the header information
      irec = 1
101   read (unit=fileobs,rec=irec,err=1002,iostat=ierr) head
      do 150 j=1,36
         k = 80*(j-1)
         if     (head(k+1:k+8) .eq. 'SIMPLE  ') then
            if (head(k+30:k+30) .ne. 'T') then
               write(array,1029) head(k+1:k+58)
1029           format('ILLEGAL FILE FORMAT: ',a58)
               istat = ivwrite (line+2,3,array,79)
               go to 1007
            endif
         elseif (head(k+1:k+8) .eq. 'BITPIX  ') then
               read (head(k+1:k+80),1025) ibits
1025           format (10x,i20)
               if (ibits .eq. 16) then
                  nblock = 1440
               elseif (ibits .eq. 32) then
                  nblock = 720
               elseif (ibits .eq. -32) then
                  nblock = 720
               else
                  write(array,1026) ibits
1026              format('SORRY: I CANT HANDLE BITPIX=',i4)
                  istat = ivwrite (line+2,3,array,32)
                  go to 1007
               endif
         elseif (head(k+1:k+8) .eq. 'NAXIS   ') then
               read (head(k+1:k+80),1025) naxis
               if (naxis .ne. 1) then
                  write(array,1028) head(k+1:k+58) 
1028              format('ILLEGAL NAXIS ENTRY: ',a58)
                  go to 1007
               endif
         elseif (head(k+1:k+8) .eq. 'NAXIS1  ') then
               read (head(k+1:k+80),1025) lount
         elseif (head(k+1:k+8) .eq. 'OBJECT  ') then
               write (obsitle,1027) head(k+12:k+80)
1027           format (a68)
         elseif (head(k+1:k+8) .eq. 'BZERO   ') then
               read (head(k+1:k+80),1024) bzero
1024           format (10x,d20.10)
         elseif (head(k+1:k+8) .eq. 'BSCALE  ') then
               read (head(k+1:k+80),1024) bscale
         elseif ((head(k+1:k+8) .eq. 'W0      ') .or. 
     .      (head(k+1:k+8) .eq. 'CRVAL1  ')) then
               read (head(k+1:k+80),1024) disp(1)
         elseif ((head(k+1:k+8) .eq. 'WPC     ') .or. 
     .      (head(k+1:k+8) .eq. 'CDELT1  ')) then
               read (head(k+1:k+80),1024) dval
               if (dval .ne. 1.) disp(2) = dval
         elseif (head(k+1:k+8) .eq. 'CD1_1    ') then
               read (head(k+1:k+80),1024) disp(2)
         elseif (head(k+1:k+8) .eq. 'FILENAME') then
               write (obsitle(39:80),1023) head(k+12:k+53)
1023           format (a41)
         elseif (head(k+1:k+8) .eq. 'HISTORY ') then
               if (head(k+24:k+28) .eq. 'DISP=') then
                  read (head(k+1:k+80),1022) (disp(i),i=1,4)
 1022                        format(28x,1p4d13.5)
               elseif (head(k+20:k+26) .eq. 'D1,2,3:') then
                  read (head(k+1:k+80),1042) (disp(i),i=1,3)
               elseif (head(k+20:k+26) .eq. 'D4,5,6:') then
                  read (head(k+1:k+80),1042) (disp(i),i=4,6)
               elseif (head(k+20:k+26) .eq. 'D7,8,9:') then
                  read (head(k+1:k+80),1042) (disp(i),i=7,9)
 1042                        format(26x,1p3d18.11)
                  if (disp(7).ne.0.0 .and. disp(8).eq.0.0 .and.
     .                disp(9).eq.0.0) then
                     disp(8) = 1.0
                     disp(9) = lount
                  endif
               endif
            elseif (head(k+1:k+8) .eq. 'END     ') then
               go to 110
         endif
150   continue
      irec = irec + 1
      go to 101

c     now read the data 
110   nrec = lount/nblock
      ipt = 0
      if (mod(lount,nblock) .ne. 0) nrec = nrec + 1
      do 130 j=1,nrec
         irec = irec + 1
         jpt = min0(nblock,lount-ipt)
         if (ibits .eq. 16) then
            read (unit=fileobs,rec=irec,err=1006,iostat=ierr) int2
            do k=1,jpt
               yobs(ipt+k) = bzero + bscale*real(int2(k))
            enddo
         elseif (ibits .eq. 32) then
            read (unit=fileobs,rec=irec,err=1006,iostat=ierr) int4
            do k=1,jpt
               yobs(ipt+k) = bzero + bscale*real(int4(k))
            enddo
         elseif(ibits .eq. -32) then
            read (unit=fileobs,rec=irec,err=1006,iostat=ierr) real4
            do k=1,jpt
               yobs(ipt+k) = real4(k)
            enddo
         endif
         ipt = ipt + jpt
130   continue

c     now fill in the wavelength array
      do j=1,lount
         xobs(j) = sngl(wavecalc(real(j),lount,disp))
            write (55,*) j, xobs(j)
      enddo
      lim1obs = 1
      lim2obs = lount
      if(xobs(2) .lt. xobs(1)) then
         do j=1,lount/2
            xtemp = xobs(j)
            ytemp = yobs(j)
            xobs(j) = xobs(lount+1-j)
            yobs(j) = yobs(lount+1-j)
            xobs(lount+1-j) = xtemp
            yobs(lount+1-j) = ytemp
         enddo
      endif
      return
         
c     give error messages, and abort
1002  write(array,1003) ierr
1003  format('ERROR IN FITS HEADER READ:   ERROR=',i4)
      istat = ivwrite(line+2,3,array,39)
      go to 1007
1006  write(array,1004) ierr
1004  format('ERROR IN DATA READ:  ERROR=',i4,'/')
      istat = ivwrite(line+2,3,array,39)
1007  lount = -1
      return

200   return

300   return

400   return

c*****here is a MONGO-style input array
500   read (fileobs,5001) obsitle
5001  format (a80)
      i = 1
501   read (fileobs,*,end=525) xobs(i),yobs(i)
      i = i + 1
      go to 501
525   lount = i - 1
      lim1obs = 1
      lim2obs = lount
      if(xobs(2) .lt. xobs(1)) then
         do j=1,lount/2
            xtemp = xobs(j)
            ytemp = yobs(j)
            xobs(j) = xobs(lount+1-j)
            yobs(j) = yobs(lount+1-j)
            xobs(lount+1-j) = xtemp
            yobs(lount+1-j) = ytemp
         enddo
      endif
      return

      end













      subroutine resynth                   
c******************************************************************************
c     This program synthesizes a section of spectrum and compares it
c     to an observation file.  This version reruns the sythesis without
c     asking for new input or output files and overwrites the original files
c     with the new models.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Strong.com'


c*****rewind the output files
      rewind nwrite 
      rewind ndump 
      if (ipr(7) .ne. 0) then
         rewind n2dump 
      endif
      

c*****rewrite the model output
      call out (21)
      if (ipr(1) .ge. 1) call out (1)
      call out (8)
      ipr(3) = iopr(3)
      

c*****redo the syntheses
      if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
         isorun = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly
         call synspec
      else
         do n=1,numatomsyn
            isynth = n
            isorun = 1
            mode = 3
	    if (numiso .ne. 0) call out(26)
            call inlines (1)
            call eqlib
            call nearly
            call synspec
            ipr(3) = 0
         enddo
      endif
         

c*****return back to the chabund routine
      return
      end                                                                






      real*8 function rinteg(x,f,fint,n,start)
c******************************************************************************
c     This routine is from ATLAS6
c******************************************************************************

      implicit real*8 (a-h,o-z)
      dimension x(n),f(n),fint(n)
c     dimension a(1000),b(1000),c(1000)  AMcW 1/2000
      dimension a(n),b(n),c(n)

      call parcoe (f,x,a,b,c,n)
      fint(1) = start 
      rinteg = start
      n1 = n - 1
c
c code to avoid negative taunu - a simple trapesium integration
c AMcW 10/2000
c
      do i = 1,n-1
         fint(i+1) = 0.5*(f(i)+f(i+1))*(x(i+1)-x(i))
         rinteg = rinteg + fint(i+1)
      enddo
      return

c below is the original code (for normal use delete the above)

      do 10 i=1,n1
         fint(i+1)= (a(i)+b(i)/2.*(x(i+1)+x(i))+ 
     .     c(i)/3.*((x(i+1)+x(i))*x(i+1)+x(i)*x(i)))*(x(i+1)-x(i))
10    rinteg = rinteg + fint(i+1)

      return
      end 




      subroutine parcoe(f,x,a,b,c,n)

      implicit real*8 (a-h,o-z)
      dimension f(n),x(n),a(n),b(n),c(n) 

      c(1)=0.
      b(1)=(f(2)-f(1))/(x(2)-x(1))
      a(1)=f(1)-x(1)*b(1)
      n1=n-1
      c(n)=0.
      b(n)=(f(n)-f(n1))/(x(n)-x(n1))
      a(n)=f(n)-x(n)*b(n) 
      if(n.eq.2)return
      do 1 j=2,n1
      j1=j-1
      d=(f(j)-f(j1))/(x(j)-x(j1)) 
      c(j)=f(j+1)/((x(j+1)-x(j))*(x(j+1)-x(j1)))-f(j)/((x(j)-x(j1))*
     1(x(j+1)-x(j)))+f(j1)/((x(j)-x(j1))*(x(j+1)-x(j1)))
      b(j)=d-(x(j)+x(j1))*c(j)
    1 a(j)=f(j1)-x(j1)*d+x(j)*x(j1)*c(j)
      c(2)=0.
      b(2)=(f(3)-f(2))/(x(3)-x(2))
      a(2)=f(2)-x(2)*b(2)
      c(3)=0.
      b(3)=(f(4)-f(3))/(x(4)-x(3))
      a(3)=f(3)-x(3)*b(3)
      if(c(j).eq.0.)go to 2
      j1=j+1
      wt=abs(c(j1))/(abs(c(j1))+abs(c(j)))
      a(j)=a(j1)+wt*(a(j)-a(j1))
      b(j)=b(j1)+wt*(b(j)-b(j1))
      c(j)=c(j1)+wt*(c(j)-c(j1))
    2 continue
      a(n1)=a(n)
      b(n1)=b(n)
      c(n1)=c(n)
      return
      end 



	program rot
	call moog()
	call system('mv OUTPUT OUTPUT1')
	call system('mv logfile logfile1')
	call moog()
	call system('mv OUTPUT OUTPUT2')
	call system('mv logfile logfile2')
	call moog()
	call system('mv OUTPUT OUTPUT3')
	call system('mv logfile logfile3')
	call moog()
	call system('mv OUTPUT OUTPUT4')
	call system('mv logfile logfile4')
	stop
	end
      subroutine slines
c******************************************************************************
c     This takes the big lines and makes all the calculations made in
c     inlines so they can be used in taukap 
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Dummy.com'
      include 'Quants.com'
      include 'Strong.com'
      include 'Factor.com'


      if (nstrong .le. 0 ) return

c*****read in up to 20 "strong" lines whose opacities will be considered
c     at all wavelengths of a synthesis
      nstrong = 0
      rewind fileslines
      do j=1,20
c
c changed read to take line id, and changed format to take old moog lists
c AMcW 1/2000
c
         read (fileslines,271,end=377) slineid(j),swave1(j),satom1(j),
     .                          se(j,1),sc6(j),sgf(j),sd0(j),swidth(j)
         nstrong = nstrong + 1
271      format(a5,6e10.3,5x,f10.3)
c
      enddo
      write(*,*) 'Can only use the first 20 strong lines'

c*****here log(gf) values are turned into gf values, if needed
377   do i=1,nstrong
         if (sgf(i) .lt. 0) then
            do j=1,nstrong
               sgf(j) = 10.**sgf(j)
            enddo
            go to 379
         endif
      enddo

c*****turn log(RW) values and EW values in mA into EW values in A.  Stuff
c     duplicate EW values of the first line of a blend into all blend members.
379   do i=1,nstrong
         if (swidth(i) .lt. 0.) then
            swidth(i) = 10.**swidth(i)*swave1(i)
         else
            swidth(i) = swidth(i)/1000.
         endif
      enddo

c*****calculate some parameters of the lines; for atomic lines the
c     van der Waals damping has different options
      do i=1,nstrong
         iatom = satom1(i)                                                   
         scharge(i) = 1.0 + 10.0*(satom1(i) - iatom)                          
         se(i,2) =  se(i,1) + 1.239d+4/swave1(i)                               
         if(iatom .ge. 100) then
            call sunder(satom1(i),ia,ib)                                        
            if ( satom1(i)-int(satom1(i)) .le. 0.0 ) then
               samass(i) = xam(ia) + xam(ib)                                   
               mas1=xam(ia)
               mas2=xam(ib)
            else 
               mas1 = int(100*(satom1(i)-int(satom1(i))))
               mas2 = int(10000*(satom1(i)-int(satom1(i)))) - mas1 * 100
               samass(i) = mas1 + mas2
            endif
            schi(i,1) = sd0(i)                                                  
            schi(i,2) = mas1*mas2/samass(i)                                
            schi(i,3) = 0.
            sc6(i) = 1.0d-31                                                    
         else
            samass(i) = xam(iatom)                       
            schi(i,1) = xchi1(iatom)                                            
            schi(i,2) = xchi2(iatom)                                            
            schi(i,3) = xchi3(iatom)

c*****do the damping, beginning with the Unsold approximation
            ich = idint(scharge(i) + 0.1)      
            unsold = dabs(1.61d-33*(13.5*scharge(i)/(schi(i,ich) -
     .               se(i,1)))**2 - 1.61d-33*(13.5*scharge(i)/
     .               (schi(i,ich)-se(i,2)))**2)               
            if (ipr(8) .eq. 0) then
               if (sc6(i) .eq. 0.0) then
                  sc6(i) = unsold
               elseif (sc6(i) .gt. 1.0d-10) then
                  sc6(i) = unsold*sc6(i)
               endif
            elseif (ipr(8) .eq. 1) then
               sc6(i) = 6.3*unsold
            elseif (ipr(8) .eq. 2) then
               sc6(i) = (1.0 + 0.67*se(i,1))*unsold
            endif
         endif
      enddo

c*****exit the routine normally
330   call snearly
      call out (27)
      return  

      end


      subroutine smooth (line)
c******************************************************************************
c     This subroutine prepares synthesis data for plotting by smoothing
c     the data in various ways.
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      logical gaussflag, rotateflag, lorenflag, macroflag


c*****initialize parameters
      nsyn = 1
      p0 = 1.
      gaussflag = .false.
      rotateflag = .false.
      lorenflag = .false.
      macroflag = .false.


c*****on entering, rewind the unsmoothed and smoothed spectrum output 
c     files, and get the synthesis range parameters from the 'dump' file
      rewind ndump
      rewind n2dump
55    read (ndump,1002) moditle
      if (moditle(1:15).eq.'        element' .or.  
     .    moditle(1:15).eq.' ALL abundances' .or.
     .    moditle(1:15).eq.'Isotope Ratio: ') go to 55
1002  format (a80)
      read (ndump,*) start, stop, step
      kount = int((stop - start + (step/4.0) )/step) + 1
      rewind ndump


c*****branch to the desired smoothing function
      if     (smtype .eq. 'n') then
         go to 40 
      elseif (smtype .eq. 'l') then
         lorenflag = .true.
      elseif (smtype .eq. 'g') then
         gaussflag = .true.
      elseif (smtype .eq. 'v') then
         rotateflag = .true.
      elseif (smtype .eq. 'c') then
         rotateflag = .true.
         gaussflag = .true.
      elseif (smtype .eq. 'm') then
         macroflag = .true.
      elseif (smtype .eq. 'd') then
         macroflag = .true.
         gaussflag = .true.
      elseif (smtype .eq. 'r') then
         macroflag = .true.
         rotateflag = .true.
         gaussflag = .true.
      endif


c*****compute a stellar rotational broadening function
c     this follows D. F. Gray, 1976, "The Obs. & Anal. of Stell. Phot", p394-9
30    if (rotateflag .eqv. .false.) go to 50
32    array = 'GIVE THE STELLAR vsini [0.0]: '
      nchars = 30
      if (line .gt. 0) then
         call getasci (nchars,line)
         call number (nchars,line,vsini)
         if (vsini .eq. -9999.) vsini = 0.
      endif
      if (vsini .lt. 0.0) go to 32
31    array = 'GIVE THE LIMB DARKENING COEFFICIENT [0.0]: '
      nchars = 43
      if (line .gt. 0) then
         call getasci (nchars,line)
         call number (nchars,line,epsilon)
         if (epsilon .eq. -9999.) epsilon = 0.
      endif
      if (epsilon .lt. 0.0) go to 31
      dlamlim = (start+stop)/2.*vsini/3.0e5
      if (step .ge. dlamlim) then
         rotateflag = .false.
         go to 50
      endif
      pi = 3.141527
      bottom = dlamlim*pi*(1.-epsilon/3.)
      c1 = 2.*(1.-epsilon)/bottom
      c2 = 0.5*epsilon*pi/bottom
      prot0 = c1 + c2
      powerrot = prot0
      jdelrot = dint(dlamlim/step)
      if (jdelrot .gt. 1000) then
         write (*,1026) 
1026     format ('ERROR: ROTATIONAL PROFILE TOO BIG!'/  
     .           '       INCREASE SPECTRUM STEP SIZE?')
         smtype = 'e'
         return
      elseif (jdelrot .gt. kount/4) then
         write (*,1028)
1028     format ('ERROR: ROTATIONAL PROFILE COVERS WHOLE ',
     .           'SPECTRUM!'/
     .           '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .           'STEP SIZE?')
         smtype = 'e'
         return
      endif
      do i=1,jdelrot
         dlam = (i-1)*step
         term = 1. - (dlam/dlamlim)**2
         prot(i) = c1*dsqrt(term) + c2*term
         powerrot = powerrot + 2.0*prot(i)
      enddo
         
c*****compute a macroturbulent smoothing function (uses subroutine vmacro)
50    if (macroflag .eqv. .false.) go to 10
51    array = 'GIVE THE MACROTURBULENT VELOCITY [0.0]: '
      nchars = 39
      if (line .gt. 0) then
         call getasci (nchars,line)
         call number (nchars,line,velmac)
         if (velmac .eq. -9999.) velmac = 0.
      endif
      if (velmac .lt. 0.0) go to 51
      if (velmac .eq. 0.) then
         macroflag = .false.
         go to 10
      endif
      wavemac = (start+stop)/2.*velmac/3.0e5
      powermac = 1.0
      do i=1,1000
         wavei = step*i/wavemac
         pmac(i) = vmacro(wavei)
         powermac = powermac + 2.0 *pmac(i)
         if (pmac(i) .lt. 0.002) then
            jdelmac = i
            go to 15
         endif
      enddo
15    if (jdelmac .gt. 1000) then
         write (*,1025) wavemac
1025     format ('ERROR: MACROTURBULENT PROFILE TOO BIG! ',
     .           '(WAVELENGTH WIDTH=',f6.2,')'/
     .           '       INCREASE SPECTRUM STEP SIZE?')
         smtype = 'e'
         return
      elseif (jdelmac .gt. kount/4) then
         write (*,1022)
1022     format ('ERROR: MACROTURBULENT PROFILE COVERS WHOLE ',
     .           'SPECTRUM!'/
     .           '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .           'STEP SIZE?')
         smtype = 'e'
         return
      endif   


c*****compute a Gaussian smoothing function
10    if (gaussflag .eqv. .false.) go to 20
11    array = 'GIVE THE FWHM OF THE GAUSSIAN FUNCTION [0.0]: ' 
      nchars = 46
      if (line .gt. 0) then
         call getasci (nchars,line)
         call number (nchars,line,half)
         if (half .eq. -9999.) half = 0.
      endif
      if (half .lt. 0.0) go to 11
      if (half .eq. 0.) then
         gaussflag = .false.
         go to 20
      endif
      sigma = half/2.
      aa = 0.6932/sigma**2
      power = 1.0
      do i=1,1000
         p(i) = dexp(-aa*(step*i)**2 )
         power = power + 2*p(i)
         if (p(i) .lt. 0.02) then
            jdel = i
            go to 25 
         endif
      enddo
25    if (jdel .gt. 1000) then
         write (*,1029) sigma
1029     format ('ERROR: GAUSSIAN PROFILE TOO BIG! ',
     .           '(HALF WIDTH=',f6.2,')'/
     .           '       INCREASE SPECTRUM STEP SIZE?')
         smtype = 'e'
         return   
      elseif (jdel .gt. kount/4) then
         write (*,1021)
1021     format ('ERROR: GAUSSIAN PROFILE COVERS WHOLE ',
     .           'SPECTRUM!'/
     .           '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .           'STEP SIZE?')
         smtype = 'e'
         return
      endif


c*****compute a Lorenzian smoothing function
20    if (lorenflag .eqv. .false.) go to 40
21    array = 'GIVE THE FWHM OF THE LORENTZIAN FUNCTION [0.0]: '
      nchars = 48
      if (line .gt. 0) then
         call getasci (nchars,line)
         call number (nchars,line,half)
         if (sigma .eq. -9999.) half = 0.
      endif
      if (half .lt. 0.0) go to 21
      if (half .eq. 0.) then
         lorenflag = .false.
         go to 40
      endif
      sigma = half/2.
      power = 1.0
      do i=1,1000
         p(i) = ((sigma**2)/((sigma**2)+((step*i)**2)))
         power = power + 2.0 *p(i)
         if (p(i) .lt. 0.02) then
            jdel = i
            go to 35 
         endif
      enddo    
35    if (jdel .gt. 1000) then
         write (*,1030) sigma
1030     format ('ERROR: LORENZIAN PROFILE TOO BIG! ',
     .           '(HALF WIDTH=',f6.2,')'/
     .           '       INCREASE SPECTRUM STEP SIZE?')
         smtype = 'e'
         return  
      elseif (jdel .gt. kount/4) then
         write (*,1031)
1031     format ('ERROR: LORENZIAN PROFILE COVERS WHOLE ',
     .           'SPECTRUM!'/
     .           '       INCREASE SYNTHESIS LENGTH OR DECREASE ',
     .           'STEP SIZE?')
         smtype = 'e'
         return
      endif

      istat = ivcleof (line,1)
      istat = ivmove (line-1,1)
      write (*,1024) sigma,(p(i),i=1,500)
 1024 format('ERROR: LORENZ PROFILE TOO BIG! (HALF WIDTH=',
     .      f6.2,')        THE PROFILE;'/(15f5.2))
      smtype = 'e'
      return


c*****now read in the raw spectrum and flip to a depth scale
40    noff = 80*(nsyn-1)
      abitle(noff+1:noff+12) = '[M/H] 0.00  '
      nabunds = 0
41    read (ndump,1002,end=2000) array
      if     (array(1:15).eq.' ALL abundances') then
         abitle(noff+6:noff+10) = array(56:60)
         go to 41
      elseif (array(1:15).eq.'        element') then
         nabunds = nabunds + 1
         if (nabunds .le. 7) then
            ioff = noff + 12 + 9*(nabunds-1)
            abitle(ioff+1:ioff+2) = array(17:18)
            abitle(ioff+3:ioff+7) = array(34:38)
            abitle(ioff+8:ioff+9) = '  '
         endif
         go to 41
      elseif (array(1:15).eq.'Isotope Ratio: ') then
         nabunds = nabunds + 1
         if (nabunds .le. 7) then
            ioff = noff + 12 + 9*(nabunds-1)
            abitle(ioff+1:ioff+4) = array(27:30)
            abitle(ioff+5:ioff+5) = ' '
            do k=33,44
               if (array(k:k) .ne. ' ') then
                  abitle(ioff+6:ioff+8) = array(k:k+2)
                  go to 60
               endif
            enddo
60          abitle(ioff+9:ioff+9) = ' '
         endif
         go to 41
      endif
      read (ndump,1002,end=2000)
      read (ndump,1003,end=2000) (y(i),i=1,kount)
1003  format (10f7.4)
      do i=1,kount
         y(i) = 1.0 - y(i)
      enddo
      if (iunits .eq. 2) then
         do i=1,kount/2
            temp = y(i)
            y(i) = y(kount+1-i)
            y(kount+1-i) = temp
         enddo
      endif


c*****apply the rotational broadening if desired
      if (rotateflag .eqv. .true.) then
         min = jdelrot + 1
         max = kount - jdelrot
         do i=1,jdelrot
            z(i) = 1.
            z(kount-i+1) = 1.
         enddo
         do i=min,max
            z(i) = prot0*y(i)
            do j=1,jdelrot
               z(i) = z(i) + prot(j)*(y(i-j) + y(i+j))
            enddo
            z(i) = z(i)/powerrot
         enddo
         do i=1,kount
            y(i) = z(i)
         enddo
      endif


c*****apply the macroturbulent broadening if desired
      if (macroflag .eqv. .true.) then
         min = jdelmac + 1
         max = kount - jdelmac
         do i=1,jdelmac
            z(i) = 1.
            z(kount-i+1) = 1.
         enddo
         do i=min,max
            z(i) = p0*y(i)
            do j=1,jdelmac
               z(i) = z(i) + pmac(j)*(y(i-j) + y(i+j))
            enddo
            z(i) = z(i)/powermac
         enddo
         do i=1,kount
            y(i) = z(i)
         enddo
      endif


c*****apply the Gaussian or Lorenzian smoothing if desired (this
c     is an either/or situation; only one of these can apply.
      if (gaussflag .eqv. .true. .or. lorenflag .eqv. .true.) then
         min = jdel + 1
         max = kount - jdel
         do i=1,jdel
            z(i) = 1.
            z(kount-i+1) = 1.
         enddo
         do i=min,max
            z(i) = p0*y(i)
            do j=1,jdel
               z(i) = z(i) + p(j)*(y(i-j) + y(i+j))
            enddo
            z(i) = z(i)/power
         enddo
         do i=1,kount
            y(i) = z(i)
         enddo
      endif


c*****move the smoothed spectrum (or unsmoothed, if nothing has
c     been done to the y-array) into the appropriate array
      do i = 1,kount
         chunk(i,nsyn) = y(i)
      enddo


c*****compute the wavelength array; must be done for each synthetic
c     spectrum because of the way the equivalences were set up
      do i=1,kount
         xsyn(i) = start + (i-1)*step
      end do
 

c*****dump the smoothed spectrum in a MONGO-style set of 
c     (wavelength,flux) point pairs
      write (n2dump,1005) kount,start,stop,step
1005  format ('the number of points per synthesis = ',i5/
     .       'start = ',f10.3,5x,'stop = ',f10.3,5x,'step = ',f10.3)
      if (xsyn(1) .le. 100.0) then
         write (n2dump,1009) (xsyn(i),chunk(i,nsyn),i=1,kount)
      else 
         write (n2dump,1008) (xsyn(i),chunk(i,nsyn),i=1,kount)
      endif
1009  format (f10.6,'  ',f10.5)
1008  format (f10.3,'  ',f10.5)
      nsyn = nsyn + 1
      go to 40


c*****exit the routine normally
2000  nsyn = nsyn - 1
      return



      end



      subroutine snearly                                                  
c******************************************************************************
c     This routine calculates the quantity *almost* for each line and       
c     each tau. when *almost* is multiplied by the voigt function, one      
c     gets the line opacity. the broadening parameter *a* and the doppler   
c     parameter *dopp* are also computed   
c
c     THIS ROUTINE IS FOR THE STRONG LINES....
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Quants.com'
      include 'Linex.com'
      include 'Mol.com'
      include 'Strong.com'
      include 'Dummy.com'
      dimension xnum(75)
      equivalence (xnum,dummy1)


c*****do the whole routine for each line (1:nlines)
      do j=1,nstrong                                                  


c*****set up some parameters
         ich = idint(scharge(j) + 0.1)                    
         iatom = satom1(j)                                                   
         factoriso = 1.0
                      

c*****calculate the doppler parameter                                       
         do i=1,ntau                                                     
            sdopp(j,i) = dsqrt(1.6631d8*t(i)/samass(j)+vturb(i)**2)            
         enddo


c*****calculate lower state atomic number densities for atoms.  Here,
c     q21 is the ion/neutral ratio, etc., and q is the ratio of the total
c     to the species of interest.  Do the Saha equation first, then
c     the Boltzmann equation
         if(iatom .ge. 100) go to 5                                         
         do i=1,ntau                                                     
            q21 = 4.825d15*u(iatom,2,i)/(u(iatom,1,i)*ne(i))*
     .            t(i)**1.5*dexp(-1.1605d4*schi(j,1)/t(i))                    
            q32 = 4.825d15*u(iatom,3,i)/(u(iatom,2,i)*ne(i))*
     .            t(i)**1.5*dexp(-1.1605d4*schi(j,2)/t(i))             
            q43 = 4.825d15*u(iatom,4,i)/(u(iatom,3,i)*ne(i))*
     .            t(i)**1.5*dexp(-1.1605d4*schi(j,3)/t(i))              
            if     (ich .eq. 1) then
               q = 1.0 + q21 + q32*q21 + q43*q32*q21
            elseif (ich .eq. 2) then
               q = 1.0/q21 + 1.0 + q32 + q43*q32
            elseif (ich .eq. 3) then
               q = 1.0/(q21*q32) + 1.0/q32 + 1.0 + q43
            endif
            if (neq .ne. 0) then
               do n=1,neq
                  if (iatom .eq. iorder(n)) then
                     xnum(i) = xamol(n,i)
                     if     (ich .eq. 1) then
                        q = 1.0
                     elseif (ich .eq. 2) then
                        q = 1.0/q21
                     endif
                     go to 35
                  endif
               enddo
            endif
            xnum(i) = xabund(iatom)*nhtot(i)                             
35          xnum(i) = xnum(i)/q*dexp(-1.1605d4*se(j,1)/t(i))/
     .      u(iatom,ich,i)   
         enddo
         go to 101                                                          

c*****calculate lower state molecular number densities and line opacities   
c     at line centers                                                       
5        am = schi(j,2)                                                      
         call sunder(satom1(j),iaa,ibb)                                        
         do n=1,neq                                                      
            if(iorder(n) .eq. iaa) ia = n                                       
            if(iorder(n) .eq. ibb) ib = n                                       
         enddo
         do i=1,ntau                                                     
            theta = 5040.0/t(i)                                                
            psipri = 1.38054d-16*t(i)*10.0**(schi(j,1)*theta-13.670)*
     .               theta**2.5/(am**1.5*u(iaa,1,i)*u(ibb,1,i)) 
            xnum(i) = dexp(-1.1605d4*se(j,1)/t(i))*psipri*
     .                xamol(ia,i)*xamol(ib,i)
         enddo
 
 
c*****calculate the line opacities at line centers
101      if (satom1(j)-float(iatom) .gt. 0.0) then
            do i=1,numiso
               if (satom1(j) .eq. isotope(i)) then
                  factoriso = isoabund(i,isorun)
               endif
            enddo
         endif
         do i=1,ntau
300         skapnu0(j,i) = 2.65386d-2*xnum(i)*sgf(j)*swave1(j)*1.0d-8/
     .                    sdopp(j,i)*(1.0-dexp(-1.43879d8/
     .                    (swave1(j)*t(i))))/factoriso    
c    .                    (swave1(j)*t(i))))/dfloat(factoriso)     AMcW 1/200
         enddo
c        strength(j) = kapnu0(j,jtau5)/dfloat(factoriso) AMcW 1/200
         strength(j) = kapnu0(j,jtau5)/factoriso
 

c*****calculate the line broadening parameter; call a separate routine 
c     for special cases where the damping parameters are accurately known
         if (itru .eq. 1 .and. (satom1(j).eq.20.1 .or. 
     .       satom1(j).eq.20.0 .or. satom1(j).eq.11.0)) then
             ifind = -1
             call strudamp (j,ifind)
         else
            ifind = 0
         endif
         if (ifind .eq. 0) then
            if (ipr(3) .gt. 1) write (nwrite,1001) j, swave1(j)
1001        format(//' LINE BROADENING PARAMETERS FOR LINE', i4,
     .             ' AT WAVELENGTH',f8.2/
     .             '  i',4x,'natural',6x,'Stark',4x,'VdWaals',
     .             6x,'total',5x,'a(j,i)')
            do i=1,ntau                                                    
               v1 = dsqrt(2.1175d8*t(i)*(1.0/samass(j)+1.008))        
               gammar = 2.223d15/swave1(j)**2
               excdiff = schi(j,idint(scharge(j)+0.001)) - se(j,2)
               if (excdiff .gt. 0) then
                  effn2 = 13.6*scharge(j)**2/excdiff
               else
                  effn2 = 25.
               endif
               gammas = 1.0e-8*ne(i)*effn2**2.5
               gammav = 17.0*sc6(j)**0.4*v1**0.6*nhneutral(i)
               gammatot = gammar + gammas + gammav
               sa(j,i) = gammatot*swave1(j)*1.0d-8/
     .                   (12.56636*sdopp(j,i))
               if (ipr(3) .gt. 1) write (nwrite,1002) i,gammar,
     .                            gammas,gammav,gammatot,sa(j,i)
1002           format (i3,1p5e11.3)
            enddo
         endif
      enddo                                                           


c*****exit the routine normally
      return                                                             

      end                                                                











      subroutine stats
c******************************************************************************
c     This routine does abundance statistics for a single species
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'

c*****compute the average and standard deviation
      average = 0.
      kount = 0
      do l=lim1obs,lim2obs
         if (abunout(l) .ne. 999.99) then
            average = average + abunout(l)
            kount = kount + 1
         endif
      enddo
      if (kount .gt. 0) then
         average = average/kount
      endif
      deviate = 0.
      if (kount .gt. 1) then
         do l=lim1obs,lim2obs
            if (abunout(l) .ne. 999.99) then
               deviate = deviate + (abunout(l)-average)**2
            endif
         enddo
         deviate = dsqrt(deviate/(kount-1))
      endif
         
c*****correlate the abundances with excitation potential and equivalent width
      if (kount .gt. 2) then
         epmin = 999.
         epmax = -999.
         rwmin = 999.
         rwmax = -999.
         x1 = 0.
         x2 = 0.
         x3 = 0.
         x4 = 0.
         y1 = 0.
         y2 = 0.
         xy = 0.
         yz = 0.
         do l=lim1obs,lim2obs
            if (abunout(l) .ne. 999.99) then
               rw = dlog10(width(l)/wave1(l))
               x1 = x1 + e(l,1)
               x2 = x2 + e(l,1)**2
               x3 = x3 + rw
               x4 = x4 + rw**2
               y1 = y1 + abunout(l)
               y2 = y2 + abunout(l)**2
               xy = xy + e(l,1)*abunout(l)
               yz = yz + rw*abunout(l)
               if (e(l,1) .lt. epmin) epmin = e(l,1)
               if (e(l,1) .gt. epmax) epmax = e(l,1)
               if (rw .lt. rwmin) rwmin = rw
               if (rw .gt. rwmax) rwmax = rw
            endif
         enddo
         xxm1 = (kount*xy - x1*y1)/(kount*x2 - x1**2)
         xxb1 = (y1*x2 - xy*x1)/(kount*x2 - x1**2)
         xxr1 = (kount*xy - x1*y1)/dsqrt((kount*x2 - x1**2)*
     .         (kount*y2 - y1**2))
         xxm2 = (kount*yz - x3*y1)/(kount*x4 - x3**2)
         xxb2 = (y1*x4 - yz*x3)/(kount*x4 - x3**2)
         xxr2 = (kount*yz - x3*y1)/dsqrt((kount*x4 - x3**2)*
     .         (kount*y2 - y1**2))
         deltaep = epmax - epmin
         deltarw = rwmax - rwmin
      endif

      return
      end
  

      subroutine strudamp (j,ifind)
c*************************************************************************
c     This routine calculates damping parameters for strong lines that have
c     accurately known laboratory damping parameters
c*************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Strong.com'
      real*8 nhe

      iwave = int(swave1(j))

      if (satom1(j) .eq. 20.1) then
         if (iwave.ne.8498 .and. iwave.ne.8542 .and.
     .       iwave.ne.8662) go to 200
         write (nwrite,1000)
1000     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'CaII INFRARED TRIPLET'/
     .          4x,'natural',6x,'stark',5x,'helium',3x,'hydrogen',
     .          6x,'gamma',5x,'a(j,i)',5x,'a(VdW)')
         do 10 i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 1.5e+08
            gstark  = 1.5e-06*ne(i)*(t(i)/5000.)**0.1666
            ghelium = 3.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 1.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gamma = gnature/2. + gstark + ghelium + ghydro 
            sa(j,i) = gamma*swave1(j)*1.0e-8/(12.56636*sdopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/samass(j)+1.008))       
            gvander = 17.0*sc6(j)**0.4*v1**0.6*nhtot(i)       
            avander = gvander*swave1(j)*1.0d-8/(12.56636*sdopp(j,i))  
            write (nwrite,1001) gnature,gstark,ghelium,ghydro,
     .                          gamma,sa(j,i),avander
1001        format (1p7e11.3)
10          continue
         return
      elseif (satom1(j) .eq. 20.0) then
         if (iwave .ne. 6717) go to 200
         write (nwrite,1002) iwave
1002     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'CaI LINE AT',i5/
     .          4x,'natural',5x,'helium',3x,'hydrogen',
     .          6x,'gamma',5x,'a(j,i)',5x,'a(VdW)')
         do 20 i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 0.4e-08
            ghelium = 1.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 2.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gamma = gnature/2. + ghelium + ghydro 
            gamma = gamma*2.
            sa(j,i) = gamma*swave1(j)*1.0e-8/(12.56636*sdopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/samass(j)+1.008))           
            gvander = 17.0*sc6(j)**0.4*v1**0.6*nhtot(i)       
            avander = gvander*swave1(j)*1.0d-8/(12.56636*sdopp(j,i))  
            write (nwrite,1001) gnature,ghelium,ghydro,
     .                          gamma,sa(j,i),avander
20          continue
         return
      elseif (satom1(j) .eq. 11.0) then
         write (nwrite,1003) iwave
1003     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'NaI LINE AT',i5/
     .          4x,'natural',4x,'VdW*1.2',6x,'gamma',
     .          5x,'a(j,i)',5x,'a(VdW)')
         do 30 i=1,ntau
            gnature = 2.21e+15/swave1(j)**2
            v1 = dsqrt(2.1175d8*t(i)*(1.0/samass(j)+1.008))      
            gvander = 17.0*sc6(j)**0.4*v1**0.6*nhtot(i)       
            gcoll   = gvander*2.1
            gamma = gnature/2. + gcoll
            sa(j,i) = gamma*swave1(j)*1.0e-8/(12.56636*sdopp(j,i))
            avander = gvander*swave1(j)*1.0d-8/(12.56636*sdopp(j,i))  
            write (nwrite,1001) gnature,gcoll,gamma,sa(j,i),avander
30          continue
         return
      endif

200   ifind = 0
      return
      

      end




      subroutine sunder(amol,i1,i2)                                      
c******************************************************************************
c     This routine breaks up molecule amol into leftmost atom i1 and        
c     the rest of the molecule i2                                           
c******************************************************************************

      implicit real*8 (a-h,o-z)
      dimension itest(5)                                                 
      data itest/100000000,1000000,10000,100,1/                          
      im = amol                                                          
      do 1 i=1,5                                                         
      i1 = im/itest(i)                                                   
      if(i1 .eq. 0) go to 1                                              
      i2 = im - i1*itest(i)                                              
      return                                                             
1     continue                                                           
      return                       
      end                                      

      subroutine synplot (choice,deviations)
c******************************************************************************
c     This routine produces MONGO plots of the syntheses.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Quants.com'
      include 'Factor.com'
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
c     real*4 style(1)  AMcW 1/2000
c     real*4 yup,ydown  AMcW 1/2000
      real*8 style(1)
      real*8 yup,ydown
      character*1 choice, deviations
      integer iflip
      character*7 colors(8)


c*****assign colors to character arrays
      colors(1) = 'white  '
      colors(2) = 'red    '
      colors(3) = 'blue   '
      colors(4) = 'yellow '
      colors(5) = 'green  '
      colors(6) = 'cyan   '
      colors(7) = 'magenta'
      colors(8) = 'black  '
 

c*****define the plot limits
      if(xlo .lt. xhi) then
         call sm_limits (xlo,xhi,ylo,yhi)
         iflip = 0
      else
         call sm_limits (xhi,xlo,ylo,yhi)
         iflip = 1
      endif
      call findtic (xlo,xhi,bigxtic,smlxtic)
      call findtic (ylo,yhi,bigytic,smlytic)
      call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)


c*****draw and label the box for the spectra
      call sm_expand (1.2d0)
      call sm_lweight (1.8d0)
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype (colors(8))
      else
         call sm_ctype (colors(1))
      endif
      if (deviations .eq. 'n') then
         call sm_window (1,1,1,1,1,1)
      else
         call sm_window (1,2,1,1,1,1)
      endif
      call sm_box (1,2,0,0)
      if (iflip .eq. 1) then
         array = 'Wavenumber'
      else
         array = 'Wavelength'
      endif
      call sm_xlabel (array)
      array = 'Rel  Flux'
      call sm_ylabel (array)
      call sm_expand (0.9d0)
      call sm_lweight (1.4d0)
      

c*****plot the synthetic spectra
      do i=1,100
         if (pec(i) .ne. 0) go to 111
      enddo            
111   do j=1,nsyn
         if (choice.eq.'h' .or. choice.eq.'f') then
            call sm_ctype (colors(8))
            call sm_ltype (j-1)
         else
            if (smterm.eq.'x11' .or. smterm.eq.'X11') then
               call sm_ctype (colors(j+1))
               call sm_ltype (0)
            else
               call sm_ctype (colors(1))
               call sm_ltype (j-1)
            endif
         endif
         call sm_conn (xsyn,chunk(1,j),kount) 
         if (iflip .eq. 1) then
            call sm_relocate (xhi+0.045d0*(xlo-xhi),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_draw (xhi+0.005d0*(xlo-xhi),
     .                 ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_relocate (xhi+0.05d0*(xlo-xhi),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
         else
            call sm_relocate (xlo+0.045d0*(xhi-xlo),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_draw (xlo+0.005d0*(xlo-xhi),
     .                 ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
            call sm_relocate (xlo+0.05d0*(xhi-xlo),
     .                     ylo+(0.08d0+0.04d0*dble(j))*(yhi-ylo))
         endif
         noff = 80*(j-1)
         call sm_label (abitle(noff+1:noff+80))
      end do
      if (choice.eq.'h' .or. choice.eq.'f') then
         call sm_ctype (colors(8))
      else
         call sm_ctype (colors(1))
      endif
      call sm_ltype (0)

   
c*****plot the observed spectrum
      if (ipr(7) .eq. 2) then
         call sm_lweight (2.2d0)
         mount = lim2obs - lim1obs + 1
         if (mount .lt. 1000) then
            style(1) = 43.0d0
            call sm_ptype (style,1)
            call sm_points (xobs(lim1obs),yobs(lim1obs),mount)
         else
            call sm_conn (xobs(lim1obs),yobs(lim1obs),mount)
         endif
         call sm_lweight (1.0d0)
         if (iflip .eq. 1) then
            call sm_relocate (xhi+0.05d0*(xlo-xhi),ylo+0.08d0*(yhi-ylo))
         else
            call sm_relocate (xlo+0.05d0*(xhi-xlo),ylo+0.08d0*(yhi-ylo))
         endif
         call sm_label (obsitle)
      endif
      if (iflip .eq. 1) then
         call sm_relocate (xhi+0.05d0*(xlo-xhi),ylo+0.04d0*(yhi-ylo))
      else
         call sm_relocate (xlo+0.05d0*(xhi-xlo),ylo+0.04d0*(yhi-ylo))
      endif
      call sm_label (moditle)
      if (deviations .eq. 'n' .or. ipr(7) .ne. 2) return
 

c*****this section of code is executed only if a deviations plot is desired;
c     find the starting and stopping points in the arrays for the deviations
      if (xsyn(kount) .le. xobs(lim1obs)) go to 1000
      if (xsyn(1) .gt. xobs(lim2obs)) go to 1000
      if (xsyn(1) .gt. xobs(lim1obs)) go to 150
      lim3obs = lim1obs
      do k=2,kount
         if (xsyn(k) .gt. xobs(lim3obs)) then
            lim1syn = k - 1
            go to 155
         endif
      enddo
150   lim1syn = 1
      do l=lim1obs,lim2obs
         if (xsyn(lim1syn) .le. xobs(l)) then
            lim3obs = l 
            go to 155
         endif
      enddo
155   if (xsyn(kount) .lt. xobs(lim2obs)) go to 160
      lim4obs = lim2obs
      do k=lim1syn,kount
         if (xsyn(k) .gt. xobs(lim4obs)) then
            lim2syn = k
            go to 165
         endif
      enddo
160   lim2syn = kount
      do l=lim3obs,lim2obs
         if (xsyn(lim2syn) .lt. xobs(l)) then
            lim4obs = l - 1
            go to 165
         endif
      enddo


c  compute the deviations; linear interpolation in the wavelength array
c  of the synthetic spectra is considered sufficient
165   do j=1,nsyn
         lpoint = lim1syn
         devsigma = 0.
         do i=lim3obs,lim4obs
170         if (xsyn(lpoint+1) .lt. xobs(i)) then
               lpoint = lpoint + 1
               go to 170
            endif
            syninterp = (chunk(lpoint+1,j)-chunk(lpoint,j))*
     .         (xobs(i)-xsyn(lpoint))/(xsyn(lpoint+1)-xsyn(lpoint)) +
     .         chunk(lpoint,j)
            dev(i) = yobs(i) - syninterp
            devsigma = devsigma + dev(i)**2
         enddo
         devsigma = dsqrt(devsigma/(lim4obs-lim3obs-1))
         
      
c  from first set of deviations, define the plot limits, draw and label box
         if (j .eq. 1) then
            yup = -1000.
            ydown = +1000.
            do i=lim3obs,lim4obs
               yup = dmax1(yup,dev(i))
               ydown = dmin1(ydown,dev(i))
            enddo
            ydelta = dmin1(0.3d0,dmax1(0.05d0,1.5d0*(yup-ydown)/2.d0))
            ydown = -ydelta
            yup = ydelta
            call sm_limits (xlo,xhi,ydown,yup)
            call findtic (ydown,yup,bigytic,smlytic)
            call sm_ticksize (smlxtic,bigxtic,smlytic,bigytic)
            call sm_expand (1.2d0)
            call sm_lweight (1.8d0)
            if (choice.eq.'h' .or. choice.eq.'f') then
               call sm_ctype (colors(8))
            else
               call sm_ctype (colors(1))
            endif
            call sm_window (1,2,1,2,1,2)
            call sm_box (0,2,0,0)
            array = 'Obs - Comp'
            call sm_ylabel (array)
            call sm_relocate (xlo,0.0d0)
            call sm_draw (xhi,0.0d0)
            call sm_expand (0.9d0)
         endif


c  plot the array of deviations
180      if (choice.eq.'h' .or. choice.eq.'f') then
            call sm_ctype (colors(8))
            call sm_ltype (j-1)
         else
            if (smterm.eq.'x11' .or. smterm.eq.'X11') then
               call sm_ctype (colors(j+1))
               call sm_ltype (0)
            else
               call sm_ctype (colors(1))
               call sm_ltype (j-1)
            endif
         endif
         call sm_conn (xobs(lim1obs),dev(lim1obs),mount)
         write (array,1021) devsigma
1021     format ('sigma =',f6.3)
         call sm_relocate(xhi-0.2d0*(xhi-xlo),
     .                 ydown+(0.10d0+0.06d0*dble(j))*(yup-ydown))
         call sm_relocate(xhi-0.24d0*(xhi-xlo),
     .                 ydown+(0.10d0+0.06d0*dble(j))*(yup-ydown))
         call sm_draw(xhi-0.215d0*(xhi-xlo),
     .                 ydown+(0.10d0+0.06d0*dble(j))*(yup-ydown))
         call sm_label (array)
      enddo


c  reset the spectrum plot boundaries before exiting
      if(xlo .lt. xhi) then
         call sm_limits (xlo,xhi,ylo,yhi)
         iflip = 0
      else
         call sm_limits (xhi,xlo,ylo,yhi)
         iflip = 1
      endif


1000  return
      end







      subroutine synspec                                                 
c******************************************************************************
c     This routine does synthetic spectra                                
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'


c*****initialize the synthesis
      call out (11)                                                       
      n = 1                                                              
      nsteps = 1
      lim1line = 0


c*****calculate continuum quantities at the spectrum wavelength
      wave = start
      wavl = 0.
 30   if (dabs(wave-wavl)/wave .ge. 0.001) then
         wavl = wave   
         call opacit (2,wave)    
         call out (15)                         
         call cdcalc (1)  
         first = 0.4343*cd(1)
         flux = rinteg(xref,cd,dummy1,ntau,first)
         call out (10)          
      endif


c*****find the appropriate set of lines for this wavelength, reading 
c     in a new set if needed
      if (mode .eq. 3) then
20       call linlimit
         if (lim2line .lt. 0) then
            call inlines (2)
            call nearly
            go to 20
         endif
         lim1 = lim1line
         lim2 = lim2line
      endif

c*****compute a spectrum depth at this point
      call taukap   
      call cdcalc (2)
      first = 0.4343*cd(1)
      d(n) = rinteg(xref,cd,dummy1,ntau,first)       
      call out (12)                

c*****step in wavelength and try again 
      if (iunits .eq. 2) then
         wave = 1.d8/(oldstop - step*nsteps)
         delta = olddelta/(1.d8/wave**2)
      elseif (iunits .eq. 1) then
         wave = 1.d4*oldstart + step*nsteps
      else
         wave = oldstart + step*nsteps
      endif
      if (wave .le. stop) then
         n = n + 1        
         nsteps = nsteps + 1
         if (n .gt. 5000) n = 1                                      
         go to 30                   

c*****finish the synthesis
      else
         call out (13)                 
         return 
      endif


      end                                




      subroutine synth                   
c******************************************************************************
c     This program synthesizes a section of spectrum and compares it
c     to an observation file.
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Factor.com'
      include 'Mol.com'
      include 'Strong.com'
      include 'Linex.com'
      include 'Pstuff.com'


c*****examine the parameter file
      call params


c*****set up the output files
      nwrite = 20     
      lscreen = 4
      array = 'Give the filename for standard output: '
      nchars = 39
      call infile ('output ',nwrite,'formatted  ',0,nchars,lscreen)
      ndump = 21               
      lscreen = lscreen + 2
      array = 'Give the filename for raw syntheses output: '
      nchars = 44
      call infile ('output ',ndump,'formatted  ',0,nchars,lscreen)
      if (ipr(7) .ne. 0) then
         n2dump = 22               
         lscreen = lscreen + 2
         array = 'Give the filename for smoothed syntheses: '
         nchars = 42
         call infile ('output ',n2dump,'formatted  ',0,nchars,lscreen)
      endif
      if (iraf .ne. 0) then
         n2write = 23               
         lscreen = lscreen + 2
         array = 'Give the filename for IRAF ("rtext") output: '
         nchars = 45
         call infile ('output ',n2write,'formatted  ',0,nchars,lscreen)
      endif


c*****set up the model atmosphere                                        
      filemodel = 30
      lscreen = lscreen + 2
      array = 'Give the filename for the model atmosphere: '
      nchars = 44
      call infile ('input  ',filemodel,'formatted  ',0,nchars,lscreen)
      call inmodel


c*****open the line list file and the strong line list file
      filelines = 31
      lscreen = lscreen + 2
      array = 'Give the filename for the line list: '
      nchars = 37
      call infile ('input  ',filelines,'formatted  ',0,nchars,lscreen)
      if (nstrong .gt. 0) then
         fileslines = 32
         lscreen = lscreen + 2
         array = 'Give the filename for the strong line list: '
         nchars = 44
         call infile ('input  ',fileslines,'formatted  ',0,nchars,
     .                lscreen)
      endif
      

c*****do the syntheses
      if (numpecatom .eq. 0 .or. numatomsyn .eq. 0) then
         isorun = 1
         nlines = 0
         mode = 3
         call inlines (1)
         call eqlib
         call nearly
         call synspec
      else
         do n=1,numatomsyn
            isynth = n
            isorun = 1
            mode = 3
	    if (numiso .ne. 0) call out (26)
            call inlines (1)
            call eqlib
            call nearly
            start = oldstart
            stop = oldstop
            call synspec
            ipr(3) = 0
         enddo
      endif
         

c*****now plot the spectrum
      if (ipr(7).eq.2 .and. ipr(9).gt.0) then
         fileobs = 23               
         lscreen = lscreen + 2
         array = 'Give the filename of the observed spectrum: '
         nchars = 44
         if (ipr(9) .eq. 1) then
            call infile ('input  ',fileobs,'unformatted',2880,nchars,
     .                   lscreen)
         else
            call infile ('input  ',fileobs,'formatted  ',0,nchars,
     .                   lscreen)
         endif
      endif
      if (ipr(7) .ne. 0) then
         call pltspec (lscreen)
      endif

c*****finish
      call finish
      end                                                                







      subroutine taukap                                                  
c******************************************************************************
c     This routine calculates the line absorption coefficient and the line  
c     opacity at wavelength *wave* for all lines in the spectrum            
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Dummy.com'
      include 'Strong.com'


c*****compute the total line opacity at each depth                          
      do i=1,ntau                                                     
         kapnu(i) = 0.0                                                     
         do j=lim1,lim2                                                  
            v = 2.997929d10*dabs(wave-wave1(j))/
     .             (wave1(j)*dopp(j,i))            
            kapnu(i) = kapnu(i) + kapnu0(j,i)*voigt(a(j,i),v)                  
         enddo                                     

c*****do the same for the strong lines
         if (nstrong .gt. 0) then
            do j=1,nstrong
               v = 2.997929d10*dabs(wave-swave1(j))/
     .             (swave1(j)*sdopp(j,i)) 
               kapnu(i) = kapnu(i) + skapnu0(j,i)*voigt(sa(j,i),v)    
            enddo
         endif

         dummy1(i) = tauref(i)*kapnu(i)/(0.4343*kapref(i))
      enddo                                                              

c*****compute the optical depths                                            
      first = tauref(1)*kapnu(1)/kapref(1)
      dummy1(1) = rinteg(xref,dummy1,taunu,ntau,0.d0)      
      taunu(1) = first
      do i=2,ntau                                                     
         taunu(i) = taunu(i-1) + taunu(i)                                   
      enddo

      return                                                             
      end                                                                

      subroutine total                                                   
c******************************************************************************
c     This routine integrates to get an equivalent width.                   
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Dummy.com'
      real*8 waveint(5000),depthint(5000)
      equivalence (waveint,dummy3),(depthint,dummy4)

c*****compute the wavelength array 
      ntotal = (stop - start)/step + 1.3                                  
      if (ntotal .gt. 5000) then
         write (nwrite,1002) ntotal
         write (ndump,1002) ntotal
1002     format (i7,' POINTS ARE TOO MANY FOR THE INTEGRATION')
         return
      endif
      do i=1,ntotal                                                    
         waveint(i) = start + step*(i-1)    
      enddo

c*****use the RINTEG routine to do an integration
      answer = 1000.*rinteg(waveint,d,depthint,ntotal,0.d0)         
      write (nwrite,1001) answer,ntotal                               
      write (ndump,1001) answer,ntotal                               
      w(ncurve) = answer/1000.
1001  format (' equivalent width: ',f8.2,' ma.',5x,
     .        5x,'number of points: ',i5)                                

c*****Then recheck using Simpson's rule
      ntot = ntotal                                                      
      if(ntotal/2*2 - ntotal .eq. 0) ntot = ntotal - 1                   
      answer = d(1) + 4.*d(2) + d(ntot)                                  
      ntot = ntot - 2                                                    
      do i=3,ntot,2                                                   
         answer = answer + 2.*d(i) + 4.*d(i+1)                              
      enddo
      answer = 1000.*step/3.*answer                                      
      write (nwrite,1006) answer                                             
      write (ndump,1006) answer                                             
1006  format(' Simpson rule check on equivalent width =',f8.2)          


      return                                                             
      end                                                                







      subroutine trudamp (j,ifind)
c*************************************************************************
c     This routine calculates damping parameters for lines that have
c     accurately known laboratory damping parameters
c*************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Linex.com'
      real*8 nhe

      iwave = int(wave1(j))

      if (atom1(j) .eq. 20.1) then
         if (iwave.ne.8498 .and. iwave.ne.8542 .and.
     .       iwave.ne.8662) go to 200
         write (nwrite,1000)
1000     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'CaII INFRARED TRIPLET'/
     .          4x,'natural',6x,'stark',5x,'helium',3x,'hydrogen',
     .          6x,'gamma',5x,'a(j,i)',5x,'a(VdW)')
         do 10 i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 1.5e+08
            gstark  = 1.5e-06*ne(i)*(t(i)/5000.)**0.1666
            ghelium = 3.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 1.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gamma = gnature/2. + gstark + ghelium + ghydro 
            a(j,i) = gamma*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))                      
            gvander = 17.0*c6(j)**0.4*v1**0.6*nhtot(i)       
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nwrite,1001) gnature,gstark,ghelium,ghydro,
     .                          gamma,a(j,i),avander
1001        format (1p7e11.3)
10          continue
         return
      elseif (atom1(j) .eq. 20.0) then
         if (iwave .ne. 6717) go to 200
         write (nwrite,1002) iwave
1002     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'CaI LINE AT',i6/
     .          4x,'natural',5x,'helium',3x,'hydrogen',
     .          6x,'gamma',5x,'a(j,i)',5x,'a(VdW)')
         do 20 i=1,ntau
            nhe = xabund(2)*nhtot(i)
            gnature = 0.4e-08
            ghelium = 1.0e-09*nhe*(t(i)/5000.)**0.4 
            ghydro  = 2.0e-08*nhtot(i)*(t(i)/5000.)**0.4 
            gamma = gnature/2. + ghelium + ghydro 
            gamma = gamma*2.
            a(j,i) = gamma*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))                      
            gvander = 17.0*c6(j)**0.4*v1**0.6*nhtot(i)       
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nwrite,1001) gnature,ghelium,ghydro,
     .                          gamma,a(j,i),avander
20          continue
         return
      elseif (atom1(j) .eq. 11.0) then
         write (nwrite,1003) iwave
1003     format(//' LINE BROADENING PARAMETERS FOR ',
     .            'NaI LINE AT',i6/
     .          4x,'natural',4x,'VdW*1.2',6x,'gamma',
     .          5x,'a(j,i)',5x,'a(VdW)')
         do 30 i=1,ntau
            gnature = 2.21e+15/wave1(j)**2
            v1 = dsqrt(2.1175d8*t(i)*(1.0/amass(j)+1.008))                      
            gvander = 17.0*c6(j)**0.4*v1**0.6*nhtot(i)       
            gcoll   = gvander*2.1
            gamma = gnature/2. + gcoll
            a(j,i) = gamma*wave1(j)*1.0e-8/(12.56636*dopp(j,i))
            avander = gvander*wave1(j)*1.0d-8/(12.56636*dopp(j,i))  
            write (nwrite,1001) gnature,gcoll,gamma,a(j,i),avander
30          continue
         return
      endif

200   ifind = 0
      return
      

      end





      real*8 function ucalc(atom,level)                                         
c******************************************************************************
c     This routine decodes the partition function data. the source       
c     is the atlas program of kurucz                                     
c******************************************************************************

      implicit real*8 (a-h,o-z)
      include 'Atmos.com'
      include 'Quants.com'
      dimension scale(4)                                                 
      data scale/0.001,0.01,0.1,1.0/                                     

      if (level .gt. 500) then
         temp = level                                                       
      else
         temp = t(level)                                                    
      endif

      iatom = int(atom + 0.01)
      ion = int(10.*(atom - float(iatom)) + 0.01)
      j = 3*(iatom-1) + ion + 1
    
      if (ion .eq. 3) then 
         ucalc = 10**(udata(iatom))
         return
      endif
 
      if (ion .eq. 0) then	
         chix = xchi1(iatom)                                                
      elseif (ion .eq. 1) then
         chix = xchi2(iatom)                                                
      else
         chix = xchi3(iatom)
      endif

      t2000 = chix*2000./11.                                             
      it = max0(1,min0(9,idint(temp/t2000-0.5)))                          
      dt = temp/t2000 - float(it) - 0.5                                  
      pmin = 1.                                                          
      i = (it+1)/2                                                       
      k1 = nudata(i,j)/100000                                            
      k2 = nudata(i,j) - k1*100000                                       
      k3 = k2/10                                                         
      kscale = k2 - k3*10                                                
      if (mod(it,2) .eq. 0) then
         p1 = float(k3)*scale(kscale)                                       
         k1 = nudata(i+1,j)/100000                                          
         kscale = mod(nudata(i+1,j),10)                                     
         p2 = float(k1)*scale(kscale)                                       
      else
         p1 = float(k1)*scale(kscale)                                       
         p2 = float(k3)*scale(kscale)                                       
         if (dt .ge. 0.) go to 13                                            
         if (kscale .gt. 1.) go to 13                                        
         kp1 = p1                                                           
         if (kp1 .ne. idint(p2+0.5)) go to 13                                 
         pmin = kp1                                                         
      endif
13    ucalc = dmax1(pmin,p1+(p2-p1)*dt)

      return                                                             
      end 



      subroutine vargauss (line)
c******************************************************************************
c     This subroutine prepares synthesis data for plotting by smoothing
c     the data with a Gaussian whose FWHM has been specified by the user
c     at various wavelengths along the spectrum
c******************************************************************************
 
      implicit real*8 (a-h,o-z)
      include 'Chars.com'
      include 'Atmos.com'
      include 'Linex.com'
      include 'Pstuff.com'
      include 'Equivs.com'
      real*8 wavefwhm(100),fwhm(100)
      integer filesmooth
      logical smflag
      data istart /0/


c*****initialize parameters
      nsyn = 1
      sigma = 0.   
      jrotdel = 0
      smflag = .false.


c*****on entering, rewind the unsmoothed and smoothed spectrum output 
c     files, and get the synthesis range parameters from the 'dump' file
      rewind ndump
      rewind n2dump
55    read (ndump,1002) moditle
      if (moditle(1:15).eq.'        element' .or.  
     .    moditle(1:15).eq.' ALL abundances' .or.
     .    moditle(1:15).eq.'Isotope Ratio: ') go to 55
1002  format (a80)
      read (ndump,*) start, stop, step
      kount = int((stop - start + (step/4.0) )/step) + 1
      rewind ndump


c*****the first time through, read in the Gaussian FWHM array
      if (istart .eq. 0) then
         istart = 1
         filesmooth = 35
         array = 'Give the filename for the smoothing FWHM data: '
         nchars = 47
         call infile ('input  ',filesmooth,'formatted  ',0,nchars,line)
         j = 1
39       read (filesmooth,*,end=40) wavefwhm(j), fwhm(j)
         j = j + 1
         if (j .le. 100) then
            go to 39
         else
            istat = ivcleof (line,1)
            istat = ivmove (line-1,1)
            write (*,*) 'ERROR: TOO MANY POINTS IN THE FWHM FILE!'
            smtype = 'e'
            return
         endif
40       jtotfwhm = j - 1
      endif


c*****now read in the raw spectrum and flip to a depth scale
45    noff = 80*(nsyn-1)
      abitle(noff+1:noff+12) = '[M/H] 0.00  '
      nabunds = 0
41    read (ndump,1002,end=2000) array
      if     (array(1:15).eq.' ALL abundances') then
         abitle(noff+6:noff+10) = array(56:60)
         go to 41
      elseif (array(1:15).eq.'        element') then
         nabunds = nabunds + 1
         if (nabunds .le. 7) then
            ioff = noff + 12 + 9*(nabunds-1)
            abitle(ioff+1:ioff+2) = array(17:18)
            abitle(ioff+3:ioff+7) = array(34:38)
            abitle(ioff+8:ioff+9) = '  '
         endif
         go to 41
      elseif (array(1:15).eq.'Isotope Ratio: ') then
         nabunds = nabunds + 1
         if (nabunds .le. 7) then
            ioff = noff + 12 + 9*(nabunds-1)
            abitle(ioff+1:ioff+4) = array(27:30)
            abitle(ioff+5:ioff+5) = ' '
            do k=33,44
               if (array(k:k) .ne. ' ') then
                  abitle(ioff+6:ioff+8) = array(k:k+2)
                  go to 60
               endif
            enddo
60          abitle(ioff+9:ioff+9) = ' '
         endif
         go to 41
      endif
      read (ndump,1002,end=2000)
      read (ndump,1003,end=2000) (y(i),i=1,kount)
1003  format (10f7.4)
      do i=1,kount
         y(i) = 1.0 - y(i)
      enddo


c*****go through the spectrum wavelengths step by step; the 
c     Gaussian smoothing will need to be different at each step
      i = 0
      oldhalf = 0.
25    i = i + 1
      if (i .gt. kount) go to 90
      synstep = start + (i-1)*step


c*****interpolate linearly in the FWHM array to get the appropriate value 
c     for the current wavelength step
      if     (synstep .le. wavefwhm(1)) then
         half = fwhm(1)
      elseif (synstep .ge. wavefwhm(jtotfwhm)) then
         half = fwhm(jtotfwhm)
      else
         do j=2,jtotfwhm
            if (synstep .le. wavefwhm(j)) then
               half = fwhm(j-1) + (synstep-wavefwhm(j-1))*
     .                (fwhm(j)-fwhm(j-1))/(wavefwhm(j)-wavefwhm(j-1))
               if (half .gt. 0.) then
                  go to 10
               else
                  go to 15
               endif
            endif
         enddo
      endif


c*****compute the Gaussian smoothing function, if needed
10    if (dabs(half-oldhalf)/half .lt. 0.03) go to 50
      oldhalf = half
      sigma = half/2
      aa = 0.6932/sigma**2
      power = 1.0
      do k=1,1000
         p(k) = dexp(-aa*(step*k)**2 )
         power = power + 2*p(k)
         if (p(k) .lt. 0.05) then
            jdel = k
            min = jdel + 1
            max = kount - jdel
            p0 = 1.
            go to 50 
         endif
      enddo
      istat = ivcleof (line,1)
      istat = ivmove (line-1,1)
      write (*,1023) sigma,(p(i),i=1,1000)
1023  format ('ERROR: GAUSSIAN PROFILE TOO BIG! (HALF WIDTH=',
     .       f6.2,')      THE PROFILE:'/(15f5.2))
      smtype = 'e'
      return


c*****if no smoothing, just equate the smoothed to the unsmoothed point
15    z(i) = y(i)
      go to 25

  
c*****otherwise smooth the spectrum
50    if (i.lt.min .or. i.gt.max) then
         z(i) = y(i)
      else
         z(i) = p0*y(i)
         do k=1,jdel
            z(i) = z(i) + p(k)*(y(i-k) + y(i+k))
         enddo
         z(i) = z(i)/power
      endif
      go to 25
 

c*****copy the smoothed spectrum to the appropriate array
90    do i=1,kount
         chunk(i,nsyn) = z(i)
      enddo


c*****compute the wavelength array; must be done for each synthetic
c     spectrum because of the way the equivalences were set up
      do i=1,kount
         xsyn(i) = start + (i-1)*step
      end do
 

c*****dump the smoothed spectrum in a MONGO-style set of 
c     (wavelength,flux) point pairs
      write (n2dump,1005) kount,start,stop,step
1005  format ('the number of points per synthesis = ',i5/
     .       'start = ',f10.3,5x,'stop = ',f10.3,5x,'step = ',f10.3)
      if (xsyn(1) .le. 100.0) then
         write (n2dump,1009) (xsyn(i),z(i),i=1,kount)
      else 
         write (n2dump,1008) (xsyn(i),z(i),i=1,kount)
      endif
1009  format (f10.6,'  ',f10.5)
1008  format (f10.3,'  ',f10.5)
      nsyn = nsyn + 1
      go to 45


c*****exit the routine normally
2000  nsyn = nsyn - 1
      return



      end




      real*8 function vmacro (xprofile)
c******************************************************************************
c     This routine computes, by linear interpolation, a point along a 
c     radial-tangential macroturbulence profile.  This routine was written by 
c     Suchitra Balachandran, and is based on the work of Gray 1992, in
c     "The Obs. & Anal. of Stell. Phot", p. 409.  These functions have 
c     been computed and included in the data arrays below:  
c             xrt = velocity / zeta_RT 
c             yrt = value at xrt  
c     The area under the function is normalized to unity
c******************************************************************************

      implicit real*8 (a-h,o-z)
      real*8 xrt(250), yrt(250)
c
      data (xrt(l),l=1,171)/
     . 0.0001,0.0101,0.0201,0.0301,0.0401,0.0501,0.0601,0.0701,0.0801,
     . 0.0901,0.1001,0.1101,0.1201,0.1301,0.1401,0.1501,0.1601,0.1701,
     . 0.1801,0.1901,0.2001,0.2101,0.2201,0.2301,0.2401,0.2501,0.2601,
     . 0.2701,0.2801,0.2901,0.3001,0.3101,0.3201,0.3301,0.3401,0.3501,
     . 0.3601,0.3701,0.3801,0.3901,0.4001,0.4101,0.4201,0.4301,0.4401,
     . 0.4501,0.4601,0.4701,0.4801,0.4901,0.5001,0.5101,0.5201,0.5301,
     . 0.5401,0.5501,0.5601,0.5701,0.5801,0.5901,0.6001,0.6101,0.6201,
     . 0.6301,0.6401,0.6501,0.6601,0.6701,0.6801,0.6901,0.7001,0.7101,
     . 0.7201,0.7301,0.7401,0.7501,0.7601,0.7701,0.7801,0.7901,0.8001,
     . 0.8101,0.8201,0.8301,0.8401,0.8501,0.8601,0.8701,0.8801,0.8901,
     . 0.9001,0.9101,0.9201,0.9301,0.9401,0.9501,0.9601,0.9701,0.9801,
     . 0.9901,1.0001,1.0101,1.0201,1.0301,1.0401,1.0501,1.0601,1.0701,
     . 1.0801,1.0901,1.1001,1.1101,1.1201,1.1301,1.1401,1.1501,1.1601,
     . 1.1701,1.1801,1.1901,1.2001,1.2101,1.2201,1.2301,1.2401,1.2501,
     . 1.2601,1.2701,1.2801,1.2901,1.3001,1.3101,1.3201,1.3301,1.3401,
     . 1.3501,1.3601,1.3701,1.3801,1.3901,1.4001,1.4101,1.4201,1.4301,
     . 1.4401,1.4501,1.4601,1.4701,1.4801,1.4901,1.5001,1.5101,1.5201,
     . 1.5301,1.5401,1.5501,1.5601,1.5701,1.5801,1.5901,1.6001,1.6101,
     . 1.6201,1.6301,1.6401,1.6501,1.6601,1.6701,1.6801,1.6901,1.7001/
      data (xrt(l),l=172,250)/
     . 1.7101,1.7201,1.7301,1.7401,1.7501,1.7601,1.7701,1.7801,1.7901,
     . 1.8001,1.8101,1.8201,1.8301,1.8401,1.8501,1.8601,1.8701,1.8801,
     . 1.8901,1.9001,1.9101,1.9201,1.9301,1.9401,1.9501,1.9601,1.9701,
     . 1.9801,1.9901,2.0001,2.0101,2.0201,2.0301,2.0401,2.0501,2.0601,
     . 2.0701,2.0801,2.0901,2.1001,2.1101,2.1201,2.1301,2.1401,2.1501,
     . 2.1601,2.1701,2.1801,2.1901,2.2001,2.2101,2.2201,2.2301,2.2401,
     . 2.2501,2.2601,2.2701,2.2801,2.2901,2.3001,2.3101,2.3201,2.3301,
     . 2.3401,2.3501,2.3601,2.3701,2.3801,2.3901,2.4001,2.4101,2.4201,
     . 2.4301,2.4401,2.4501,2.4601,2.4701,2.4801,2.4901/
c
      data (yrt(l),l=1,133)/
     . 1.128380,1.126790,1.088790,1.069200,1.049990,1.031020,1.012720,
     . 0.993719,0.975411,0.957327,0.939467,0.921830,0.904416,0.887224,
     . 0.870264,0.853520,0.836978,0.820671,0.805960,0.788712,0.773060,
     . 0.757624,0.742405,0.727394,0.712603,0.698026,0.683659,0.669504,
     . 0.655559,0.641822,0.628292,0.614969,0.601851,0.588936,0.576224,
     . 0.563713,0.551402,0.539288,0.527372,0.515651,0.504123,0.492788,
     . 0.481644,0.470689,0.459921,0.449339,0.438813,0.428727,0.418693,
     . 0.408839,0.399161,0.389660,0.382276,0.371177,0.362193,0.353376,
     . 0.344727,0.336242,0.327921,0.319760,0.311759,0.303916,0.296228,
     . 0.288693,0.281342,0.273786,0.266697,0.260087,0.253292,0.246640,
     . 0.240128,0.233754,0.227516,0.221413,0.215442,0.209602,0.203891,
     . 0.198305,0.192845,0.187508,0.182291,0.177193,0.172213,0.167347,
     . 0.162595,0.157955,0.153423,0.149000,0.144683,0.140469,0.136358,
     . 0.132347,0.128434,0.124619,0.120898,0.117271,0.113735,0.110289,
     . 0.106931,0.103659,0.100472,0.097368,0.094346,0.091403,0.088538,
     . 0.085750,0.083037,0.080397,0.077829,0.075331,0.072902,0.070540,
     . 0.068244,0.066012,0.063844,0.061736,0.059689,0.057701,0.055770,
     . 0.053895,0.052075,0.050308,0.048594,0.046930,0.045317,0.043751,
     . 0.042233,0.040761,0.039334,0.037951,0.036611,0.035316,0.034058/
      data (yrt(l),l=134,250)/
     . 0.032839,0.031659,0.030516,0.029410,0.028339,0.027303,0.026300,
     . 0.025330,0.024392,0.023484,0.022607,0.021759,0.020939,0.020147,
     . 0.019382,0.018643,0.017928,0.017239,0.016573,0.015930,0.015309,
     . 0.014711,0.014133,0.013576,0.013038,0.012520,0.012021,0.011539,
     . 0.011075,0.010627,0.010196,0.009781,0.009381,0.008996,0.008626,
     . 0.008269,0.007925,0.007595,0.007277,0.006972,0.006678,0.006395,
     . 0.006123,0.005862,0.005611,0.005369,0.005138,0.004915,0.004701,
     . 0.004496,0.004299,0.004110,0.003929,0.003755,0.003588,0.003428,
     . 0.003274,0.003127,0.002986,0.002850,0.002721,0.002597,0.002478,
     . 0.002364,0.002255,0.002151,0.002051,0.001955,0.001864,0.001776,
     . 0.001692,0.001612,0.001536,0.001463,0.001393,0.001326,0.001262,
     . 0.001201,0.001143,0.001087,0.001034,0.000984,0.000935,0.000889,
     . 0.000845,0.000803,0.000763,0.000725,0.000689,0.000654,0.000621,
     . 0.000590,0.000560,0.000531,0.000504,0.000478,0.000454,0.000430,
     . 0.000408,0.000387,0.000366,0.000347,0.000329,0.000312,0.000295,
     . 0.000280,0.000265,0.000251,0.000237,0.000224,0.000212,0.000201,
     . 0.000190,0.000180,0.000170,0.000161,0.000152/
     
 
      if (xprofile.lt.xrt(1) .or. xprofile.ge.xrt(250)) then
         vmacro = 0.
         return
      endif

      i = int(100.*xprofile) + 1
      vmacro = (yrt(i+1)-yrt(i))*(xprofile-xrt(i))/(xrt(i+1)-xrt(i)) 
     .         + yrt(i) 


      return
      end



      real*8 function voigt(a,v)                                                
c******************************************************************************
c     This routine calculates the voigt function using the approximations   
c     found in the *new series-astronomy and astrophysics* volume of        
c     landolt-bornstein.    
c******************************************************************************

      implicit real*8 (a-h,o-z)                                                
      a2 = a*a                                                           
      v2 = v*v                                                           
      if(a .eq. 0.) go to 62                                             
      if(a .le. 0.2) go to 50                                            
      if(a.le.1.4 .and. a+v.le.3.2) go to 30                             
c  case 1, a .gt. 1.4 or (a .gt. 0.2 and a+v .gt. 3.2)                   
      u = 1.4142136*(a2 + v2)                                            
      voigt = 0.7978847*a/u*(1.0 + (3.0*v2-a2)/u**2 + (15.0*v2*v2        
     1 -30.0*a2*v2+3.0*a2*a2)/u**4)                                      
      voigt = voigt/1.772454                                             
      return                                                             
30    u=0.979895023-0.962846325*a+0.532770573*a2-0.122727278*a*a2        
31    h0 = dexp(-v2)                                                      
      if(v .ge. 2.4) go to 35                                            
      if(v .ge. 1.3) go to 33                                            
c  case 2,  0.2 .lt. a .le. 1.4 and a+v .le. 3.2                         
      h1=-1.12470432-0.15516677*v+3.28867591*v2-2.34357915*v*v2          
     1 +0.42139162*v2*v2                                                 
      go to 36                                                           
33    h1=-4.48480194+9.39456063*v-6.61487486*v2+1.98919585*v*v2          
     1 -0.2204165*v2*v2                                                  
      go to 36                                                           
35    h1=(0.554153432+0.278711796*v-0.188325687*v2+0.042991293*v*v2      
     1 -0.003278278*v2*v2)/(v2 - 1.5)                                    
36    h2 = (1.0 - 2.0*v2)*h0                                             
      if(a .le. 0.2) go to 52                                            
      h1 = h1 + 1.1283790*h0                                             
      h2p = h2                                                           
      h2 = h2 - h0 + 1.1283790*h1                                        
      h3 = 0.37612635*(1.0-h2p) - 0.6666667*v2*h1 + 1.1283790*h2         
      h4 = 0.6666667*v2*v2*h0 - 0.37612635*h1 + 1.1283790*h3             
      voigt = u*(h0 + h1*a + h2*a2 + h3*a*a2 + h4*a2*a2)                 
      voigt = voigt/1.772454                                             
      return                                                             
c  case 3,  a .le. 0.2 and v .lt. 5.0                                    
50    if(v .ge. 5.0) go to 60                                            
      go to 31                                                           
52    voigt = h0 + h1*a + h2*a2                                          
      voigt = voigt/1.772454                                             
      return                                                             
c  case 4,  a .le. 0.2 and v .ge. 5.0                                    
60    voigt = a/(1.772454*v2)*(1.0 + 1.5/v2 + 3.75/(v2*v2))              
      voigt = voigt/1.772454                                             
      return                                                             
c  case 5, a .eq. 0.0                                                    
62    voigt = exp(-v2)/1.772454                                          
      return                                                             
      end                                                                


      real*8 function wavecalc(point,npt,c)
c*****this routine returns the wavelength of a given channel number
 
      implicit real*8 (a-h,o-z)
      real*4 point 
      real*8 c(9)

      if (c(9) .eq. 1.) go to 20
      if (c(9) .eq. 2.) go to 40
      if (c(9) .eq. 3.) go to 30

c*****no wavelength solution exists
      if (c(1).eq.0. .or. c(2).eq.0.) then
         wavecalc = point

c*****an ordinary polynomial solution
      else
         dn = point
         wavecalc = c(1)+dn*(c(2)+dn*(c(3)+dn*(c(4)+
     .                   dn*(c(5)+dn*c(6)))))
      endif
      return

c*****a Chebyshev polynomial solution
20    xpt = (2.*point-real(npt+1))/real(npt-1)
      wavecalc = c(1) + 
     .           c(2)*xpt + 
     .           c(3)*(2.*xpt**2-1.) +
     .           c(4)*xpt*(4.*xpt**2-3.) + 
     .           c(5)*(8.*xpt**4-8.*xpt**2+1.) +
     .           c(6)*xpt*(16.*xpt**4-20.*xpt**2+5.)
      return

c*****a spline3 solution
30    s = (point-1.)/(real(npt)-1.)*c(8)
      j = int(s)
      a = real(j+1) - s
      b = s - real(j)
      z0 = a**3
      z1 = 1. + 3.*a*(1.+a*b)
      z2 = 1. + 3.*b*(1.+a*b)
      z3 = b**3
      wavecalc = c(j+1)*z0 + c(j+2)*z1 + c(j+3)*z2 + c(j+4)*z3
      return

c*****a Legendre polynomial solution
40    xpt = (2.*point-real(npt+1))/real(npt-1)
      wavecalc = c(1) + c(2)*xpt
      return


      end




